SystemOrganization addCategory: #'Xpf-CodeTalk'!
SystemOrganization addCategory: #'Xpf-CodeTalk-Commands'!
SystemOrganization addCategory: #'Xpf-CodeTalk-Kernel'!
SystemOrganization addCategory: #'Xpf-CodeTalk-Tests'!
SystemOrganization addCategory: #'Xpf-CodeTalk-Morphs'!
SystemOrganization addCategory: #'Xpf-CodeTalk-Models'!
SystemOrganization addCategory: #'Xpf-CodeTalk-Browsers'!
SystemOrganization addCategory: #'Xpf-CodeTalk-Nodes'!
SystemOrganization addCategory: #'Xpf-CodeTalk-Panels'!
SystemOrganization addCategory: #'Xpf-CodeTalk-Filters'!

!OBMonticelloPackageNode methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 13:06'!
hasMarkups

	^ true! !

!OBMonticelloPackageNode methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 14:24'!
markupSourceName

	^ 'mc package "{1}"' format: {self packageName}! !

!OBMonticelloPackageNode methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 13:48'!
referencesForMarkups

	^ (PackageOrganizer default
		packageNamed: self packageName
		ifAbsent: [^ #()]) methods! !

!MCVersion methodsFor: '*xpf-codetalk-override' stamp: 'mt 5/30/2009 17:44'!
load

	MCVersionLoader loadVersion: self.
	
	(Preferences
		preferenceAt: #browseMarkupsAfterLoadMerge
		ifAbsent: [Preference new rawValue: false])
		preferenceValue ifTrue: [ XpfCtMarkupBrowser
			openOn: (OBMonticelloPackageNode on: self package workingCopy)].! !

!MCVersion methodsFor: '*xpf-codetalk-override' stamp: 'mt 5/30/2009 17:44'!
merge

	MCVersionMerger mergeVersion: self.
	
	(Preferences
		preferenceAt: #browseMarkupsAfterLoadMerge
		ifAbsent: [Preference new rawValue: false])
		preferenceValue ifTrue: [ XpfCtMarkupBrowser
			openOn: (OBMonticelloPackageNode on: self package workingCopy)].! !

!OBCmdBrowseImplementors methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 15:34'!
icon

	^ #xpfCtPageCodeIcon! !

!OBCmdBrowseImplementors methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 15:34'!
iconOnly

	^ true! !

!OBCmdBrowseSenders methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 15:28'!
icon

	^ #xpfCtTransmitBlueIcon! !

!OBCodeNode methodsFor: '*xpf-codetalk' stamp: 'mt 6/5/2009 16:07'!
filterAllFor: markupNodes

	^ XpfCtMarkupFilterNode
		named: '-- all{1} --'
		nodes: markupNodes
		description: 'Display all markups in this scope. See the window title to determine the scope.'! !

!OBCodeNode methodsFor: '*xpf-codetalk' stamp: 'mt 6/5/2009 16:07'!
filterForMeFor: markupNodes

	^ XpfCtMarkupFilterNode
		named: '-- for me{1} --'
		nodes: (markupNodes
			select: [:node | node attribute isAuthorMentioned])
		description: 'Display only markups for me in this scope. Those are markups with chat messages which include my initials. See the window title to determine the current scope.'! !

!OBCodeNode methodsFor: '*xpf-codetalk' stamp: 'mt 6/5/2009 16:07'!
filterFromMeFor: markupNodes

	^ XpfCtMarkupFilterNode
		named: '-- mine{1} --'
		nodes: (markupNodes
			select: [:node | node attribute isMine])
		description: 'Display only markups which were created by me in this scope. See the window title to determine the current scope.'! !

!OBCodeNode methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 13:05'!
hasMarkups

	^ false! !

!OBCodeNode methodsFor: '*xpf-codetalk' stamp: 'mt 6/5/2009 16:20'!
isDescendantOfMarkup: anOBCodeNode

	^ false! !

!OBCodeNode methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 17:22'!
isMarkupNode

	^ false! !

!OBCodeNode methodsFor: '*xpf-codetalk' stamp: 'mt 6/5/2009 15:15'!
markupFilters

	| m |
	m := self markups.
	^ {self filterAllFor: m. self filterForMeFor: m. self filterFromMeFor: m}! !

!OBCodeNode methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 12:56'!
markupSourceName
	"Return name of markup source, e.g. package name, class category, ..."

	^ self subclassResponsibility! !

!OBCodeNode methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 13:46'!
markups

	| result |
	result := OrderedCollection new.
	self referencesForMarkups do: [:methodRef |
		(methodRef sourceCode asText attributesOfKind: XpfComplexAttribute) do: [:attr |
			result add: (XpfCtMarkupNode
				forAttribute: attr
				method: methodRef)]].
	^ result! !

!OBCodeNode methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 13:46'!
referencesForMarkups

	^ self subclassResponsibility! !

OBCodeNode subclass: #XpfCtMarkupFilterNode
	instanceVariableNames: 'name description markupNodes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Nodes'!

!XpfCtMarkupFilterNode class methodsFor: 'instance creation' stamp: 'mt 6/5/2009 16:04'!
named: aString nodes: someMarkupNodes

	^ self
		named: aString
		nodes: someMarkupNodes
		description: ''! !

!XpfCtMarkupFilterNode class methodsFor: 'instance creation' stamp: 'mt 6/5/2009 16:03'!
named: aString nodes: someMarkupNodes description: anotherString

	^ self new
		name: aString;
		markupNodes: someMarkupNodes;
		description: anotherString! !

!XpfCtMarkupFilterNode methodsFor: 'accessing' stamp: 'mt 6/5/2009 16:03'!
description

	description ifNil: [self description: ''].
	^ description! !

!XpfCtMarkupFilterNode methodsFor: 'accessing' stamp: 'mt 6/5/2009 16:02'!
description: anObject

	description := anObject.! !

!XpfCtMarkupFilterNode methodsFor: 'testing' stamp: 'mt 6/5/2009 15:05'!
hasMarkups

	^ false! !

!XpfCtMarkupFilterNode methodsFor: 'testing' stamp: 'mt 6/5/2009 15:05'!
hasSelector

	^ false! !

!XpfCtMarkupFilterNode methodsFor: 'testing' stamp: 'mt 6/5/2009 15:05'!
hasVersions

	^ false! !

!XpfCtMarkupFilterNode methodsFor: 'ancestry' stamp: 'mt 6/5/2009 16:24'!
isDescendantOfMarkup: anOBCodeNode

	^ true! !

!XpfCtMarkupFilterNode methodsFor: 'accessing' stamp: 'mt 6/5/2009 14:59'!
markupNodes

	^ markupNodes! !

!XpfCtMarkupFilterNode methodsFor: 'accessing' stamp: 'mt 6/5/2009 14:59'!
markupNodes: anObject

	markupNodes := anObject.! !

!XpfCtMarkupFilterNode methodsFor: 'navigation' stamp: 'mt 6/5/2009 15:03'!
markupsByChatSize

	| result groups actualGroup |
	result := OrderedCollection new.
	groups := {
		25 -> '25+ posts'.
		10 -> '10-24 posts'.
		5 -> '5-9 posts'.
		1 -> '1-4 posts'.
		0 -> '(no posts)'}.
	
	self sortMarkupsByChatSize do: [:node | |g|
		g := groups detect: [:s | node attribute chat size >= s key].
		actualGroup = g key ifFalse: [
			result add: (XpfCtSeparatorNode text: g value)].
		actualGroup := g key.
		result add: node].
	^ result! !

!XpfCtMarkupFilterNode methodsFor: 'navigation' stamp: 'mt 6/5/2009 15:03'!
markupsByCreationTime

	| result lastDate |
	result := OrderedCollection new.
	self sortMarkupsByCreationTime do: [:node | |d|
			d := node attribute timestamp date.
			lastDate = d ifFalse: [
				result add: (XpfCtSeparatorNode text: d printRelativeDate)].
			lastDate := d.
			result add: node].
	^ result! !

!XpfCtMarkupFilterNode methodsFor: 'navigation' stamp: 'mt 6/5/2009 15:03'!
markupsByLastActivity

	| result lastDate |
	result := OrderedCollection new.
	self sortMarkupsByLastActivity do: [:node | |d|
			d := node attribute chat
				ifEmpty: [node attribute timestamp date]
				ifNotEmpty: [(node attribute chat last at: #timestamp) date].
			lastDate = d ifFalse: [
				result add: (XpfCtSeparatorNode text: d printRelativeDate)].
			lastDate := d.
			result add: node].
	^ result! !

!XpfCtMarkupFilterNode methodsFor: 'navigation' stamp: 'mt 6/5/2009 15:03'!
markupsByTag

	| result lastTag |
	result := OrderedCollection new.
	self sortMarkupsByTag do: [:node | |t|
			t := node attribute tag.
			lastTag = t ifFalse: [
				result add: (XpfCtSeparatorNode text: ('#{1}' format: {t}))].
			lastTag := t.
			result add: node].
	^ result! !

!XpfCtMarkupFilterNode methodsFor: 'accessing' stamp: 'mt 6/5/2009 16:09'!
name
	"Use the usual placeholder to display the number of nodes."
	
	^ name format: {' (', self markupNodes size asString, ')'}! !

!XpfCtMarkupFilterNode methodsFor: 'accessing' stamp: 'mt 6/5/2009 14:58'!
name: anObject

	name := anObject.! !

!XpfCtMarkupFilterNode methodsFor: 'sorting' stamp: 'mt 6/5/2009 15:02'!
sortMarkupsByChatSize

	^ self markupNodes sortBy: [:n1 :n2 | 
		n1 attribute chat size > n2 attribute chat size]! !

!XpfCtMarkupFilterNode methodsFor: 'sorting' stamp: 'mt 6/5/2009 15:02'!
sortMarkupsByCreationTime

	^ self markupNodes sortBy: [:n1 :n2 |
		n1 attribute timestamp > n2 attribute timestamp]! !

!XpfCtMarkupFilterNode methodsFor: 'sorting' stamp: 'mt 6/5/2009 15:03'!
sortMarkupsByLastActivity

	^ self markupNodes sortBy: [:n1 :n2 | |t1 t2|
		t1 := n1 attribute chat
			ifEmpty: [n1 attribute timestamp]
			ifNotEmpty: [n1 attribute chat last at: #timestamp].
		t2 := n2 attribute chat
			ifEmpty: [n2 attribute timestamp]
			ifNotEmpty: [n2 attribute chat last at: #timestamp].
		t1 > t2]! !

!XpfCtMarkupFilterNode methodsFor: 'sorting' stamp: 'mt 6/5/2009 15:03'!
sortMarkupsByTag

	^ self markupNodes sortBy: [:n1 :n2 |
		n1 attribute tag asString < n2 attribute tag asString]! !

!XpfCtMarkupFilterNode methodsFor: 'public' stamp: 'mt 6/5/2009 18:24'!
text

	| txt |
	txt := self description asText.
	txt addAttribute: (TextColor color: Color gray muchDarker).
	^ txt! !

OBCodeNode subclass: #XpfCtMarkupNode
	instanceVariableNames: 'attribute method snippet'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Nodes'!

!XpfCtMarkupNode class methodsFor: 'instance creation' stamp: 'mt 5/30/2009 10:42'!
forAttribute: aComplexAttribute method: aMethodReference

	^ self new
		attribute: aComplexAttribute;
		method: aMethodReference! !

!XpfCtMarkupNode methodsFor: 'accessing' stamp: 'mt 5/30/2009 10:25'!
attribute

	^ attribute! !

!XpfCtMarkupNode methodsFor: 'accessing' stamp: 'mt 5/30/2009 10:25'!
attribute: anObject

	attribute := anObject.! !

!XpfCtMarkupNode methodsFor: 'public' stamp: 'mt 5/30/2009 17:29'!
browse

	OBCodeBrowser defaultBrowserClass
		openOnClass: self method actualClass
		selector: self method methodSymbol.! !

!XpfCtMarkupNode methodsFor: 'public' stamp: 'mt 6/6/2009 08:52'!
chatMessageFor: aChatLine

	^ self txtChatMessageFor: ('"{1}"'
		format: {aChatLine at: #message}).! !

!XpfCtMarkupNode methodsFor: 'public' stamp: 'mt 6/6/2009 08:51'!
chatStampFor: aChatLine

	| txt |
	txt := self txtChatStampFor: ('{1} - {2}' format: {
		(aChatLine at: #timestamp) printRelativeTimeStamp.
		(aChatLine at: #author)}).
		
	(aChatLine at: #author) = Utilities authorInitials
		ifTrue: [txt append: (self txtHeadFor: ' (You!!)')].

	^ txt! !

!XpfCtMarkupNode methodsFor: 'public' stamp: 'mt 6/6/2009 08:55'!
creatorFor: aCreatorString

	| txt |
	txt := self txtValueFor: aCreatorString.
		
	self attribute isMine
		ifTrue: [txt append: (self txtHeadFor: ' (You!!)')].

	^ txt! !

!XpfCtMarkupNode methodsFor: 'testing' stamp: 'mt 5/30/2009 17:17'!
hasMarkups

	^ false! !

!XpfCtMarkupNode methodsFor: 'testing' stamp: 'mt 5/30/2009 10:26'!
hasSelector

	^ false! !

!XpfCtMarkupNode methodsFor: 'testing' stamp: 'mt 5/30/2009 10:26'!
hasVersions

	^ false! !

!XpfCtMarkupNode methodsFor: 'testing' stamp: 'mt 5/30/2009 17:22'!
isMarkupNode

	^ true! !

!XpfCtMarkupNode methodsFor: 'accessing' stamp: 'mt 5/30/2009 10:41'!
method

	^ method! !

!XpfCtMarkupNode methodsFor: 'accessing' stamp: 'mt 5/30/2009 10:42'!
method: aMethodReference

	method := aMethodReference.! !

!XpfCtMarkupNode methodsFor: 'public' stamp: 'mt 6/2/2009 18:11'!
name

	| result |
	attribute ifNil: [^ '(no attribute)'].
	result := ('{1}>>{2} (#{3})' format: {
		self method theClassName.
		self method methodSymbol.
		self attribute tag}) asText.
	self attribute wasRead ifTrue: [
		result addAttribute: TextColor gray].
	^ result	! !

!XpfCtMarkupNode methodsFor: 'accessing' stamp: 'mt 5/30/2009 11:19'!
snippet

	^ snippet! !

!XpfCtMarkupNode methodsFor: 'accessing' stamp: 'mt 5/30/2009 11:19'!
snippet: anObject

	snippet := anObject.! !

!XpfCtMarkupNode methodsFor: 'public' stamp: 'mt 6/6/2009 08:55'!
text

	| txt |
	txt := '' asText.
	txt
		append: (self txtHeadFor: 'Creator    ');
		append: (self creatorFor: self attribute creator);
		append: String cr asText;
		append: (self txtHeadFor: 'Timestamp  ');
		append: (self txtValueFor: self attribute timestamp printRelativeTimeStamp, String cr);
		append: (self txtHeadFor: 'Tag        ');
		append: (self txtValueFor: '#', self attribute tag, String cr);
		append: (self txtHeadFor: 'Method     ');
		append: (self txtMethodLinkFor: (self txtValueFor: ('{1}>>{2}' format: {self method theClassName. self method methodSymbol}), String cr));
		append: (self txtHeadFor: 'Comment   ');
		append: (self txtCommentFor: ('"{1}"' format: {self attribute comment}), String cr);
		append: (self txtSeparator: 50).

	(self attribute chat sortBy: [:line1 :line2 | (line1 at: #timestamp) > (line2 at: #timestamp)])
		do: [:line |
			txt
				append: (String cr, String cr) asText;
				append: (self chatStampFor: line);
				append: String cr asText;
				append: (self chatMessageFor: line)].
	
	self attribute read.
	^ txt! !

!XpfCtMarkupNode methodsFor: 'formatting' stamp: 'mt 6/6/2009 08:46'!
txtChatMessageFor: aString

	^ XpfCodeTalk highlightAuthorInitialsFor:
		(self txtMethodLinkFor: (Text string: aString attribute: TextColor black))! !

!XpfCtMarkupNode methodsFor: 'formatting' stamp: 'mt 6/6/2009 08:55'!
txtChatStampFor: aString

	^ Text string: aString attributes: {TextColor black. TextEmphasis bold}! !

!XpfCtMarkupNode methodsFor: 'formatting' stamp: 'mt 6/6/2009 08:20'!
txtCommentFor: aString

	^ Text string: aString attributes: {TextColor color: Color green muchDarker}! !

!XpfCtMarkupNode methodsFor: 'formatting' stamp: 'mt 6/6/2009 08:19'!
txtHeadFor: aString

	^ Text string: aString attribute: TextColor gray! !

!XpfCtMarkupNode methodsFor: 'formatting' stamp: 'mt 6/6/2009 08:34'!
txtMethodLinkFor: aTextOrString

	^ XpfCtMethodLink addMethodLinksInto: aTextOrString asText! !

!XpfCtMarkupNode methodsFor: 'formatting' stamp: 'mt 6/6/2009 08:26'!
txtSeparator: width

	^ Text
		string: ((String new: width) atAllPut: Character space)
		attributes: {TextColor gray. TextEmphasis struckOut}! !

!XpfCtMarkupNode methodsFor: 'formatting' stamp: 'mt 6/6/2009 08:20'!
txtValueFor: aString

	^ Text string: aString attributes: {TextColor black. TextEmphasis bold}! !

OBCodeNode subclass: #XpfCtSeparatorNode
	instanceVariableNames: 'text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Nodes'!

!XpfCtSeparatorNode class methodsFor: 'instance creation' stamp: 'mt 5/25/2009 14:15'!
text: aString

	^ self new
		text: aString! !

!XpfCtSeparatorNode methodsFor: 'testing' stamp: 'mt 5/25/2009 14:47'!
isSeparatorNode

	^ true! !

!XpfCtSeparatorNode methodsFor: 'public' stamp: 'mt 5/25/2009 14:48'!
name

	^ text asText allBold! !

!XpfCtSeparatorNode methodsFor: 'accessing' stamp: 'mt 5/25/2009 14:15'!
text

	^ text! !

!XpfCtSeparatorNode methodsFor: 'accessing' stamp: 'mt 5/25/2009 14:14'!
text: anObject

	text := anObject.! !

!DataStream methodsFor: '*xpf-codetalk' stamp: 'mt 3/24/2009 15:43'!
references

    ^ Dictionary new! !

!OBMorphBuilder methodsFor: '*xpf-codetalk' stamp: 'mt 5/27/2009 10:06'!
insertMorph: aMorph

	current ifNotNil: 
			[current addMorphBack: aMorph.
			self current: aMorph do: []].
	^ aMorph! !

!OBMorphBuilder methodsFor: '*xpf-codetalk' stamp: 'mt 6/5/2009 15:52'!
specialScroller: aColumnPanel with: aBlock 
	| morph |
	morph := (XpfCtPaneScroller withModel: aColumnPanel)
				name: 'scroller';
				vResizing: #spaceFill;
				hResizing: #spaceFill;
				yourself.
	current ifNotNil: [current addMorphBack: morph].
	^self current: morph do: aBlock! !

TestCase subclass: #XpfCtComplexAttributeTest
	instanceVariableNames: 'sut sut2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Tests'!

!XpfCtComplexAttributeTest methodsFor: 'running' stamp: 'mt 5/28/2009 19:19'!
setUp

	super setUp.
	sut := XpfComplexAttribute forTag: #bad.
	sut
		addChatLine: 'She sells sea shells at the sea shore.';
		creator: Utilities authorInitials, 'test'.
	sut2 := XpfComplexAttribute forTag: #comment.
	sut2 comment: 'This is just a comment'.! !

!XpfCtComplexAttributeTest methodsFor: 'tests' stamp: 'mt 5/28/2009 12:10'!
testInstanceCreation

	self
		should: sut tag = #bad;
		should: sut creator = (Utilities authorInitials, 'test');
		should: sut chat size = 1;
		should: (sut chat first at: #author) = Utilities authorInitials;
		should: sut timestamp <= (sut chat first at: #timestamp)! !

!XpfCtComplexAttributeTest methodsFor: 'tests' stamp: 'mt 6/2/2009 17:59'!
testReading

	XpfComplexAttribute reset. "Clear read cache."
	self
		shouldnt: (XpfComplexAttribute wasRead: sut);
		shouldnt: (XpfComplexAttribute wasRead: sut2).
	XpfComplexAttribute read: sut.
	self
		should: (XpfComplexAttribute wasRead: sut);
		shouldnt: (XpfComplexAttribute wasRead: sut2).
	self
		shouldnt: [XpfComplexAttribute
			read: sut;
			read: sut] raise: Error.! !

!XpfCtComplexAttributeTest methodsFor: 'tests' stamp: 'mt 5/2/2009 15:35'!
testScanning

	| stream attr |
	stream := (String new: 500) writeStream.
	sut writeScanOn: stream.
	attr := XpfComplexAttribute scanFrom:
		(stream contents readStream position: 1). "Skip first 'h' to identify complex attribute. See RunArray class>>scanFrom:"
	
	self
		should: sut tag = attr tag;
		should: sut timestamp = attr timestamp;
		should: sut creator = attr creator;
		should: sut chat size = attr chat size;
		should: (sut chat first at: #author) = (attr chat first at: #author);
		should: (sut chat first at: #timestamp) = (attr chat first at: #timestamp);
		should: (sut chat first at: #message) = (attr chat first at: #message)! !

!XpfCtComplexAttributeTest methodsFor: 'tests' stamp: 'mt 5/28/2009 19:22'!
testScanningComments

	| stream attr |
	stream := (String new: 500) writeStream.
	sut2 writeScanOn: stream.
	attr := XpfComplexAttribute scanFrom:
		(stream contents readStream position: 1). "Skip first 'h' to identify complex attribute. See RunArray class>>scanFrom:"
	
	self
		should: sut2 tag = attr tag;
		should: sut2 comment = attr comment.! !

!XpfCtComplexAttributeTest methodsFor: 'tests' stamp: 'mt 5/18/2009 10:31'!
testTagAcccessing

	self should: sut tag = #bad.
	sut tag: #'0'.
	self should: sut tag isNil.
	sut tag: #talk.
	self should: sut tag = #talk.
	sut tag: #shouldNotBeAllowed.
	self should: sut tag isNil.! !

TestCase subclass: #XpfCtMonticelloTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Tests'!

!XpfCtMonticelloTest class methodsFor: 'marking' stamp: 'cs 5/4/2009 02:05'!
markCollection: anAttribute

	| source ref |
	ref := MethodReference class: Collection selector: #do:.
	source := ref sourceCode.
	(source attributesOfKind: XpfComplexAttribute)
		do: [:att | source removeAttribute: att ].
	source addAttribute: anAttribute from: 1 to: 1.
	Collection compile: source classified: ref category.
	^ ref! !

!XpfCtMonticelloTest class methodsFor: 'marking' stamp: 'mt 5/5/2009 15:05'!
markCollectionDoBad
	^ self markCollection: (XpfComplexAttribute forTag: #bad)! !

!XpfCtMonticelloTest class methodsFor: 'marking' stamp: 'cs 5/2/2009 12:58'!
markCollectionDoNormal

	| source ref |
	ref := MethodReference class: Collection selector: #do:.
	source := ref sourceCode.
	Collection compile: source asString classified: ref category.
	^ ref! !

!XpfCtMonticelloTest methodsFor: 'tests' stamp: 'mt 5/5/2009 15:05'!
testAddCodeMarkup
	| ref source md snapshotBin md2 color |
	ref := self class markCollectionDoBad.
	source := ref sourceCode.
	color := ((source attributesAt: 1) detect: [ :attr | attr isKindOf: XpfComplexAttribute ]) color.
	md := (Collection compiledMethodAt: #do:) methodReference asMethodDefinition.
	snapshotBin := MCMczWriter new serializeInBinary: (MCSnapshot fromDefinitions: {  md  }).
	md2 := (DataStream on: ((RWBinaryOrTextStream with: snapshotBin)
			reset;
			yourself)) next definitions first.
	self
		should: md2 source isString;
		should: md2 sourceText isText;
		should: md source = md2 source;
		should: ((md2 sourceText attributesAt: 1) anySatisfy: [ :attr | (attr isKindOf: XpfComplexAttribute) and: [ attr color = color ] ]).

	"Clean up"
	self class markCollectionDoNormal! !

!XpfCtMonticelloTest methodsFor: 'tests' stamp: 'mt 4/20/2009 16:17'!
testDefinitionFromReference

	| ref cm md |
	ref := MethodReference class: Collection selector: #do:.
	cm := Collection compiledMethodAt: #do:.
	md := ref asMethodDefinition.
	
	self
		should: cm getSource = ref sourceCode;
		should: ref sourceCode isText;
		should: ref source isString;
		should: md source isString;
		should: md sourceText isText.! !

TestCase subclass: #XpfCtTagSearchTest
	instanceVariableNames: 'sut badText att'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Tests'!

!XpfCtTagSearchTest methodsFor: 'helping' stamp: 'mt 5/5/2009 15:08'!
searchCollection: aBlock

	| helper |
	helper := XpfCtTagSearchHelper new.
	helper matchAttributeBad.
	aBlock value: helper.
	helper searchClass: Collection.
	^ helper results! !

!XpfCtTagSearchTest methodsFor: 'running' stamp: 'mt 5/5/2009 15:06'!
setUp

	super setUp.
	badText := 'int main(int argc, char** args) {printf("%s\n", args[0]);}' asText.
	att := XpfComplexAttribute forTag: #bad.
	badText 
		addAttribute: att
		from: 10
		to: 15.
	sut := XpfCtTagSearchHelper new.
	XpfCtMonticelloTest markCollectionDoBad.! !

!XpfCtTagSearchTest methodsFor: 'running' stamp: 'cs 5/2/2009 16:39'!
tearDown

	super tearDown.
	XpfCtMonticelloTest markCollectionDoNormal.! !

!XpfCtTagSearchTest methodsFor: 'testing' stamp: 'cs 5/2/2009 16:37'!
testBadCode

	sut matchAttributeBad.
	self should: (sut searchText: badText).! !

!XpfCtTagSearchTest methodsFor: 'testing' stamp: 'mt 5/5/2009 15:08'!
testCreator

	XpfCtMonticelloTest markCollection: (XpfComplexAttribute forTag: #bad).
	self
		should:   (self searchCollection: [:helper |
			helper matchCreator: Utilities authorInitials, 'X']) isEmpty;
		shouldnt: (self searchCollection: [:helper |
			helper matchCreator: Utilities authorInitials]) isEmpty.! !

!XpfCtTagSearchTest methodsFor: 'testing' stamp: 'mt 5/5/2009 15:08'!
testKeyword

	XpfCtMonticelloTest markCollection:
		((XpfComplexAttribute forTag: #bad) addChatLine: 'this is a test').
	self
		should:   (self searchCollection: [:helper | helper matchKeyword: 'tis']) isEmpty;
		shouldnt: (self searchCollection: [:helper | helper matchKeyword: 'tes']) isEmpty.! !

!XpfCtTagSearchTest methodsFor: 'testing' stamp: 'mt 5/5/2009 15:08'!
testSearchMethodCategory

	sut matchAttributeBad.
	self should: sut results isEmpty.
	sut searchCategory: 'Collections'.
	self
		shouldnt: sut results isEmpty;
		should: (sut results anySatisfy: [:ref |
			ref classIsMeta not &
			(ref classSymbol = #Collection) &
			(ref methodSymbol = #do:)]).! !

!XpfCtTagSearchTest methodsFor: 'testing' stamp: 'mt 5/5/2009 15:08'!
testSearchMethodClass

	sut matchAttributeBad.
	self should: sut results isEmpty.
	sut searchClass: Collection.
	self
		should: sut results size = 1;
		shouldnt: sut results first classIsMeta;
		should: sut results first classSymbol = #Collection;
		should: sut results first methodSymbol = #do:.! !

!XpfCtTagSearchTest methodsFor: 'testing' stamp: 'mt 5/5/2009 21:50'!
testSearchMethodGlobal

	sut matchAttributeBad.
	self should: sut results isEmpty.
	
	sut searchGlobal.
	
	self
		shouldnt: sut results isEmpty;
		should: (sut results anySatisfy: [:ref |
			ref classIsMeta not &
			(ref classSymbol = #Collection) &
			(ref methodSymbol = #do:)]).! !

!XpfCtTagSearchTest methodsFor: 'testing' stamp: 'mt 5/5/2009 15:09'!
testTimeLastMonth

	XpfCtMonticelloTest markCollection:
		((XpfComplexAttribute forTag: #bad) timestamp:
			TimeStamp now asDate onPreviousMonth asTimeStamp).
	self
		should:   (self searchCollection: [:helper | helper matchTime: #today]) isEmpty;
		should:   (self searchCollection: [:helper | helper matchTime: #yesterday]) isEmpty;
		should:   (self searchCollection: [:helper | helper matchTime: #thisWeek]) isEmpty;
		should:   (self searchCollection: [:helper | helper matchTime: #lastWeek]) isEmpty;
		should:   (self searchCollection: [:helper | helper matchTime: #thisMonth]) isEmpty;
		shouldnt: (self searchCollection: [:helper | helper matchTime: #lastMonth]) isEmpty.! !

!XpfCtTagSearchTest methodsFor: 'testing' stamp: 'mt 5/5/2009 15:09'!
testTimeToday

	XpfCtMonticelloTest markCollection:
		((XpfComplexAttribute forTag: #bad) timestamp: TimeStamp now).
	self
		shouldnt: (self searchCollection: [:helper | helper matchTime: #today]) isEmpty;
		should:   (self searchCollection: [:helper | helper matchTime: #yesterday]) isEmpty;
		shouldnt: (self searchCollection: [:helper | helper matchTime: #thisWeek]) isEmpty;
		should:   (self searchCollection: [:helper | helper matchTime: #lastWeek]) isEmpty;
		shouldnt: (self searchCollection: [:helper | helper matchTime: #thisMonth]) isEmpty;
		should:   (self searchCollection: [:helper | helper matchTime: #lastMonth]) isEmpty.! !

!XpfCtTagSearchTest methodsFor: 'testing' stamp: 'mt 5/5/2009 15:09'!
testTimeYesterday

	XpfCtMonticelloTest markCollection:
		((XpfComplexAttribute forTag: #bad) timestamp: TimeStamp now - (Duration days: 1)).
	self should:   (self searchCollection: [:helper | helper matchTime: #today]) isEmpty.
	self shouldnt: (self searchCollection: [:helper | helper matchTime: #yesterday]) isEmpty.
	TimeStamp now dayOfWeekName = Week startDay ifTrue: [
		self should:   (self searchCollection: [:helper | helper matchTime: #thisWeek]) isEmpty.
		self shouldnt: (self searchCollection: [:helper | helper matchTime: #lastWeek]) isEmpty]
	ifFalse: [
		self shouldnt: (self searchCollection: [:helper | helper matchTime: #thisWeek]) isEmpty.
		self should:   (self searchCollection: [:helper | helper matchTime: #lastWeek]) isEmpty].
	TimeStamp now day = 1 ifTrue: [
		self should:   (self searchCollection: [:helper | helper matchTime: #thisMonth]) isEmpty.
		self shouldnt: (self searchCollection: [:helper | helper matchTime: #lastMonth]) isEmpty]
	ifFalse: [
		self shouldnt: (self searchCollection: [:helper | helper matchTime: #thisMonth]) isEmpty.
		self should:   (self searchCollection: [:helper | helper matchTime: #lastMonth]) isEmpty].! !

TestCase subclass: #XpfCtTextTest
	instanceVariableNames: 'sut att1 att2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Tests'!

!XpfCtTextTest methodsFor: 'running' stamp: 'mt 5/5/2009 15:06'!
setUp
	
	super setUp.
	
	sut := 'The quick brown fox jumps over the lazy dog.' asText.
	att1 := XpfComplexAttribute forTag: #talk.
	att2 := XpfComplexAttribute forTag: #bad.! !

!XpfCtTextTest methodsFor: 'tests' stamp: 'mt 5/2/2009 10:19'!
testAttributesOfKind

	| atts |
	sut addAttribute: att1 from: 1 to: 5.
	sut addAttribute: att2 from: 6 to: 10.
	
	atts := sut attributesOfKind: att1 class.
	
	self
		should: atts size = 2;
		should: atts first == att1;
		should: atts second == att2.! !

!XpfCtTextTest methodsFor: 'tests' stamp: 'mt 5/18/2009 11:14'!
testAttributesOfKindFromTo

	| atts1 atts2 atts3 atts4 atts5 |
	sut addAttribute: att1 from: 1 to: 5.
	sut addAttribute: att2 from: 6 to: 10.
	
	atts1 := sut attributesOfKind: att1 class from: 1 to: 5.
	atts2 := sut attributesOfKind: att2 class from: 6 to: 10.
	atts3 := sut attributesOfKind: att1 class from: 1 to: 10.
	atts4 := sut attributesOfKind: att1 class from: 5 to: 5.
	atts5 := sut attributesOfKind: att1 class from: 5 to: 4.
	
	self
		should: atts1 size = 1;
		should: atts2 size = 1;
		should: atts3 size = 2;
		should: atts4 size = 1;
		should: atts5 size = 1;
		should: atts1 first == att1;
		should: atts2 first == att2;
		should: atts3 first == att1;
		should: atts3 second == att2;
		should: atts4 first == att1;
		should: atts5 first == att1.! !

!XpfCtTextTest methodsFor: 'tests' stamp: 'mt 5/2/2009 10:24'!
testIncludesAttributesOfKind

	sut addAttribute: att1 from: 1 to: 1.
	self should: (sut includesAttributesOfKind: att1 class).! !

!XpfCtTextTest methodsFor: 'tests' stamp: 'mt 5/3/2009 18:35'!
testIncludesAttributesOfKindFromTo

	sut addAttribute: att1 from: 1 to: 2.
	self
		should: (sut includesAttributesOfKind: att1 class from: 1 to: 2);
		shouldnt: (sut includesAttributesOfKind: att1 class from: 3 to: 4).! !

!XpfCtTextTest methodsFor: 'tests' stamp: 'mt 5/2/2009 10:27'!
testRemoveAttribute

	sut addAttribute: att1 from: 1 to: 5.
	sut addAttribute: att2 from: 6 to: 10.
	sut removeAttribute: att1.
		
	self
		should: (sut includesAttributesOfKind: att1 class);
		shouldnt: ((sut attributesOfKind: att1 class) includes: att1);
		should: ((sut attributesOfKind: att1 class) includes: att2).! !

!XpfCtTextTest methodsFor: 'tests' stamp: 'mt 5/2/2009 10:28'!
testRemoveAttributeAround

	sut addAttribute: att1 from: 1 to: 5.
	sut addAttribute: att2 from: 6 to: 10.
	sut removeAttribute: att1 around: 5.
	sut removeAttribute: att2 around: 5.
		
	self
		should: (sut includesAttributesOfKind: att1 class);
		shouldnt: ((sut attributesOfKind: att1 class) includes: att1);
		should: ((sut attributesOfKind: att1 class) includes: att2).! !

!XpfCtTextTest methodsFor: 'tests' stamp: 'mt 5/2/2009 10:30'!
testRemoveAttributeAroundAnd

	sut addAttribute: att1 from: 1 to: 5.
	sut addAttribute: att2 from: 6 to: 10.
	sut removeAttribute: att1 around: 4 and: 6.
		
	self
		should: (sut includesAttributesOfKind: att1 class);
		shouldnt: ((sut attributesOfKind: att1 class) includes: att1);
		should: ((sut attributesOfKind: att1 class) includes: att2).! !

!XpfCtTextTest methodsFor: 'tests' stamp: 'mt 5/2/2009 10:32'!
testRemoveAttributeFromTo

	sut addAttribute: att1 from: 1 to: 5.
	sut addAttribute: att2 from: 6 to: 10.
	sut removeAttribute: att1 from: 1 to: 5.
	sut removeAttribute: att2 from: 6 to: 9.
		
	self
		should: (sut includesAttributesOfKind: att1 class);
		shouldnt: ((sut attributesOfKind: att1 class) includes: att1);
		should: ((sut attributesOfKind: att1 class) includes: att2).! !

!OBButtonModel class methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 17:08'!
withLabel: aString inBar: aRadioButtonBar longDescription: aToolTip icon: aSymbol

	^ self new
		label: aString;
		bar: aRadioButtonBar;
		longDescription: aToolTip;
		icon: aSymbol! !

!OBButtonModel methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 17:04'!
icon

	^ icon! !

!OBButtonModel methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 16:58'!
icon: aMorph

	icon := aMorph.! !

!OBButtonModel methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 17:03'!
iconOnly

	iconOnly ifNil: [self iconOnly: false].
	^ iconOnly! !

!OBButtonModel methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 17:03'!
iconOnly: aBoolean

	iconOnly := aBoolean.! !

!OBButtonModel methodsFor: '*xpf-codetalk-override' stamp: 'mt 5/30/2009 17:04'!
labelMorph
	
	| morph lm |
	(Smalltalk classNamed: #UITheme) ifNotNilDo: [:uit |
		morph := uit current buttonLabelForText: label].
	
	morph ifNil: [morph := (StringMorph 
		contents: label
		font: TextStyle defaultFont).
		(label isText and: [label hasColor]) ifFalse: [morph color: (self isEnabled ifTrue: [Color black] ifFalse: [Color gray])]].
	
	self icon ifNil: [^ morph].
	self iconOnly ifTrue: [^ (MenuIcons perform: self icon) asMorph].
	
	lm := PanelMorph new
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		fillStyle: Color transparent; "non pane color tracking"
		changeTableLayout;
		listDirection: #leftToRight;
		cellInset: 2.
	
	lm
		addMorphBack: (MenuIcons perform: self icon) asMorph;
		addMorphBack: morph.
	
	^ lm! !

PanelMorph subclass: #XpfCtMessageMorph
	instanceVariableNames: 'timestamp author message'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Morphs'!

!XpfCtMessageMorph class methodsFor: 'instance creation' stamp: 'mt 5/3/2009 10:53'!
timestamp: aTimeStamp author: aString message: messageString

	^ self new
		author: aString;
		timestampContent: aTimeStamp;
		messageContent: messageString! !

!XpfCtMessageMorph methodsFor: 'accessing' stamp: 'mt 4/30/2009 09:03'!
author

	author ifNil: [author := ''].
	^ author! !

!XpfCtMessageMorph methodsFor: 'accessing' stamp: 'mt 4/30/2009 09:04'!
author: aString

	author := aString! !

!XpfCtMessageMorph methodsFor: 'accessing' stamp: 'mt 5/3/2009 14:28'!
highlightIf: aString
	"Change backgroundcolor if the string is in the message."
	
	(self message contents asString asLowercase includesSubString: aString asLowercase)
		ifTrue: [self color: Color yellow].! !

!XpfCtMessageMorph methodsFor: 'initialization' stamp: 'mt 5/2/2009 18:04'!
initialize

	super initialize.
	self
		changeTableLayout;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		listDirection: #topToBottom;
		borderWidth: 0;
		layoutInset: 2;
		cellInset: 0;
		fillStyle: Color white;
		width: XpfCtCodeChatMorph defaultExtent x;
		initializeUserInterface.! !

!XpfCtMessageMorph methodsFor: 'initialization' stamp: 'mt 4/30/2009 09:04'!
initializeUserInterface

	self
		addMorphBack: self timestamp;
		addMorphBack: self message.! !

!XpfCtMessageMorph methodsFor: 'accessing' stamp: 'mt 6/4/2009 16:36'!
message

	message ifNil: [message := TextMorph new
		hResizing: #spaceFill;
		vResizing: #rigid].
	^ message! !

!XpfCtMessageMorph methodsFor: 'accessing' stamp: 'mt 6/6/2009 08:44'!
messageContent: aString

	self message contentsWrapped: aString asText.
	self message font: (XpfClient sansFontAt: 10).
	XpfCtMethodLink addMethodLinksInto: self message contents.
	XpfCodeTalk highlightAuthorInitialsFor: self message contents.! !

!XpfCtMessageMorph methodsFor: 'accessing' stamp: 'mt 6/5/2009 14:27'!
parseAuthorInitials

	| rx s strm links |
	rx := ('\\<{1}\\>' format: {Utilities authorInitials}) asRegex.
	s := self message contents asString.
	strm := s readStream.
	links := OrderedCollection new.
	
	[rx searchStream: strm]
		whileTrue: [
			links add: {
				rx subBeginning: 1.
				rx subEnd: 1}].

	links do: [:link |
		self message contents
			addAttribute: TextColor red
			from: link first + 1
			to: link second].! !

!XpfCtMessageMorph methodsFor: 'accessing' stamp: 'mt 4/30/2009 09:24'!
timestamp

	timestamp ifNil: [timestamp := TextMorph new
		hResizing: #spaceFill;
		vResizing: #rigid;
		lock].
	^ timestamp! !

!XpfCtMessageMorph methodsFor: 'accessing' stamp: 'mt 5/3/2009 10:52'!
timestampContent: aTimeStamp
	"Add the given timestamp and the authors initials to the text entry."
	
	| text |
	text := '{1} - {2}:' format: {aTimeStamp printRelativeTimeStamp. self author}.
	self timestamp contents: text.
	self timestamp font: ((XpfClient sansFontAt: 8) emphasized: (TextEmphasis bold emphasisCode)).
	! !

PanelMorph subclass: #XpfCtRowMorph
	instanceVariableNames: 'lastPosition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Kernel'!

!XpfCtRowMorph class methodsFor: 'as yet unclassified' stamp: 'mt 5/1/2009 17:18'!
for: someMorphs

	| instance |
	instance := self new.
	someMorphs do: [:m | instance addMorphBack: m].
	^ instance! !

!XpfCtRowMorph methodsFor: 'accessing' stamp: 'mt 5/2/2009 14:12'!
initialize

	super initialize.
	self
		changeTableLayout;
		listDirection: #leftToRight;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		layoutInset: 3;
		useRoundedCorners;
		cellInset: 3;
		color: (Color r: 4 g: 133 b: 157 alpha: 0.9).! !

!XpfCtRowMorph methodsFor: 'accessing' stamp: 'mt 5/2/2009 14:12'!
position: aPoint

	aPoint = lastPosition ifTrue: [^ self].
	lastPosition := aPoint.
	super position: aPoint.! !

OBPanel subclass: #XpfCtProgressPanel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Panels'!

!XpfCtProgressPanel methodsFor: 'as yet unclassified' stamp: 'mt 6/3/2009 10:27'!
buildOn: aBuilder

	| bar button row |
	bar := (XpfCtPluggableProgressBarMorph
		newFor: self browser root metaNode filters first inspector
		value: #currentStep
		max: #maxSteps)
		hResizing: #spaceFill;
		vResizing: #spaceFill.
	button := XpfCtButton
		on: self browser root metaNode filters first inspector
		action: #stop
		icon: #xpfCtCrossIcon
		label: 'Stop'.
	row := PanelMorph new
		changeTableLayout;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		listDirection: #leftToRight;
		addMorphBack: bar;
		addMorphBack: button.
		
	^ aBuilder insertMorph: row.! !

!XpfCtProgressPanel methodsFor: 'as yet unclassified' stamp: 'mt 5/30/2009 18:34'!
vResizing

	^ #rigid! !

OBPanel subclass: #XpfCtToolbar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Panels'!

!XpfCtToolbar methodsFor: 'actions' stamp: 'mt 5/30/2009 19:36'!
addChat
	
	| morph editor |
	morph := self textMorph.
	editor := morph textMorph editor.
	morph hasUnacceptedEdits: (editor justTalk: nil).! !

!XpfCtToolbar methodsFor: 'actions' stamp: 'mt 5/30/2009 19:43'!
addChatLabel
	
	^ self
		labelMorphWithIcon: MenuIcons xpfCtSmallMarkCommentIcon
		text: 'add code chat'! !

!XpfCtToolbar methodsFor: 'actions' stamp: 'mt 5/30/2009 19:36'!
addComment
	
	| morph editor |
	morph := self textMorph.
	editor := morph textMorph editor.
	morph hasUnacceptedEdits: (editor addComment: nil).! !

!XpfCtToolbar methodsFor: 'actions' stamp: 'mt 5/30/2009 19:43'!
addCommentLabel
	
	^ self
		labelMorphWithIcon: MenuIcons xpfCtSmallAddCommentIcon
		text: 'add comment'! !

!XpfCtToolbar methodsFor: 'building' stamp: 'mt 5/30/2009 19:45'!
buildOn: aMorphBuilder

	| row head |
	head := 'CodeTalk' asText.
	head addAttribute: (TextColor color: Color gray).
	head addAttribute: (TextFontReference toFont: (XpfClient sansFontAt: 8)).
	row := PanelMorph new
		changeTableLayout;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		listDirection: #leftToRight;
		borderWidth: 1;
		borderRaised;
		cellInset: 5;
		fillStyle: (Color r: 0.8 g: 0.8 b: 0.8 alpha: 0.5);
		addMorphBack: (PanelMorph new vResizing: #rigid; hResizing: #rigid; fillStyle: Color transparent; extent: 3@3);
		addMorphBack: head asMorph;
		addMorphBack: self dot;
		addMorphBack: (self newButton: #addComment);
		addMorphBack: (self newButton: #addChat);
		addMorphBack: (self newButton: #markBad).
		
		.
	
	aMorphBuilder insertMorph: row.! !

!XpfCtToolbar methodsFor: 'building' stamp: 'mt 5/30/2009 19:38'!
dot

	^ PanelMorph new
		hResizing: #rigid;
		vResizing: #rigid;
		fillStyle: Color gray;
		extent: 2@2! !

!XpfCtToolbar methodsFor: 'building' stamp: 'mt 5/30/2009 19:46'!
labelMorphWithIcon: anIcon text: aString

	| lm lbl |

	lm := PanelMorph new
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		fillStyle: Color transparent; "non pane color tracking"
		changeTableLayout;
		listDirection: #leftToRight;
		cellInset: 4.
	
	lbl := aString asText.
	lbl
		"addAttribute: (TextColor color: Color gray muchDarker);"
		addAttribute: (TextFontReference toFont: (XpfClient sansFontAt: 8)).
		
	lm
		addMorphBack: anIcon asMorph;
		addMorphBack: lbl asMorph lock.

	^ lm! !

!XpfCtToolbar methodsFor: 'actions' stamp: 'mt 5/30/2009 19:17'!
markBad
	
	| morph editor |
	morph := self textMorph.
	editor := morph textMorph editor.
	morph hasUnacceptedEdits: (editor markAsBad: nil).! !

!XpfCtToolbar methodsFor: 'actions' stamp: 'mt 5/30/2009 19:43'!
markBadLabel

	^ self
		labelMorphWithIcon: MenuIcons xpfCtSmallMarkBadIcon
		text: 'mark bad'! !

!XpfCtToolbar methodsFor: 'building' stamp: 'mt 5/30/2009 19:49'!
newButton: aSymbol

	^ (PluggableButtonMorphPlus
		on: self
		getState: nil
		action: aSymbol
		label: (aSymbol, #Label) asSymbol)
		borderWidth: 0;
		height: 16;
		onColor: Color white offColor: Color gray muchLighter.! !

!XpfCtToolbar methodsFor: 'private' stamp: 'mt 5/30/2009 19:07'!
textMorph
	"A little bit tricky but necessary."
	
	| panel |
	panel := self browser definitionPanel.
	^ OBPluggableTextMorph allSubInstances
		detect: [:each | each model == panel]
		ifNone: []! !

!XpfCtToolbar methodsFor: 'private' stamp: 'mt 5/30/2009 18:38'!
vResizing

	^ #rigid! !

!OBMethodVersion methodsFor: '*xpf-codetalk-override' stamp: 'mt 5/3/2009 09:39'!
source

	| file |
	file := sources at: (sources fileIndexFromSourcePointer: pointer).
	file position: (sources filePositionFromSourcePointer: pointer).
	^ file nextChunkText makeSelectorBold! !

OBTextMorphEditorWithShout subclass: #XpfEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Kernel'!

!XpfEditor class methodsFor: 'initialization' stamp: 'mt 5/5/2009 15:17'!
initializeCmdKeyShortcuts

	super initializeCmdKeyShortcuts.
	CmdActions
		at: ($t asInteger + 1) put: #justTalk:;
		at: ($r asInteger + 1) put: #markAsBad:.! !

!XpfEditor methodsFor: 'code markup' stamp: 'mt 5/28/2009 19:51'!
addComment: aCharacterStream

	(paragraph tagSelectionWith: #comment)
		ifTrue: [self userHasEdited. ^ true].
	^ false! !

!XpfEditor methodsFor: 'code markup' stamp: 'mt 5/18/2009 10:53'!
changeMarkupTag

	| result |
	result := UITheme current
		chooseDropListIn: self morph
		text: 'Select a new tag:'
		title: 'Change Markup Tag' list: XpfComplexAttribute tags.
		
	result ifNil: [^ false].
	
	(paragraph changeTagInSelectionTo: result)
		ifTrue: [self userHasEdited. ^ true].
	^ false! !

!XpfEditor methodsFor: 'initialize-release' stamp: 'cs 5/2/2009 13:44'!
changeParagraph: aParagraph
	"Add a back reference to the textmorph to the paragraph."

	super changeParagraph: aParagraph.
	(aParagraph isKindOf: XpfParagraph) & (morph isKindOf: XpfTextMorph)
		ifTrue: [
			aParagraph textMorph: morph.
			morph removeAllMorphs.
			(aParagraph text attributesOfKind: XpfComplexAttribute)
				do: [:attr | attr addDependent: morph]].! !

!XpfEditor methodsFor: 'code markup' stamp: 'mt 5/5/2009 15:02'!
justTalk: aCharacterStream

	(paragraph tagSelectionWith: #talk)
		ifTrue: [self userHasEdited. ^ true].
	^ false! !

!XpfEditor methodsFor: 'code markup' stamp: 'mt 5/1/2009 15:59'!
markAsBad: aCharacterStream

	(paragraph tagSelectionWith: #bad)
		ifTrue: [self userHasEdited. ^ true].
	^ false! !

!XpfEditor methodsFor: 'code markup' stamp: 'mt 5/1/2009 14:55'!
removeMarkup: aCharacterStream

	paragraph untagSelection.
	self userHasEdited.
	^ true! !

!XpfEditor methodsFor: 'code markup' stamp: 'mt 5/5/2009 15:02'!
resizeMarkup: aCharacterStream

	(paragraph resizeTagInSelection)
		ifTrue: [self userHasEdited. ^ true].
	^ false! !

SHTextStylerST80 subclass: #XpfTextStyler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Kernel'!

!XpfTextStyler methodsFor: 'private' stamp: 'mt 4/29/2009 23:01'!
privateStyle: aText
	"First, backup current style information about background color in text runs. Then let Shout work. Then restore background color information for text runs."

	| backupRuns |
	backupRuns := aText runs.

	super privateStyle: aText.
	
	backupRuns withStartStopAndValueDo: [:start :stop :attrs | |a|
		a := attrs detect: [:attr | attr isKindOf: XpfComplexAttribute] ifNone: [nil].
		a ifNotNil: [aText addAttribute: a from: start to: stop].
	]! !

!XpfTextStyler methodsFor: 'converting' stamp: 'mt 4/29/2009 23:02'!
unstyledTextFrom: aText

	| backupRuns result |
	backupRuns := aText runs.

	result := super unstyledTextFrom: aText.
	
	backupRuns withStartStopAndValueDo: [:start :stop :attrs | |a|
		a := attrs detect: [:attr | attr isKindOf: XpfComplexAttribute] ifNone: [nil].
		a ifNotNil: [result addAttribute: a from: start to: stop]].
	^ result! !

!OBTextSelection methodsFor: '*xpf-codetalk' stamp: 'mt 5/3/2009 18:39'!
start

	^ selection first! !

!OBTextSelection methodsFor: '*xpf-codetalk' stamp: 'mt 5/3/2009 18:39'!
stop

	^ selection last! !

!OBClassNode methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 13:55'!
hasMarkups

	^ true! !

!OBClassNode methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 14:22'!
markupSourceName

	^ '{1} "{2}"' format: {
		self theClass isMeta
			ifTrue: ['meta-class']
			ifFalse: ['class'].
		self theClassName}! !

!OBClassNode methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 14:13'!
methodReferences

	^ (self theClass selectors collect: [ :each | 
		MethodReference class: self theClass selector: each])! !

!OBClassNode methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 13:54'!
referencesForMarkups

	^ self methodReferences! !

OBFilter subclass: #XpfCtReloadFilter
	instanceVariableNames: 'inspector cache announcer node isReloading browser updateProcess'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Filters'!

!XpfCtReloadFilter methodsFor: 'accessing' stamp: 'mt 5/25/2009 11:09'!
announcer

	^ announcer! !

!XpfCtReloadFilter methodsFor: 'accessing' stamp: 'mt 5/25/2009 12:45'!
announcer: anObject

	announcer := anObject.! !

!XpfCtReloadFilter methodsFor: 'accessing' stamp: 'mt 5/25/2009 11:48'!
browser

	^ browser! !

!XpfCtReloadFilter methodsFor: 'accessing' stamp: 'mt 5/25/2009 11:48'!
browser: anObject

	browser := anObject.! !

!XpfCtReloadFilter methodsFor: 'accessing' stamp: 'mt 5/25/2009 11:22'!
cache

	cache ifNil: [
		self cache: OrderedCollection new].
	^ cache! !

!XpfCtReloadFilter methodsFor: 'accessing' stamp: 'mt 5/19/2009 16:45'!
cache: anObject

	cache := anObject.! !

!XpfCtReloadFilter methodsFor: 'updating' stamp: 'mt 6/3/2009 09:51'!
doNodeRefreshing

	| sel |
	self browser navigationPanel currentColumn ifNotNilDo: [:col |
		sel := col selection].

	self announcer announce: OBRefreshRequired new.

	sel ifNotNilDo: [:s |
		self browser navigationPanel currentColumn selection: s].! !

!XpfCtReloadFilter methodsFor: 'initalizing' stamp: 'mt 5/27/2009 15:04'!
initializeForNode: aMethodNode

	| reference definition |
	reference := aMethodNode reference.
	definition := aMethodNode definition.
	self inspector: (XpfCtMczInspector newForPackageNamed: 
		(PackageOrganizer default packageOfMethod: reference) packageName).
		
	node := aMethodNode.
		
	self inspector
		addDependent: self;
		inspectVersionsFor: definition selector
		in: definition theClass.! !

!XpfCtReloadFilter methodsFor: 'accessing' stamp: 'mt 5/19/2009 16:47'!
inspector

	^ inspector! !

!XpfCtReloadFilter methodsFor: 'accessing' stamp: 'mt 5/19/2009 16:45'!
inspector: anObject

	inspector := anObject.! !

!XpfCtReloadFilter methodsFor: 'updating' stamp: 'mt 6/3/2009 09:51'!
refreshNodes

	updateProcess
		ifNil: [updateProcess := [
			self doNodeRefreshing.
			(Delay forMilliseconds: (
				self cache size < 3
					ifTrue: [1000]
					ifFalse: [3000])) wait.
			updateProcess := nil] fork].! !

!XpfCtReloadFilter methodsFor: 'updating' stamp: 'mt 6/3/2009 09:51'!
update: aSymbol

	super update: aSymbol.
	aSymbol = #done ifTrue: [self refreshNodes].! !

!XpfCtReloadFilter methodsFor: 'updating' stamp: 'mt 6/2/2009 15:32'!
update: aSymbol with: anObject

	super update: aSymbol with: anObject.
	
	aSymbol = #versionFound ifTrue: [
		self cache add: (XpfCtRemoteMethodVersion
			repository: (anObject at: #repository)
			info: (anObject at: #info)
			definition: (anObject at: #definition)).
		self refreshNodes].! !

!OBCodeBrowser methodsFor: '*xpf-codetalk-commands' stamp: 'mt 5/30/2009 15:07'!
cmdCodeTalk
	^ XpfCtEditCommand allSubclasses! !

!OBCodeBrowser methodsFor: '*xpf-codetalk-commands' stamp: 'mt 5/30/2009 09:34'!
cmdMarkups

	^ XpfCtCmdBrowseMarkups! !

!OBCodeBrowser methodsFor: '*xpf-codetalk-commands' stamp: 'mt 5/19/2009 15:19'!
cmdRemoteVersions
	^ XpfCtCmdBrowseRemoteMethodVersions! !

OBCodeBrowser subclass: #XpfCtMarkupBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Browsers'!

!XpfCtMarkupBrowser class methodsFor: 'as yet unclassified' stamp: 'mt 6/5/2009 15:12'!
maxPanes

	^ 2! !

!XpfCtMarkupBrowser class methodsFor: 'as yet unclassified' stamp: 'mt 6/5/2009 15:12'!
minPanes

	^ 2! !

!XpfCtMarkupBrowser class methodsFor: 'as yet unclassified' stamp: 'mt 6/5/2009 15:50'!
navigationPanel

	^ XpfCtMarkupColumnPanel minPanes: self minPanes maxPanes: self maxPanes! !

!XpfCtMarkupBrowser class methodsFor: 'as yet unclassified' stamp: 'mt 6/5/2009 16:27'!
openOn: aCodeNode

	| rootNode filterNode markupNode |
	rootNode := OBMetaNode named: 'Environment'.
	filterNode := OBMetaNode named: 'Markup Filter'.
	filterNode ancestrySelector: #isDescendantOfMarkup:.
	
	markupNode := OBMetaNode named: 'Markup'.
	
	rootNode
		childAt: #markupFilters
		put: filterNode.
	
	filterNode
		childAt: #markupsByLastActivity
		labeled: 'by last activity'
		put: markupNode;
		childAt: #markupsByChatSize
		labeled: 'by chat size'
		put: markupNode;
		childAt: #markupsByCreationTime
		labeled: 'by creation time'
		put: markupNode;
		childAt: #markupsByTag
		labeled: 'by tag'
		put: markupNode;
		addFilter: OBModalFilter new.
	
	^ (self metaNode: rootNode root: aCodeNode selection: aCodeNode markupFilters first) open! !

!XpfCtMarkupBrowser class methodsFor: 'as yet unclassified' stamp: 'mt 5/30/2009 17:25'!
panels
	^ {self navigationPanel. self definitionPanel} reject: [:ea | ea isNil]! !

!XpfCtMarkupBrowser methodsFor: 'building' stamp: 'mt 5/30/2009 09:24'!
defaultBackgroundColor

	^ Color red muchLighter! !

!XpfCtMarkupBrowser methodsFor: 'accessing' stamp: 'mt 5/30/2009 14:34'!
defaultLabel

	^ 'Markups for {1}' format: {self root markupSourceName}! !

OBCodeBrowser subclass: #XpfCtRemoteVersionBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Browsers'!

!XpfCtRemoteVersionBrowser class methodsFor: 'layout' stamp: 'mt 5/19/2009 10:21'!
maxPanes

	^ 1! !

!XpfCtRemoteVersionBrowser class methodsFor: 'layout' stamp: 'mt 5/19/2009 10:21'!
minPanes

	^ 1! !

!XpfCtRemoteVersionBrowser class methodsFor: 'instance creation' stamp: 'mt 5/25/2009 11:48'!
openOn: aMethodNode

	| instance version rootNode filter |
	version := OBMetaNode named: 'RemoteVersion'.	
	rootNode := OBMetaNode named: 'Method'.
	filter := XpfCtReloadFilter new.
	
	version ancestrySelector: #isDescendantOfMethodVersion:.
	
	rootNode
		childAt: #remoteVersions put: version;
		addFilter: filter.

	instance := self metaNode: rootNode root: aMethodNode selection: nil.
	
	filter
		browser: instance;
		announcer: instance announcer;
		initializeForNode: aMethodNode.

	^ instance open! !

!XpfCtRemoteVersionBrowser class methodsFor: 'layout' stamp: 'mt 5/26/2009 19:11'!
optionalButtons

	^ #('browse' 'revert')! !

!XpfCtRemoteVersionBrowser class methodsFor: 'layout' stamp: 'mt 5/26/2009 19:17'!
panels

	^ {self topPanel. self navigationPanel. self progressPanel. self definitionPanel} reject: [:ea | ea isNil]! !

!XpfCtRemoteVersionBrowser class methodsFor: 'layout' stamp: 'mt 5/26/2009 19:18'!
progressPanel

	^ XpfCtProgressPanel new! !

!XpfCtRemoteVersionBrowser class methodsFor: 'layout' stamp: 'mt 5/30/2009 17:15'!
topPanel

	^OBTopNavigationPanel withPanels: ({self mercuryPanel. self optionalButtonPanel} reject: [:ea | ea isNil])! !

!XpfCtRemoteVersionBrowser methodsFor: 'building' stamp: 'mt 5/25/2009 10:13'!
defaultBackgroundColor

	^ Color gray muchLighter! !

!XpfCtRemoteVersionBrowser methodsFor: 'accessing' stamp: 'mt 5/28/2009 10:04'!
defaultLabel

	^ 'Monticello Versions of {1}>>#{2}' format: {self root theClassName. self root selector}! !

TextLink subclass: #XpfCtMethodLink
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Kernel'!

!XpfCtMethodLink class methodsFor: 'services' stamp: 'mt 6/5/2009 13:45'!
addMethodLinksInto: aText
	"Parse the message and add links to the methods mentioned. This method will modify the attributes of the given text object."

	| rx s links strm |
	rx := '([A-Z]\w*)(\sclass)?>>(\w[\w:]*)' asRegex.
	s := aText asString.
	strm := s readStream.
	links := OrderedCollection new.
	
	[rx searchStream: strm]
		whileTrue: [
			links add: {
				rx subBeginning: 2.
				rx subEnd: 4.
				'{1}{2} {3}' format: {
					rx subexpression: 2.
					rx subexpression: 3.
					rx subexpression: 4}}].

	links do: [:link |
		aText
			addAttribute: (XpfCtMethodLink new classAndMethod: link third)
			from: link first + 1
			to: link second].
		
	^ aText! !

!XpfCtMethodLink methodsFor: 'as yet unclassified' stamp: 'mt 6/6/2009 09:06'!
actOnClickFor: aTextMorph

	[OBCodeBrowser defaultBrowserClass
		openOnClass: self theClass
		selector: self selector]
		on: Error
		do: [:e | Transcript show: '[CodeTalk] Method browsing not possible.'; cr].
	^ true! !

!XpfCtMethodLink methodsFor: 'as yet unclassified' stamp: 'mt 6/4/2009 16:31'!
selector

	^ (classAndMethod findTokens: Character space) last asSymbol! !

!XpfCtMethodLink methodsFor: 'as yet unclassified' stamp: 'mt 6/4/2009 16:32'!
theClass 

	| c |
	c := Smalltalk at: self theClassName asSymbol ifAbsent: [^nil].
	self theClassIsMeta ifTrue: [^c classSide].
	^c! !

!XpfCtMethodLink methodsFor: 'as yet unclassified' stamp: 'mt 6/4/2009 16:31'!
theClassIsMeta

	^ (classAndMethod findTokens: Character space) second = 'class'! !

!XpfCtMethodLink methodsFor: 'as yet unclassified' stamp: 'mt 6/4/2009 16:26'!
theClassName

	^ (classAndMethod findTokens: Character space) first! !

!OBClassCategoryNode methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 14:01'!
hasMarkups

	^ true! !

!OBClassCategoryNode methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 14:24'!
markupSourceName

	^ 'class category "{1}"' format: {self name}! !

!OBClassCategoryNode methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 14:19'!
referencesForMarkups

	| result |
	result := OrderedCollection new.
	self classNames
		collect: [:ea | environment at: ea]
		thenDo: [:c |
			c selectors do: [ :each |
				result add: (MethodReference class: c selector: each)].
			c class selectors do: [ :each |
				result add: (MethodReference class: c class selector: each)]].
	^ result! !

SystemProgressBarMorph subclass: #XpfCtPluggableProgressBarMorph
	instanceVariableNames: 'model maxSelector valueSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Morphs'!

!XpfCtPluggableProgressBarMorph class methodsFor: 'as yet unclassified' stamp: 'mt 5/5/2009 20:53'!
newFor: aModel value: valSel max: maxSel

	^ self new
		model: aModel;
		maxSelector: maxSel;
		valueSelector: valSel! !

!XpfCtPluggableProgressBarMorph methodsFor: 'accessing' stamp: 'mt 5/5/2009 20:45'!
maxSelector

	^ maxSelector! !

!XpfCtPluggableProgressBarMorph methodsFor: 'accessing' stamp: 'mt 5/5/2009 20:45'!
maxSelector: aSymbol

	maxSelector := aSymbol! !

!XpfCtPluggableProgressBarMorph methodsFor: 'accessing' stamp: 'mt 5/5/2009 20:42'!
model

	^ model! !

!XpfCtPluggableProgressBarMorph methodsFor: 'accessing' stamp: 'mt 5/5/2009 20:43'!
model: anObject

	self model ifNotNilDo: [:m | m removeDependent: self].
	model := anObject.
	self model ifNotNilDo: [:m | m addDependent: self].! !

!XpfCtPluggableProgressBarMorph methodsFor: 'updating' stamp: 'mt 5/5/2009 21:24'!
update: aSymbol

	super update: aSymbol.
	
	aSymbol = self valueSelector ifTrue: [self updateBar]! !

!XpfCtPluggableProgressBarMorph methodsFor: 'updating' stamp: 'mt 5/5/2009 21:26'!
updateBar

	| value max |
	value := self model perform: self valueSelector.
	max := self model perform: self maxSelector.
	
	self 
		disableTableLayout: ((value = 0) | (value = max));
		visible: ((value = 0) | (value = max)) not.	
	
	self visible ifTrue:
		[self barSize: (value * self width) // max].! !

!XpfCtPluggableProgressBarMorph methodsFor: 'accessing' stamp: 'mt 5/5/2009 20:45'!
valueSelector

	^ valueSelector! !

!XpfCtPluggableProgressBarMorph methodsFor: 'accessing' stamp: 'mt 5/5/2009 20:54'!
valueSelector: aSymbol

	valueSelector := aSymbol.
	self update: aSymbol.! !

!OBMethodVersionNode methodsFor: '*xpf-codetalk' stamp: 'mt 5/3/2009 10:02'!
categoryText

	^ self version category! !

!OBMethodVersionNode methodsFor: '*xpf-codetalk' stamp: 'mt 5/27/2009 10:39'!
hasVersions

	^ false! !

!OBMethodVersionNode methodsFor: '*xpf-codetalk' stamp: 'mt 5/3/2009 09:55'!
sourceText

	^ self version source! !

OBMethodVersionNode subclass: #XpfCtRemoteMethodVersionNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Nodes'!

!XpfCtRemoteMethodVersionNode class methodsFor: 'as yet unclassified' stamp: 'mt 5/19/2009 11:20'!
on: aRemoteMethodVersion

	^ self new setVersion: aRemoteMethodVersion! !

!XpfCtRemoteMethodVersionNode methodsFor: 'as yet unclassified' stamp: 'mt 5/27/2009 16:02'!
name

	| author time ver|
	time := String streamContents: [:strm |
		self version definition fullTimeStamp time print24: true showSeconds: false on: strm].
	author := (self version stamp findTokens: Character space) first.
	ver := self version info name.
	
	^ '{1} {2} [{3}]' format: {time. author. ver}! !

!XpfCtRemoteMethodVersionNode methodsFor: 'accessing' stamp: 'mt 5/19/2009 15:31'!
remoteVersion

	^ version! !

!XpfCtRemoteMethodVersionNode methodsFor: 'accessing' stamp: 'mt 5/19/2009 15:31'!
remoteVersion: anObject

	version := anObject.! !

!XpfCtRemoteMethodVersionNode methodsFor: 'as yet unclassified' stamp: 'mt 5/19/2009 11:28'!
source

	^ self sourceText! !

!XpfCtRemoteMethodVersionNode methodsFor: 'as yet unclassified' stamp: 'mt 5/19/2009 11:26'!
sourceText

	^ self remoteVersion sourceText! !

!XpfCtRemoteMethodVersionNode methodsFor: 'as yet unclassified' stamp: 'mt 5/19/2009 15:35'!
theClass

	^ self version theClass! !

!OBCmdChaseVariables methodsFor: '*xpf-codetalk-override' stamp: 'mt 5/30/2009 16:03'!
buttonLabelWithSpaces

	^ super buttonLabelWithSpaces! !

!OBCmdChaseVariables methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 15:47'!
icon

	^ #xpfCtBricksIcon! !

!OBCmdChaseVariables methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 15:47'!
iconOnly

	^ true! !

!OBCmdChaseVariables methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 16:06'!
longDescription

	^ 'chase variables'! !

!OBCmdBrowseMethodVersions methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 15:51'!
icon

	^ #xpfCtTimeIcon! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 2/5/2009 18:08'!
markBadIcon
	^ Icons
			at: #'markBad'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self markBadIconContents readStream) ].! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 2/5/2009 18:06'!
markBadIconContents
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAACxSURBVDjL7dItC8JQAIXh491H
WbDvD1pEDIIKm1zDxqKi0WIULAZFYc1msF3ErEZlMC9Mhxx/gTAR28KpDxx4QRK/DCXwAbDg
0oLMTShtQF0F5AlwvwHkqy+Zxxs+lwsmvs8DKrIw8DCh8njNLOxRtxrU4yF3MFRhIBFQ2XxG
3W7yXq8xjULGsIsDFwF58zzq0YBpFPDc6XIKp/iFI4S7h5BbWGoFW03gyABVtyzxT8Ab8Xze
i+tkcykAAAAASUVORK5CYII='! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 2/5/2009 18:08'!
markGoodIcon
	^ Icons
			at: #'markGood'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self markGoodIconContents readStream) ].! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 2/5/2009 18:06'!
markGoodIconContents
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAC5SURBVDjLY/j//z8DJZhh1ADs
BjjsspIC4gb77ZZX7TdbXLVda9Zgs8xEihQDGmZfm/7/0KOD/3ff3/V/6plJ/y3mGjYQbYD9
NsurBx4e+D/10tT/nWc6/i+5sui/+RS9q0QbYLfB/OrWO1v+d5/p+t96qvn/3Auz/pt0aRNv
gPVyk4appyf+X3xl4f/ZF2b+n3Co579+mSrxXrCcZyhlMV2/wbRP56pRq+ZV3SLlBq1EOanR
lEgjAwAXIuIDq5qm/AAAAABJRU5ErkJggg=='! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 2/5/2009 18:08'!
markUnknownIcon
	^ Icons
			at: #'markUnknown'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self markUnknownIconContents readStream) ].! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 2/5/2009 18:07'!
markUnknownIconContents
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAQAAAC1+jfqAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAABlSURBVCjPY/jPgB8yDC4FilKK
DfJXZa6KNwhKYVfQkPW/63/b/+T/XA1YFchd7fqf/j/2f+N/5qtYFUhe7fif9D/sf91/BuwK
hBoS/jcBpcP/M2C3gluKrYHhKhA2MEgN2pDEDgEb0f5zlvXgVgAAAABJRU5ErkJggg=='! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 2/5/2009 18:08'!
removeMarkupIcon
	^ Icons
			at: #'removeMarkup'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self removeMarkupIconContents readStream) ].! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 2/5/2009 18:07'!
removeMarkupIconContents
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAQAAAC1+jfqAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAABbSURBVCjPzdAxDoAgEERRzsFp
95JbGI2ASA2SCOX3Ahtr8tuXTDIO959bCxRfpOitWS5vA+lMJg9JbKCTTmMQ1QS3ThqVQbBB
lsbgpXLYE8lHCXrqLptf9km7Dzv+FwGTaznIAAAAAElFTkSuQmCC'! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 5/28/2009 19:58'!
xpfCtAddCommentIcon

	^ Icons
			at: #'xpfCtAddComment'
			ifAbsentPut:[ UIThemeWatery new newWindowMaximizeForm ].! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 15:56'!
xpfCtArrowDivideContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAI3SURBVDjLpZNNSJRxEMaf1XVV
yA/8iH1fKdEKIzwpSIeCLmkRUaaXSsE6tB3qYLIQeTUMCwqEKNI6hJHRNamwEDSXCENKoaKN
NjLCd9PDRuX7f2b+HUSzcLs4t2Hm+Q0zPBOw1mItkbEy6RiP9LSPnuhK19x6r6nn8MDBrlUB
Hc8iveFsN+rkOJ2nnhy78q+4ZbCp180ri7qFbmfjjb3L9UDH+MlMq9oXznHaNuVvgYjg3dwb
JOYT/UKJkAIx0ucUlLVVOVWgJabiU4jPxPtpJBJU1bMqWpuFEFQVFhakgEbqhBKlkUyStUJC
rEBVEQxmwfisEyPRgLUWp58e3xgKhBJ1znaoKh6/fYRbjYOBlSscuN5g62vrQSsYjg0j9T1V
PnIu9ikDAISyOFUEtITS4sidxtCy+FpDSI2CSlAJYwj68ueIQoEYQixBEYTzwqBh9xLA+Ox2
SlwYXazTX4QAQBAASJlZMP6cl/KK8nMLUF5agR+/fp7Zf3V3tVDgFLv1lRsqQCVmkx5SqdQc
KTMAEFgyUsvdQ82kDFSUVIbcYhcKC2/egwhRWFAEqkH84wdMTU/7Qjk6cfHV/b8AANB8c99m
Gukk2bq1fFvm+uJSqAo+f/2CickJEcptGjn/8tLr98s+WM3Key7v2rEuN2+0proGYhWx5zF4
yeTOFxcmx/5r5aV42D4y5n1LLvhi4NNg1vMWVhOnBQAAfWarVSgUNJKdri+YFmCIB0NDECMQ
StpvDKz1nX8D4+Fd1+gIFK0AAAAASUVORK5CYII='! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 15:56'!
xpfCtArrowDivideIcon

	^ Icons
		at: #'xpfCtArrowDivide'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfCtArrowDivideContents readStream) ].! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 15:44'!
xpfCtBricksContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAALLSURBVDjLpZPfT1JhGMfprnnd
39B1986rtja3TEWGBJocEYbya+oBzgJRt8xwKjoCf1SgqKSiGUqlYiZzGpY6XebMXFOxocIF
K8p1c76d8zpXq9lNF8/27H2f7+f5Pu8PAQDB/8RfC2/u1WVErHTmS1oniyko7Bfmk4iVlmCG
1t6KWOhMvuZcwCpTHU0a9EioVTjiRCmGQYqmSZ7QlCNZacCyuSp6LuCjVMR+sVpx4uzAkboM
MYmQBJ/za/zeB3EOGzbqLhNAndeWYXRVZxocWpl5UI9d4XWkfT4ktRU45kbgRWewY5UScaqI
GykXHOAKAdz2GKMNIStsYyYwAQP2RDfwIxjCN7cLiQoVsZys0uNzkZSI+VH2Jfm/AJqeMtYx
fRe+xS5YR2lC5wFpdwfSTidSLc04lBcR8SFVfAr43YHSW4zZzSk4phvBjFRi52YB6Zx2d+Jr
eztSTXbES2REyAMOuO5bomzWZHNfNTf7MwTqHjmWPi1gaiOE4aV+dAfqMa+jsCvJIzfBu+DP
4kAmwY4wG7MKOWrtflR2R6BpGIgKyntLsbA9h4m1UQRXA/BHPTAN62CzuBClpNwN5GFXnIto
iQR3mDao2sJwTKzD4ltELjPECjReBTu2MoSRZT+GlnzwLnSBHtIg1/oET6M7qPe+grJlkoj4
4AHq9hnIm15AaAtCUOXQZ2nd6ri2T4WuOSf6X3vIWeTbxjCzFkNgfhueyXeo6XsNQ2cERfbn
RFzaOg1RXfD08ZycnFwwtOkUSheVrvApUN5LEfrkyh4G5rbwmItH0xuQN08SMcU54gHEwZ8v
Ud+qvaR3aC+Ka0dZb/g9POFNPOQc3OfsF9tPO/MAcf04coyD7Lm/TGXtyJJZeuISrtAeeAtX
aB2K1jCkjc+QYw5AbHyQoEzOa//8qvxo6pruskKmNy2uG+csj6HA2PtdbnZVn9X8BLLktmdB
dpY6AAAAAElFTkSuQmCC'! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 15:44'!
xpfCtBricksIcon

	^ Icons
		at: #'xpfCtBricks'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfCtBricksContents readStream) ].! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 15:38'!
xpfCtChartOrganisationContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAFOSURBVDjLtVK7SgNRED0b9iuM
2lr4QK1DQIyk0FZsJAj+gH+ilRZb2NjaRHTLmA9QFKz9huzm7t37Hu+u7IJgQjR6YLjDzOXM
mcMERIR5EE5qXA4z4sqACYWEC5wfLQXf/WtMIuDSoL0A7DZDjBj/uYI0l8jzEEJYJMkvCEZM
4PqZIxlzpGk+kSCY18TGtGYcx9Tv96dOqBUMBgNyzsFaC621312Ac+59yJFlGRhj5VvVoigK
vniglEK32w1mkd3r9ejPPAjOhqdknYX18p1/rzo3pYqTh0OSRkJI5UMgPn4s61sX66SkhtEG
cISGsQad5gH2FvehfV5BaIF2cwet5RZyKeu68pe5ubKG7dUNP5AQGltMN57Mosgr5EIiVQmY
Gvtc1PVicqHY+dXpk8Dg7v22XKFo1ARe9v1bDOlXKKKCs4Sn1xdU1v3vIc2CD3bN4xJjfJWv
AAAAAElFTkSuQmCC'! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 15:39'!
xpfCtChartOrganisationIcon

	^ Icons
			at: #'xpfCtChartOrganisation'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfCtChartOrganisationContents readStream) ].! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 5/1/2009 17:52'!
xpfCtCommentAddContents
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAGkSURBVDjLrZJPKINhHMd3UsrJ
TcpBDi6UC+3ookQ5OOBAaCh2cFQ40GqTzURTihI54DRp8dqBg3BQw5BtNmxe/4flT9re5+v3
vJvF2l6Kp749Pe/7fj7P7/09jwqA6i9R/ZugVr+cSZmlvFOgEIGSl0xgnVt3IRyRoDSWtn1c
4qakxQW0yKBEJMbw+MpwHWIQnxgCDwxnQQbvHYP7RoLnJirvntrkkuKvghytZU1+eUWg+Mjg
J/j0nuEkBh9dSTgQo4KB+R0uqEgquCD4PBiDbxlc11HYSfBuILUg/gu8fB/t6rmVcEzw4aWE
fYIdAS6IyILe6S0uUCdtIpd8Hbwah1+SxQlNTE91jJHPI5tcPoiLrBsL6BxrQOtQFep0pc/l
XYU9P14kkngugy/onxlF30ITlpwWOEQB5tV21JgLUNKRZVSCTeM2J6/kuV5fFrbuD8N6OCJX
Y7S3wGxv44K3VHAuxUvR8HVldxFszolvvVncs3DB7+67Wpv9Nig0Qy80yrB+pVG5gsTQh7pq
Yz5Mgkbemc98rdiDJBIDJcTLjs0G/vwDCw/6dFwBuzsAAAAASUVORK5CYII='! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 5/1/2009 17:53'!
xpfCtCommentAddIcon
	^ Icons
			at: #'xpfCtCommentAdd'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfCtCommentAddContents readStream) ].! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 5/28/2009 20:12'!
xpfCtCommentContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAEvSURBVDjLY/j//z8DJZiBagZE
tO8QAuKlQPwTiP/jwbuAWAWbARtXHrz1//efv//xgS0n74MMuQ3EbHADgBweIP7z99+//x++
/fv/8tO//88+/vv/5P2//w/f/ft/782//7df/f1/5xXE8OoFx0GGmCEbIJcz9QBY8gVQ47MP
//4/Bmp+8Pbf/7tQzddf/P1/9RnEgM5VZ0EGeGM14ClQ86N3UM2v//2/9RKi+QpQ88UnuA2A
ewHk/PtAW++8/vv/JlDzted//18Gar7wBGTAH7ABtYtOgAywxBqIIEOQAcg1Fx7/BRuMFoic
uKLxDyzK5u64Cjfo/ecfYD5Q/DLWaMSGgQrvPH/3FabxOxDXEp0SgYp7Z267AtL4BYgLSUrK
QA1KQHwPiFPolxcGzAAA94sPIr7iagsAAAAASUVORK5CYII='! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 5/28/2009 20:12'!
xpfCtCommentIcon

	^ Icons
			at: #'xpfCtComment'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfCtCommentContents readStream) ].! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 5/1/2009 17:51'!
xpfCtCommentsContents
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAG/SURBVDjLjZK9T8JQFMVZTUyc
3IyJg4mDi87+GyYu6qB/gcZdFxkkJM66qJMGSNRBxDzigJMRQ1jQ4EcQ+SgVKB+FtuL13EdJ
xNDq8Ev7Xu85797T51nwhqeAH5w6cAxWwDgReX7jwYfdaCIraroptB7NLlVQrOoiGEsL1G06
GZyxuILicsMUH3VTlOqGKNUMUdTacj+j1Nng0NGAT2WxYosK1bbIVVoiW27J9V8G57WWKVSc
zMV5iK+Tudv1vVh5yXdlLQN+os4AFZss2Ob82CCgQmhYHSnmkzf2b6rIhTAaaT2aXZALIRdC
LgRtkA1WfYG4iKcVYX52JIs7EYvFmJ8wGiEXQi6EXAhdyn2MxQaPcg68zIETTvzyLsPzWnwq
ixVbhFwI3RFykes+A9vkIBKX4jCoIxdCLrI4/0OcUXXK4/1dbbDBS088xGGCCzAJCsiF2lan
T8xdKNhHXvRarLFBqmcwCrbAhL32+kP3lHguETKRsNlbqUFPeY2OoikW62DNM+jf2ibzQNN0
g5ALC75AGiT59oIReQ+cDGyTB+TC4jaYGXiRXMTD3AFogVmnOjeDMRAC025duo7wH74BwZ8J
lHrTPLcAAAAASUVORK5CYII='! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 5/1/2009 17:54'!
xpfCtCommentsIcon
	^ Icons
			at: #'xpfCtComments'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfCtCommentsContents readStream) ].! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 5/1/2009 17:52'!
xpfCtCrossContents
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAIhSURBVDjLlZPrThNRFIWJicmJ
z6BWiYbIkYDEG0JbBiitDQgm0PuFXqSAtKXtpE2hNuoPTXwSnwtExd6w0pl2OtPlrphKLSXh
x07OZM769qy19wwAGLhM1ddC184+d18QMzoq3lfsD3LZ7Y3XbE5DL6Atzuyilc5Ciyd7IHVf
gNcDYTQ2tvDr5crn6uLSvX+Av2Lk36FFpSVENDe3OxDZu8apO5rROJDLo30+Nlvj5RnTlVNA
Ks1aCVFr7b4BPn6Cls21AWgEQlz2+Dl1h7IdA+i97A/geP65WhbmrnZZ0GIJpr6OqZqYAd5/
gJpKox4Mg7pD2YoC2b0/54rJQuJZdm6Izcgma4TW1WZ0h+y8BfbyJMwBmSxkjw+VObNanp5h
/adwGhaTXF4NWbLj9gEONyCmUZmd10pGgf1/vwcgOT3tUQE0DdicwIod2EmSbwsKE1P8QoDk
cHPJ5YESjgBJkYQpIEZ2KEB51Y6y3ojvY+P8XEDN7uKS0w0ltA7QGCWHCxSWWpwyaCeLy0Bk
A7UXyyg8fIzDoWHeBaDN4tQdSvAVdU1Aok+nsNTipIEVnkywo/FHatVkBoIhnFisOBoZxcGt
Qd4B0GYJNZsDSiAEadUBCkstPtN3Avs2Msa+Dt9XfxoFSNYF/Bh9gP0bOqHLAm2WUF1YQskw
rVFYPWkf3h1iXwbvqGfFPSGW9Eah8HSS9fuZDnS32f71m8KFY7xs/QZyu6TH2+2+FAAAAABJ
RU5ErkJggg=='! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 5/1/2009 17:54'!
xpfCtCrossIcon
	^ Icons
			at: #'xpfCtCross'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfCtCrossContents readStream) ].! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 5/1/2009 17:52'!
xpfCtDeleteContents
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAJdSURBVDjLpZP7S1NhGMf9W7Yf
ogSJboSEUVCY8zJ31trcps6zTI9bLGJpjp1hmkGNxVz4Q6ildtXKXzJNbJRaRmrXoeWx8tJO
TWptnrNryre5YCYuI3rh+8vL+/m8PA/PkwIg5X+y5mJWrxfOUBXm91QZM6UluUmthntHqplx
Uml2lciF6wrmdHriI0Wx3xw2hAediLwZRWRkCPzdDswaSvGqkGCfq8VEUsEyPF1O8Qu3O7A0
9RbRvjuIttsRbT6HHzebsDjcB4/JgFFlNv9MnkmsEszodIIY7Oaut2OJcSF68Qx8dgv8tmqE
L1gQaaARtp5A+N4NzB0lMXxon/uxbI8gIYjB9HytGYuusfiPIQcN71kjgnW6VeFOkgh3XcHL
vAwMSDPohOADdYQJdF1FtLMZPmslvhZJk2ahkgRvq4HHUoWHRDqTEDDl2mDkfheiDgt8pw34
0/EocuClCuFvboQzb0cwIZgki4KhzlaE6w0InipbVzBfqoK/qRH94i0rgokSFeO11iBkp8Ed
V8cfJo0yD75aE2ZNRvSJ0lZKcBXLaUYmQrCzDT6tDN5SyRqYlWeDLZAg0H4JQ+Jt6M3atNLE
10VSwQsN4Z6r0CBwqzXesHmV+BeoyAUri8EyMfi2FowXS5dhd7doo2DVII0V5BAjigP89GEV
Atda8b2ehodU4rNaAW+dGfzlFkyo89GTlcrHYCLpKD+V7yeeHNzLjkp24Uu1Ed6G8/F8qjqG
Rzlbl2H2dzjpMg1KdwsHxOlmJ7GTeZC/nesXbeZ6c9OYnuxUc3fmBuFft/Ff8xMd0s65SXIb
/gAAAABJRU5ErkJggg=='! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 5/1/2009 17:54'!
xpfCtDeleteIcon
	^ Icons
			at: #'xpfCtDelete'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfCtDeleteContents readStream) ].! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 16:04'!
xpfCtEyeContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAKASURBVDjLxVNLTxNRFP7udDp9
TCEtFSzloUBwY4FUF0ZjVDYsTDSw0/gjXBii/gk2GjZudO1G4wONK40CGkQSRKTybqGAfVHa
6dy5M/d6WwMhccnCk3yLk3u+L9+55xwihMBRQsERQz2crK+vX3Txyn1SyfXDMnyE24AjwR0Q
4qLQw1M82H4vGo1+3OeQ/RZSqdQTV2XnhkKzmqaoYJaJQj4P27LgcQGNdTocRmFzyWiJv2zq
il0/EJDkt67C0oAGhtTmJpLpHEwSAPNEwBwCy+bQ7W1EsYlYWxiKdMSjvbPhniu96tra2ohm
bAxovILZxCq0E5dh6M1g0jllAqYEZRw7lhRp1ZDdewW9tILAykRPingfk9Ti7BbJJ47viiC6
45cwNm2gYPAaefhWH4TgGB79JoU4vG6Cu0MNyMx/Bv8+hkzJtlWWW27yRfrQ0dhS+4sq0aAO
qHQgOK8JGJbMKZf9/h1asPssyv56sBejqupuinEtEHI5jgNFURCuA5JZB6a0fPvBF1BLClbs
moPT7X5wKVqrbWhFqDMmFFHcKLLiNmzbBmMM7WEFAY2jbDCUJbFsMpQkjgUI4ifVWk21lqaX
oBQ2mMJ94adi6wes5AxoMYOw7uBcl4JTEQFVULhhId5GcO2MJtuUEykXQRc+gb1/hLTl/Vob
Y2JmctyfnTvvUwlEqCMPvdGEHrKgevj+wlTrxO8VL1+ebLaSc1gwA2kj9bPlYJGmPrx7bm0l
rkbIrhrwewFPPbjbj+pzdSPtUh7YXsRqpiT2gp1T9NfEhcGR1zY5fEzjo3c8ud3SIKV0SJrp
1wgCLjiS7/CKaU5LPCOcj918+Gb+n1X+b9f4B22tbKhgZZpBAAAAAElFTkSuQmCC'! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 16:05'!
xpfCtEyeIcon

	^ Icons
		at: #'xpfCtEye'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfCtEyeContents readStream) ].! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 5/3/2009 14:11'!
xpfCtMagnifierContents
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAH5SURBVDjLpZK/a5NhEMe/748k
RqypmqQQgz/oUPUPECpCoEVwyNStIA6COFR33boIjg6mg4uL0k0EO1RFISKImkHQxlbQRAsx
0dgKJm/e53nunnOwViR5leJnuZs+973jHBHB/+D/ah7X2LXWloilyMw5YgtD3CDiBWN4Zno8
bQcJHBFBucauZfsolZDCru0OfFcAAUISrLZDfPzSKxuiibOT+T6JCwDMtrQzYQvZHQ5Cw2h3
GK0OI9AWBzJJZFOxgtJUGpTABQAiLu5OOviuGIEWkBUwC7pasNZj7N2ThNJUjBQY4pznAoEW
sBWwxU+JFXSVRTzmQWvKRR5RG4KVGMgKrAVYflexAAugDCEygdbUCI2F7zobk7FZY76DIDQg
rT9HCwwt1FsBhhIu4p4D3kiS8B0MJz28ftfGSPfl8MPLxbGBAqVpptbslJc+fEPMA7JDPrIp
H3FX8LzaROdrE5O51jalgid3Lh4b6/sDALh6971riErGcFET58gwDPGndG9JT6ReHcwfPorG
ygu8rdxvGxMeP3XtzcofgigWZ0/EtQ7n0/sOTe0/Mo7V5WeoVu61z1yvZzZX+BsnZx9opYLp
evXp7eXKIrL5UWit0n0r/Isb50bjRGreiyWmgs76lfM31y5tSQAAc6czHjONXLi13thygih+
AEq4N6GqMsuhAAAAAElFTkSuQmCC'! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 5/3/2009 14:11'!
xpfCtMagnifierIcon
	^ Icons
			at: #'xpfCtMagnifier'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfCtMagnifierContents readStream) ].! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 5/5/2009 14:42'!
xpfCtMarkBadIcon

	^ Icons
			at: #'xpfCtMarkBad'
			ifAbsentPut:[ UIThemeWatery new newWindowCloseForm ].! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 5/5/2009 14:41'!
xpfCtMarkCommentIcon

	^ Icons
			at: #'xpfCtMarkComment'
			ifAbsentPut:[ UIThemeWatery new newWindowMinimizeForm ].! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 15:33'!
xpfCtPageCodeContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAALESURBVBgZPcFLaJxlFIDh95zv
+//MJZObITUUq/QSG42orcULSnQhgmRjQRCyqaC4qLqrLgQ34gV040JKcOGiEMS9C0E3iVGE
WIu0pWClWAlpmsaZSRuTmfn+c8zY0ecRd6fr2XcXTpQH+mZVOAqUAKFLABdwI5n93tjw72Sz
fmrx9EybXeLudD3/wdLimTeOTqrKkEPA+Z87u5z1Wx3mlxtcu9r6++L5SyPfn55pRXo0yL15
DEMXrhNUBATcoHAjJWe7U/D0oRqPTkR+svWK2+H69OtfDys9ItLv7iEPSqYQBYJCEBABRQBj
fCBn5tg49xzsK8eB6hdKj4NstR0FVEBFUBFUBBVBg7D61zZ393e4b0R49fE7CFl4MdJjKB8t
NGkWzqnHRvn0XIOYYHaqRgxC7srlDadtCbM2T+3vQ6ImZddDH14Z8YGxPGaKtkBFIEGtDGfO
Nmm1nSwofXmglAdKeYajIIo++P6Vl6YOVVcm9/Vrs1HwyiMjqAgn7h9kvVFQKcPnP9dZ/m2L
LCp5CPRFxQB30MkD5bl9tVBarXd4+UiF4VrEgeGKcnyixlozMV4Vlv7cQoCoQgxKYVAY6Lnl
zdcur7Z2RvLA3GKTjUYHd2fjVuKrX+oMReWPtTZPjlfIVIkqBBVKmVAkRy99MvHl8lJ97/mL
dSuVlM++uUZhMLdwg2pJ2dro8Ob0GE9MDeCAOTiQBSW1E+LudE2/88P2/jv3lm60oXJ4D62r
62zehMGDo2gudLmDcdv8cxnPvLW4E+kxS7w3u4ePL+QcGVPswF0UDoWAOTjgDu7w6/WEm9PZ
SUR6UsssmXm7QH5cKTBxHKHLHATHHFwFNSFGsVRYivR0doq1ah5G336gXXV3xcG4bbAc6XKH
ciaIYFmQm0WyFXF3uo6d/PZk6vgLIvKw4xX+4+CA4/zL6doxs7MK8/8A73I7wFFcAY8AAAAA
SUVORK5CYII='! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 15:33'!
xpfCtPageCodeIcon

	^ Icons
			at: #'xpfCtPageCode'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfCtPageCodeContents readStream)].! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 5/3/2009 19:16'!
xpfCtPaintcanContents
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAJVSURBVDjLlZPbS5NhHMd3tbvy
ov6HIJRuhKAFgRci5GXYVQkG0c6HJGvD1FVMjdxC22wlQ9iG7uBh0rtDmxtb77vFoh2c7KgM
tiGbU9xdgezb3hf0Ii3cxZfngef5fn6H5/ewALD+Vv8Upeh7HfzdM+pb4QwT7PPunOg8M7tl
Ph63JtE/4UM3f7WnLUDL3NE7vgmFKYbeF050Di3dbQvQSrvjzogTIm0Yt0WrePp25VNbAHcg
rLopXMOgyo/uR8v4bAnAbrdLLwSIRCLK1HYaHKEdnQ9MuHZ/Edv5MpYcHljc1K9Fgvo+uxqa
nLYEr5wBhMNhZTqdRr1ex6jOBz8VxzONC+VyGQcHB5g3rcFGZWH+lscrc9ArWdjseqzzXWLM
FEWdmnO5HEwbEYzpvmKZ+IFKpYJSqQS/3w/l+4XmlCXYnHGmMfTBOzyg9lxmkSQ5RpsbjQYK
hQKy2Syz7u/vM0Z6T5+73W44nU7IlOrmS9tPPJn3VfsmXVdZLfKbra0tVKtV7O7uYmdnh8mE
BtCwVCqFRCIBgiCg0Wggk8ko7sdNCMwJ3JogRpgSHA6HOhqN4ujoCIeHh6jVashkMkgmk4jH
4wgEApibm4NUKqVEIhH74awXrfSPbyi+dJ020Wg0vguFQtjb20M+n2eixmIxBqDX6+nIpFAo
ZMb63owHHCXhOvOMWq1W7fF4UCwWQZdFN9RqtdKRSYFAcPonrj/fGPznIKlUKvX6+jrTfZvN
BolEQvL5fPaFJ5GWXC5XGwwGiMViksfjtfcbT9Rq1gCXy/2vmdYfaGviUGKvapgAAAAASUVO
RK5CYII='! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 5/3/2009 19:16'!
xpfCtPaintcanIcon
	^ Icons
			at: #'xpfCtPaintcan'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfCtPaintcanContents readStream) ].! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 5/28/2009 19:57'!
xpfCtSmallAddCommentIcon

	^ Icons
			at: #'xpfCtSmallAddComment'
			ifAbsentPut:[ UIThemeWatery new newWindowMaximizeForm scaledToSize: 8@8 ].! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 5/5/2009 14:41'!
xpfCtSmallMarkBadIcon

	^ Icons
			at: #'xpfCtSmallMarkBad'
			ifAbsentPut:[ UIThemeWatery new newWindowCloseForm scaledToSize: 8@8 ].! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 5/5/2009 14:42'!
xpfCtSmallMarkCommentIcon

	^ Icons
			at: #'xpfCtSmallMarkComment'
			ifAbsentPut:[ UIThemeWatery new newWindowMinimizeForm scaledToSize: 8@8 ].! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 15:51'!
xpfCtTimeContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAKrSURBVDjLpdPbT9IBAMXx/qR6
qNbWUy89WS5rmVtutbZalwcNgyRLLMyuoomaZpRQCt5yNRELL0TkBSXUTBT5hZSXQPwBAvor
/fZGazlb6+G8nIfP0znbgG3/kz+Knsbb+xxNV63DLxVLHzqV0vCrfMluzFmw1OW8ePEwf8+W
gM1UXDnapVgLePr5Nj9DJBJGFEN8+TzKqL2RzkenV4yl5ws2BXob1WVeZxXhoB+PP0xzt0Bl
y0fKTePozV5GphYQPA46as+gU5/K+w2w6Ev2Ol/KpNCigM01R2uPgDcQIRSJEYys4JmNoO/y
0tbnY9JlxnA9M15bfHZHCnjzVN4x7TLz6fMSJqsPgLAoMvV1niSQBGIbUP3Ki93t57XhItVX
julTQHf9hfk5/xgGyzQTgQjx7xvE4nG0j3UsiiLR1VVaLN3YpkTuNLgZGzRSq8wQUoD16flk
OPSF28/cLCYkwqvrrAGXC1UYWtuRX1PR5RhgTJTI1Q4wKwzwWHk4kQI6a04nQ99mUOlczMYk
FhPrBMQoN+7eQ35Nhc01SvA7OEMSFzTv8c/0UXc54xfQcj/bNzNmRmNy0zctMpeEQFSio/cd
vqUICz9AiEPb+DLK2gE+2MrR5qXPpoAn6mxdr1GBwz1FiclDcAPCEkTXIboByz8guA75eg8W
xxDtFZloZIdNKaDu5rnt9UVHE5POep6Zh7llmsQlLBNLSMTiEm5hGXXDJ6qb3zJiLaIiJy1Z
pjy587ch1ahOKJ6XHGGiv5KeQSfFun4ulb/josZOYY0di/0tw9YCquX7KZVnFW46Ze2V4wU1
ivRYe1UWI1Y1vgkDvo9PGLIoabp7kIrctJXSS8eKtjyTtuDErrK8jIYHuQf8VbK0RJUsLfEg
94BfIztkLMvP3v3XN/5rfgIYvAvmgKE6GAAAAABJRU5ErkJggg=='! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 15:51'!
xpfCtTimeIcon

	^ Icons
			at: #'xpfCtTime'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfCtTimeContents readStream)].! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 15:26'!
xpfCtTransmitBlueContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAALASURBVDjLhZJdSFNhGMcPSMJA
CLr1wptAkIIuC6zFKjJDb6QurNiFaCH2gWiFNh1rLodNJ/iBS5k5RdvcSSunpTYrc+QHSHFw
bmzNbWd+bE7FWFgnn/6TFrKsLh4OvLy///N7nvMyRMTsrq7xUCpK0/EuNK23BgXd66DQPLw8
XW9Z0jwcCKTG34+HiwFG+mfWaGh2g4Y/bdDL2XVip1apfSxI91k+UmHki/8IAJjYOR4aZCfD
9GJmnTreBqnx1RKhK9U8D5DqKY/vIrUMr1B1f4Cu6z2DV1vdib8D0FXLfgiTeXKNoCsAlEBX
FOtS3uMTlXZ5JbceewRVH09lPV663OTS7ATo3wQPt2LOvukwNQwtCbWWQIr6WSAJukroTtzt
9k0Ud3iVhXpPUoHOnSJtdgnyXp5y6pxCdo0jjWkZWdY+sYXo0ehKVFdSxfLJchPvrhtYokqT
n8q6fSTv9VNes8t9qcGVfLHeKUEI3Wj30FmVXcNA185OhUndz5PCzIuga6odWCToGgvb3OK8
FpcYusbbXV7KqXWYstQOUYZ6HsFeEis4joHulhnLgy5BNwG6kTvoCl2xzWbLtlqtadAVX2l0
UabaHjldNZdwUsGRzOijYzJunYHuVvf7VSrt9Ea3K7rW9jmqu1Jn/pgO+LvFYvlWrR/NgO7C
KeUcHVdwovRKbme0o+XcJoPtOpWsn6AbgW4idE9EtwvYYJ93kH3eSQaDoSN6ll7BHULXfQD9
51Tz0QCOwXZvQrcAi9kf+22AD6Dzptls3ga8rdPpeK1Wm7T7AQEWoy4w8U8zWoCbAAs+/yIt
eHkCLKhUqgd73d0LPgL4x6/O44DHAW/LZLIvJSUlB/8bAHgE8FfArbEzwAbAm0VFRew/AwCf
B+wHfC/+ImB5fn7+mFQqPfPXAMBgddl7zRotwFm5ubmZqITY2U/WPMCPgs5K+QAAAABJRU5E
rkJggg=='! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 15:27'!
xpfCtTransmitBlueIcon

	^ Icons
			at: #'xpfCtTransmitBlue'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfCtTransmitBlueContents readStream)].! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 15:17'!
xpfCtWorldContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAMtSURBVDjLVZNLa1xlAIafc5sz
k8xkMkkm5MKY2EpT2qa2MTVCmoLS2gq6EKooimAW7iQb/0I2bgTRIog0oFW7KQpCS7VqrSmm
JGlSQtswqWlLLmbGmcmcZM6cy/edz00r6bt8eXh4N6+mlGJnxiZHR4APgSNAFjCBKjClInXm
05Gzl3by2mPB2OSoCUwAp1/LHbcziSyO24gbgJAegg2urF8UUsifhZBvfvXK99v/C8YmRy3g
t8G2/cMv517E8Wx8ApYcjZiyKbkRSgQkcFn3rzG9Nn1LhOLYt2/8UNUfLZkYaN0zfLRrkLIM
CHUNIXTqIoZLjLJvU/ASrFQtnko+z2BH38HAD78DMConHh4FPn5nz6vGgqyxTp16JNj2kpR9
C8eD/OoW1VoNO1NCS+d5oW0vV27f2PX11MS8MTR6+JOTXUMHNCPBui5AtdMpk8xsGNQ9ndur
20TxCnbPIn5TnmJUwaxIDrTm9Jn7d1tM4EiuqZs5d41iXGefsZsIwYNCgOfVSXconJbLLEWb
4CuahU2+6HO8d4DQF/0m0NpgNvLAXaPgu6QadrEZpKhUItJZj/aMS1EewvHnsdUWW/+WKG82
kEykCAPRbCqlNE1B4DsocpiW5OJfIVoiyfqSQFdNdGXrpLZGcFZDPKYJg2VQCiGEZkoRlZ3A
6W41mknFn2WlaOKFFrG4Tbw9wb2/S3g3miHySLdbNDd2kzYKVGpVpIiqugjF7P3yQ55pyLFW
mCSyVokZPqHnEoYmsWQGuyWOGdexNIkRFOnqbGN5bRngjh4G4rMLd6+KnmQW012lWrpOJuNj
Ch9LU9i6gRkEZHIrpNv/QK8vcijXz5lfLijgS+PmuYV75+fPDXr1Wt9znfsouy5x+2miuolt
W1iawBJV0o0/wT8lBvbv5WZ+gaWNlasz43MfmQChH777e37uT78eHDx5+BiLBROjqhDaFmGk
Q1KS6+mlr7+XX2evc+nWVB54+4kznfr8pZQIxXkRyhPvDb9vIjtQqgFN12hLO2yUZ/ni8o8S
uAa8NTM+t/GE4HGGx4del0J+IGXUH8ko86iuAneAszPjc9/s5P8DuO6ZcsXuRqAAAAAASUVO
RK5CYII='! !

!MenuIcons class methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 15:18'!
xpfCtWorldIcon

	^ Icons
			at: #'xpfCtWorld'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfCtWorldContents readStream)].! !

!ByteArray class methodsFor: '*xpf-codetalk' stamp: 'mt 5/3/2009 21:24'!
fromHex: hexString 
	"Returns a byteArray from a hex string. The hex string can have
	leading zeros that will not be truncated, preserving the size of the
	byteArray for things like cyrptograpy"
	| anInteger hexSize stringSize aStringOfHex |
	aStringOfHex := (hexString copyWithoutAll: (Array with: $  with: Character cr with: Character tab)).
	stringSize := aStringOfHex size.
	(stringSize > 3
			and: [(aStringOfHex copyFrom: 1 to: 3) = '16r'])
		ifTrue: [anInteger := Number readFrom: (aStringOfHex asUppercase at: 3 put: $r;
							 yourself).
			hexSize := aStringOfHex size - 3 / 2]
		ifFalse: [anInteger := Number readFrom: aStringOfHex asUppercase base: 16.
			hexSize := aStringOfHex size / 2].
	^ anInteger asByteArrayOfSize2: hexSize asInteger! !

OBColumnPanel subclass: #XpfCtMarkupColumnPanel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Panels'!

!XpfCtMarkupColumnPanel commentStamp: 'mt 6/5/2009 15:53' prior: 0!
Just like the normal OBColumnPanel but uses another building method to get another scroller for special layouting.!

!XpfCtMarkupColumnPanel methodsFor: 'building' stamp: 'mt 6/5/2009 15:53'!
buildOn: aBuilder 
	^aBuilder specialScroller: self with: [columns do: [:ea | ea buildOn: aBuilder]]! !

OBTextMorphWithShout subclass: #XpfTextMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Kernel'!

!XpfTextMorph methodsFor: 'submorphs-add/remove' stamp: 'mt 5/1/2009 14:13'!
addMorph: aMorph

	(self submorphs includes: aMorph)
		ifFalse: [^ super addMorph: aMorph].
	^ aMorph! !

!XpfTextMorph methodsFor: 'private' stamp: 'topa 2/13/2009 14:09'!
editorClass
	"Answer the class used to create the receiver's editor"
	
	^XpfEditor! !

!XpfTextMorph methodsFor: 'initialization' stamp: 'mt 4/30/2009 10:36'!
initialize

	super initialize.
	
	(Preferences preferenceAt: #showLineNumbers ifAbsent: [Preference new rawValue: false]) preferenceValue
		ifTrue: [self leftMargin: ((Preferences standardCodeFont widthOfString: '99') * 1.7) rounded].! !

!XpfTextMorph methodsFor: 'accessing' stamp: 'mt 4/29/2009 15:52'!
leftMargin: aNumber

	self margins: (aNumber@0 corner: 0@0).! !

!XpfTextMorph methodsFor: 'private' stamp: 'mt 4/22/2009 20:24'!
paragraphClass
	
	^ XpfParagraph! !

!XpfTextMorph methodsFor: 'submorphs-add/remove' stamp: 'mt 4/30/2009 14:38'!
removeAllMorphsBut: someMorphs

	self submorphs copy do: [:m | (someMorphs includes: m)
		ifFalse: [m delete]]! !

!XpfTextMorph methodsFor: 'private' stamp: 'mt 5/28/2009 19:44'!
update: aSymbol

	super update: aSymbol.
	(aSymbol = #chatLineAdded or: [aSymbol = #commentChanged])
		ifTrue: [self hasUnacceptedEdits: true].
	aSymbol = #resizeRequested ifTrue: [
		self hasUnacceptedEdits:
			self paragraph resizeTagInSelection].! !

!XpfTextMorph methodsFor: 'private' stamp: 'mt 5/3/2009 19:45'!
update: aSymbol with: anAttribute

	aSymbol = #deleteRequested ifTrue: [
		self text removeAttribute: anAttribute.
		self hasUnacceptedEdits: true].
	
	super update: aSymbol with: anAttribute.! !

!XpfTextMorph methodsFor: 'submorphs-add/remove' stamp: 'mt 4/30/2009 13:21'!
updateSubmorphs: someMorphs

	self submorphs copy do: [:m |
		(someMorphs includes: m) ifFalse: [m delete]].
	someMorphs do: [:m |
		(self submorphs includes: m) ifFalse: [self addMorph: m]].! !

!OBMethodCategoryNode methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 13:07'!
hasMarkups

	^ true! !

!OBMethodCategoryNode methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 14:29'!
markupSourceName


	^ 'protocol [{1}] in {2} "{3}"' format: {
		self name.
		self theClass isMeta
			ifTrue: ['meta-class']
			ifFalse: ['class'].
		self theClassName}.! !

!OBMethodCategoryNode methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 13:47'!
referencesForMarkups

	^ self methodReferences! !

!OBCmdBrowseInheritance methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 15:57'!
icon

	^ #xpfCtArrowDivideIcon! !

!OBCmdBrowseInheritance methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 15:57'!
iconOnly

	^ true! !

!OBCmdBrowseInheritance methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 16:06'!
longDescription
	
	^ 'browse inheritance'! !

TextAttribute subclass: #XpfComplexAttribute
	instanceVariableNames: 'tag chat chatMorph deleteMorph resizeMorph morph creator timestamp comment commentMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Kernel'!

XpfComplexAttribute class
	instanceVariableNames: 'colorTable readCache'!

XpfComplexAttribute class
	instanceVariableNames: 'colorTable readCache'!

!XpfComplexAttribute class methodsFor: 'color mapping' stamp: 'mt 5/28/2009 19:15'!
colorForTag: aSymbol

	colorTable ifNil: [colorTable := Dictionary newFrom: {
		#bad -> (Color red alpha: 0.4).
		#talk -> (Color yellow alpha: 0.4).
		#comment -> (Color green alpha: 0.4)}].
	
	^ colorTable at: aSymbol ifAbsent: [Color transparent]! !

!XpfComplexAttribute class methodsFor: 'instance creation' stamp: 'mt 5/2/2009 16:11'!
forTag: aSymbol

	^ self new
		tag: aSymbol;
		timestamp: TimeStamp now;
		creator: Utilities authorInitials! !

!XpfComplexAttribute class methodsFor: 'caching' stamp: 'mt 6/2/2009 18:02'!
identityArrayFor: aComplexAttribute
	
	^ {	aComplexAttribute creator.
		aComplexAttribute timestamp printString.
		aComplexAttribute chat isEmpty
			ifTrue: ['']
			ifFalse: [aComplexAttribute chat last at: #author].
		aComplexAttribute chat isEmpty
			ifTrue: ['']
			ifFalse: [(aComplexAttribute chat last at: #timestamp) printString].
		aComplexAttribute tag.
		aComplexAttribute comment}.! !

!XpfComplexAttribute class methodsFor: 'caching' stamp: 'mt 6/2/2009 18:20'!
read: aComplexAttribute
	"Tell the local cache that the given attribute was read by the developer."
	
	(Preferences
		preferenceAt: #rememberMarkupReads
		ifAbsent: [Preference new rawValue: false])
		preferenceValue
			ifFalse: [^ self].
	
	(readCache ifNil: [readCache := Set new])
		add: (self identityArrayFor: aComplexAttribute).! !

!XpfComplexAttribute class methodsFor: 'caching' stamp: 'mt 6/2/2009 17:59'!
reset
	"Free all cached values."
	
	colorTable := nil.
	readCache := nil.! !

!XpfComplexAttribute class methodsFor: 'private' stamp: 'mt 5/3/2009 21:19'!
scanChatFrom: strm for: attribute

	| chatCopy |
	chatCopy := Json readFrom: (ByteArray fromHex: (strm upTo: $-)) asString readStream.
	chatCopy do: [:line |
		line at: #timestamp put: (TimeStamp fromString: (line at: #timestamp))].
	attribute chat: chatCopy asOrderedCollection.! !

!XpfComplexAttribute class methodsFor: 'private' stamp: 'mt 5/28/2009 19:10'!
scanCommentFrom: strm for: attribute

	attribute comment: (ByteArray fromHex: (strm upTo: $-)) asString.! !

!XpfComplexAttribute class methodsFor: 'private' stamp: 'mt 5/3/2009 21:19'!
scanCreatorFrom: strm for: attribute

	attribute creator: (ByteArray fromHex: (strm upTo: $-)) asString.! !

!XpfComplexAttribute class methodsFor: 'instance creation' stamp: 'mt 5/28/2009 19:21'!
scanFrom: strm

	| count instance substream content |
	instance := self new.
	content := strm upTo: $#.
	count := (content findTokens: $-) size.

	(count < 4 or: [count > 5])
		ifTrue: [^ instance. "Parsing failed."].
		
	substream := content readStream.
	self
		scanTimestampFrom: substream for: instance;
		scanCreatorFrom: substream for: instance;
		scanTagFrom: substream for: instance;
		scanChatFrom: substream for: instance.
	
	count = 5 ifTrue: [self scanCommentFrom: substream for: instance].
	
	^ instance! !

!XpfComplexAttribute class methodsFor: 'private' stamp: 'mt 5/1/2009 14:37'!
scanTagFrom: strm for: attribute

	attribute tag: (strm upTo: $-) asSymbol.! !

!XpfComplexAttribute class methodsFor: 'private' stamp: 'mt 5/3/2009 21:19'!
scanTimestampFrom: strm for: attribute

	attribute timestamp: (TimeStamp fromString:
		(ByteArray fromHex: (strm upTo: $-)) asString).! !

!XpfComplexAttribute class methodsFor: 'caching' stamp: 'mt 5/28/2009 19:14'!
tags
	"Return a list of all available tags."

	^ #(bad talk comment)! !

!XpfComplexAttribute class methodsFor: 'caching' stamp: 'mt 6/2/2009 18:22'!
wasRead: aComplexAttribute
	"Did the developer already read the given attribute?"
	
	(Preferences
		preferenceAt: #rememberMarkupReads
		ifAbsent: [Preference new rawValue: false])
		preferenceValue
			ifFalse: [readCache := nil. ^ false].
	
	^ (readCache ifNil: [readCache := Set new])
		includes: (self identityArrayFor: aComplexAttribute)! !

!XpfComplexAttribute methodsFor: 'testing' stamp: 'mt 4/30/2009 16:08'!
= other

	^ self == other! !

!XpfComplexAttribute methodsFor: 'chat' stamp: 'mt 4/30/2009 17:06'!
addChatLine: aString

	self chat add: (Dictionary newFrom: {
		#author -> Utilities authorInitials.
		#timestamp -> TimeStamp now.
		#message -> aString}).
	self changed: #chatLineAdded.! !

!XpfComplexAttribute methodsFor: 'chat' stamp: 'mt 4/30/2009 17:08'!
addDependent: anObject

	(self dependents includes: anObject)
		ifTrue: [^ self].
		
	^ super addDependent: anObject.! !

!XpfComplexAttribute methodsFor: 'accessing' stamp: 'mt 4/29/2009 21:51'!
chat

	chat ifNil: [chat := OrderedCollection new].
	^ chat! !

!XpfComplexAttribute methodsFor: 'accessing' stamp: 'mt 4/30/2009 11:15'!
chat: aCollection

	chat := aCollection.! !

!XpfComplexAttribute methodsFor: 'accessing read-only' stamp: 'mt 5/1/2009 17:11'!
chatMorph

	chatMorph ifNil: [chatMorph := XpfCtChatIconMorph new attribute: self].
	^ chatMorph! !

!XpfComplexAttribute methodsFor: 'html' stamp: 'mt 5/1/2009 15:05'!
closeHtmlOn: aStream 
	"put on the given stream the tag to close the html  
	representation of the receiver"
	aStream nextPutAll: '</span>'! !

!XpfComplexAttribute methodsFor: 'accessing read-only' stamp: 'mt 5/1/2009 14:31'!
color

	^ self class colorForTag: self tag! !

!XpfComplexAttribute methodsFor: 'accessing' stamp: 'mt 5/28/2009 19:09'!
comment

	comment ifNil: [comment := ''].
	^ comment! !

!XpfComplexAttribute methodsFor: 'accessing' stamp: 'mt 5/28/2009 20:03'!
comment: aString

	comment := aString asString.
	self changed: #commentChanged.! !

!XpfComplexAttribute methodsFor: 'accessing read-only' stamp: 'mt 5/28/2009 19:07'!
commentMorph

	commentMorph ifNil: [commentMorph := XpfCtCommentIconMorph new attribute: self].
	^ commentMorph! !

!XpfComplexAttribute methodsFor: 'accessing' stamp: 'mt 5/2/2009 15:47'!
creator

	creator ifNil: [creator := Utilities authorInitials].
	^ creator! !

!XpfComplexAttribute methodsFor: 'accessing' stamp: 'mt 5/2/2009 15:44'!
creator: authorInitials

	creator := authorInitials.! !

!XpfComplexAttribute methodsFor: 'accessing read-only' stamp: 'mt 5/1/2009 17:24'!
deleteMorph

	deleteMorph ifNil: [deleteMorph := XpfCtDeleteIconMorph new attribute: self].
	^ deleteMorph! !

!XpfComplexAttribute methodsFor: 'displaying' stamp: 'mt 5/1/2009 15:37'!
displayOn: aCanvas in: drawBounds
	"Show some stuff on the canvas for this attribute."
	
	aCanvas
		fillRectangle: drawBounds
		color: self color.! !

!XpfComplexAttribute methodsFor: 'accessing' stamp: 'cs 5/4/2009 02:27'!
includesChatLine: aString

	self chat do: [:dict |
		((dict at: #message) includesSubString: aString)
			ifTrue: [^ true]].
	^ false! !

!XpfComplexAttribute methodsFor: 'chat' stamp: 'mt 6/5/2009 13:56'!
isAuthorMentioned
	"Look into the chat messages to find out if this image's author is mentioned in a message."
	
	^ self chat anySatisfy: [:line | (line at: #message) includesSubString: Utilities authorInitials]! !

!XpfComplexAttribute methodsFor: 'testing' stamp: 'mt 6/5/2009 14:41'!
isMine

	^ self creator = Utilities authorInitials! !

!XpfComplexAttribute methodsFor: 'accessing read-only' stamp: 'mt 5/28/2009 19:18'!
morph

	morph ifNil: [morph := XpfCtRowMorph for: {
		self tag = #comment
			ifTrue: [self commentMorph]
			ifFalse: [self chatMorph].
		self resizeMorph.
		self deleteMorph}].
	^ morph! !

!XpfComplexAttribute methodsFor: 'html' stamp: 'mt 5/1/2009 15:05'!
openHtmlOn: aStream 
	"put on the given stream the tag to open the html  
	representation of the receiver"
	aStream nextPutAll: '<span>'! !

!XpfComplexAttribute methodsFor: 'reading' stamp: 'mt 6/2/2009 18:04'!
read

	self class read: self.! !

!XpfComplexAttribute methodsFor: 'event handling' stamp: 'mt 5/1/2009 17:33'!
requestDeletion

	self changed: #deleteRequested with: self.! !

!XpfComplexAttribute methodsFor: 'event handling' stamp: 'mt 5/3/2009 19:47'!
requestResizing
	"No need to give us away because the pure selection in a paragraph will handle this."

	self changed: #resizeRequested.! !

!XpfComplexAttribute methodsFor: 'accessing' stamp: 'mt 5/18/2009 10:40'!
resetMorphs

	morph := nil.
	chatMorph := nil.
	resizeMorph := nil.
	deleteMorph := nil.! !

!XpfComplexAttribute methodsFor: 'accessing read-only' stamp: 'mt 5/3/2009 19:20'!
resizeMorph

	resizeMorph ifNil: [resizeMorph := XpfCtResizeIconMorph new attribute: self].
	^ resizeMorph! !

!XpfComplexAttribute methodsFor: 'accessing' stamp: 'mt 5/1/2009 14:31'!
tag

	^ tag! !

!XpfComplexAttribute methodsFor: 'accessing' stamp: 'mt 5/18/2009 10:42'!
tag: aSymbol
	"Tag this attribute. Different tags allows to display this attribute in different ways."

	tag := (self class tags includes: aSymbol) ifTrue: [aSymbol] ifFalse: [].
	self resetMorphs.! !

!XpfComplexAttribute methodsFor: 'accessing' stamp: 'mt 5/2/2009 15:47'!
timestamp

	timestamp ifNil: [timestamp := TimeStamp now].
	^ timestamp! !

!XpfComplexAttribute methodsFor: 'accessing' stamp: 'mt 5/2/2009 15:45'!
timestamp: aTimeStamp

	timestamp := aTimeStamp.! !

!XpfComplexAttribute methodsFor: 'reading' stamp: 'mt 6/2/2009 18:04'!
wasRead

	^ self class wasRead: self! !

!XpfComplexAttribute methodsFor: 'scanning' stamp: 'mt 5/2/2009 15:51'!
writeChatOn: strm

	| chatCopy |
	chatCopy := self chat collect: [:line |
		Dictionary newFrom: {
			#timestamp -> (line at: #timestamp) printString.
			#author -> (line at: #author).
			#message -> (line at: #message)}].
	strm nextPutAll: (Json render: chatCopy) toHex.
	strm nextPut: $-.! !

!XpfComplexAttribute methodsFor: 'scanning' stamp: 'mt 5/28/2009 20:08'!
writeCommentOn: strm

	strm nextPutAll: self comment toHex.
	strm nextPut: $-.! !

!XpfComplexAttribute methodsFor: 'scanning' stamp: 'mt 5/2/2009 15:52'!
writeCreatorOn: strm

	strm nextPutAll: self creator toHex.
	strm nextPut: $-.! !

!XpfComplexAttribute methodsFor: 'scanning' stamp: 'mt 5/28/2009 19:10'!
writeScanOn: strm

	strm nextPut: $h.
	self
		writeTimestampOn: strm;
		writeCreatorOn: strm;
		writeTagOn: strm;
		writeChatOn: strm;
		writeCommentOn: strm.
	strm nextPut: $#. "mark end of attribute stream"! !

!XpfComplexAttribute methodsFor: 'scanning' stamp: 'mt 5/1/2009 14:34'!
writeTagOn: strm

	strm nextPutAll: (self tag ifNil: [$0]).
	strm nextPut: $-.! !

!XpfComplexAttribute methodsFor: 'scanning' stamp: 'mt 5/2/2009 16:08'!
writeTimestampOn: strm

	strm nextPutAll: self timestamp printString toHex.
	strm nextPut: $-.! !

StandardWindow subclass: #XpfCtTagAnalysisMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Morphs'!

!XpfCtTagAnalysisMorph class methodsFor: 'defaults' stamp: 'mt 5/9/2009 17:20'!
defaultControlWidth

	^ 150! !

!XpfCtTagAnalysisMorph class methodsFor: 'defaults' stamp: 'mt 5/9/2009 17:47'!
defaultExtent

	^ 500@280! !

!XpfCtTagAnalysisMorph class methodsFor: 'opening' stamp: 'mt 5/9/2009 17:20'!
open

	^ self new openInWorld extent: self defaultExtent! !

!XpfCtTagAnalysisMorph class methodsFor: 'opening' stamp: 'mt 5/9/2009 17:20'!
prototypicalToolWindow
	"Used in flaps."
	
	^ self new extent: self defaultExtent! !

!XpfCtTagAnalysisMorph class methodsFor: 'accessing' stamp: 'mt 5/9/2009 17:20'!
title

	^ 'Markup analysis'! !

!XpfCtTagAnalysisMorph methodsFor: 'controls' stamp: 'mt 5/9/2009 17:26'!
analysisButton

	^ (self
		newButtonFor: self model
		getState: nil
		action: #startStop
		arguments: nil
		getEnabled: #canAnalyze
		getLabel: #label
		help: 'Click here to start analysis.')
		hResizing: #spaceFill! !

!XpfCtTagAnalysisMorph methodsFor: 'controls' stamp: 'mt 5/9/2009 17:46'!
diagram

	^ XpfCtDiagramMorph new
		dimensions: (0@5 corner: 100@0);
		addGrid: 10@1;
		addGraph: (XpfCtGraphMorph
			newFor: (XpfCtTestGraphModel newForInspector: self model inspector)
			color: Color red)! !

!XpfCtTagAnalysisMorph methodsFor: 'controls' stamp: 'mt 5/9/2009 17:54'!
filterEntry

	^ (self
		newTextEntryFor: self model
		getText: #filter
		setText: #filter:
		getEnabled: #isNotAnalyzing
		help: nil)
		hResizing: #rigid;
		vResizing: #rigid;
		extent: self class defaultControlWidth@(self theme textFont height + 8);
		autoAccept: true.! !

!XpfCtTagAnalysisMorph methodsFor: 'initialize-release' stamp: 'mt 5/9/2009 17:10'!
initialize

	super initialize.
	self
		addMorph: (self newDialogPanel listDirection: #leftToRight) frame: (0@0 corner: 1@1);
		model: XpfCtTagAnalysisModel new;
		initializeUserInterface.! !

!XpfCtTagAnalysisMorph methodsFor: 'initialize-release' stamp: 'mt 5/9/2009 17:48'!
initializeUserInterface

	self paneMorphs first
		cellInset: 20;
		addMorphBack: ((self newColumn: {
			self newRow: {(self newLabel: 'Repository') hResizing: #spaceFill. self repositoryEntry}.
			self newRow: {(self newLabel: 'Username') hResizing: #spaceFill. self usernameEntry}.
			self newRow: {(self newLabel: 'Password') hResizing: #spaceFill. self passwordEntry}.
			self newRow: {(self newLabel: 'Filter') hResizing: #spaceFill. self filterEntry}.
			self newToolSpacer vResizing: #spaceFill.
			self newSeparator.
			self analysisButton})
			hResizing: #shrinkWrap);
		addMorphBack: self diagram.! !

!XpfCtTagAnalysisMorph methodsFor: 'controls' stamp: 'mt 5/9/2009 17:54'!
passwordEntry

	^ (self
		newTextEntryFor: self model
		getText: #password
		setText: #password:
		getEnabled: #isNotAnalyzing
		help: nil)
		hResizing: #rigid;
		vResizing: #rigid;
		extent: self class defaultControlWidth@(self theme textFont height + 8);
		autoAccept: true.! !

!XpfCtTagAnalysisMorph methodsFor: 'controls' stamp: 'mt 5/9/2009 17:53'!
repositoryEntry

	^ (self
		newTextEntryFor: self model
		getText: #repositoryName
		setText: #repositoryName:
		getEnabled: #isNotAnalyzing
		help: 'Type name of repository in SqueakSource @ HPI.')
		hResizing: #rigid;
		vResizing: #rigid;
		extent: self class defaultControlWidth@(self theme textFont height + 8);
		autoAccept: true.! !

!XpfCtTagAnalysisMorph methodsFor: 'appearance' stamp: 'mt 5/9/2009 17:22'!
title

	^ self class title! !

!XpfCtTagAnalysisMorph methodsFor: 'controls' stamp: 'mt 5/9/2009 17:54'!
usernameEntry

	^ (self
		newTextEntryFor: self model
		getText: #username
		setText: #username:
		getEnabled: #isNotAnalyzing
		help: nil)
		hResizing: #rigid;
		vResizing: #rigid;
		extent: self class defaultControlWidth@(self theme textFont height + 8);
		autoAccept: true.! !

StandardWindow subclass: #XpfCtTagSearchMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Morphs'!

!XpfCtTagSearchMorph class methodsFor: 'defaults' stamp: 'mt 5/5/2009 19:34'!
defaultControlWidth

	^ 150! !

!XpfCtTagSearchMorph class methodsFor: 'defaults' stamp: 'mt 5/5/2009 18:53'!
defaultExtent

	^ 600@350! !

!XpfCtTagSearchMorph class methodsFor: 'opening' stamp: 'mt 5/5/2009 18:53'!
open

	^ self new openInWorld extent: self defaultExtent! !

!XpfCtTagSearchMorph class methodsFor: 'opening' stamp: 'mt 5/5/2009 18:59'!
prototypicalToolWindow
	"Used in flaps."
	
	^ self new extent: self defaultExtent! !

!XpfCtTagSearchMorph class methodsFor: 'accessing' stamp: 'cs 5/4/2009 11:55'!
title

	^ 'Markup finder'! !

!XpfCtTagSearchMorph methodsFor: 'controls' stamp: 'mt 5/5/2009 19:26'!
categoryEditor

	| pt |
	pt := PluggableTextEditorMorph new
		on: self model
		text: #category
		accept: #category:
		readSelection: #categoryLength
		menu: nil;
		font: self theme textFont;
		cornerStyle: self preferredCornerStyle;
		hResizing: #rigid;
		getEnabledSelector: #categoryEnabled;
		borderStyle: (BorderStyle inset width: 1);
		color: Color white;
		alwaysAccept: true;
		vResizing: #rigid;
		hideScrollBarsIndefinitely;
		extent: self class defaultControlWidth@(self theme textFont height + 8);
		setBalloonText: 'Enter category here';
		autoAccept: true.
	pt textMorph
		autoFit: true;
		wrapFlag: true;
		margins: (2@1 corner: 2@1).
	^ pt! !

!XpfCtTagSearchMorph methodsFor: 'layout' stamp: 'cs 5/3/2009 13:25'!
categoryRow

	^ self newRow: {
		(self newLabel: 'Category') hResizing: #spaceFill.
		self categoryEditor}! !

!XpfCtTagSearchMorph methodsFor: 'controls' stamp: 'mt 5/5/2009 19:26'!
classEditor

	| pt |
	pt := (PluggableTextEditorMorph new
		on: self model
		text: #theClass
		accept: #theClass:
		readSelection: #theClassLength
		menu: nil;
		getEnabledSelector: #theClassEnabled;
		font: self theme textFont;
		cornerStyle: self preferredCornerStyle;
		hResizing: #rigid;
		borderStyle: (BorderStyle inset width: 1);
		color: Color white)
		alwaysAccept: true;
		vResizing: #rigid;
		hideScrollBarsIndefinitely;
		extent: self class defaultControlWidth@(self theme textFont height + 8);
		setBalloonText: 'Enter class name here';
		autoAccept: true.
	pt textMorph
		autoFit: true;
		wrapFlag: true;
		margins: (2@1 corner: 2@1).
	^ pt! !

!XpfCtTagSearchMorph methodsFor: 'layout' stamp: 'cs 5/3/2009 12:37'!
classRow

	^ self newRow: {
		(self newLabel: 'Class') hResizing: #spaceFill.
		self classEditor}! !

!XpfCtTagSearchMorph methodsFor: 'layout' stamp: 'mt 5/5/2009 19:25'!
creatorRow

	^ self newRow: {
		(self newLabel: 'Creator') hResizing: #spaceFill.
		(self
			newTextEntryFor: self model
			getText: #creator
			setText: #creator:
			help: 'Enter the initials of the tag''s creator')
			autoAccept: true;
			width: self class defaultControlWidth;
			hResizing: #rigid}! !

!XpfCtTagSearchMorph methodsFor: 'initialization' stamp: 'cs 5/4/2009 11:07'!
initialize

	super initialize.
	self
		addMorph: (self newDialogPanel listDirection: #leftToRight) frame: (0@0 corner: 1@1);
		model: XpfCtTagSearchModel new;
		initializeUserInterface.! !

!XpfCtTagSearchMorph methodsFor: 'initialization' stamp: 'mt 5/6/2009 10:22'!
initializeUserInterface

	self paneMorphs first
		addMorphBack: ((self newColumn: {
			self categoryRow.
			self classRow.
			self tagRow.
			self creatorRow.
			self timeRow.
			self keywordRow.
			self newToolSpacer vResizing: #spaceFill.
			self newSeparator.
			self progressLabel.
			self progressBar.
			self searchButton})
			hResizing: #shrinkWrap);
		addMorphBack: self resultsList.! !

!XpfCtTagSearchMorph methodsFor: 'layout' stamp: 'mt 5/5/2009 19:25'!
keywordRow

	^ self newRow: {
		(self newLabel: 'Keyword') hResizing: #spaceFill.
		(self
			newTextEntryFor: self model
			getText: #keyword
			setText: #keyword:
			help: 'Enter a keyword to search in tag discussions')
			autoAccept: true;
			width: self class defaultControlWidth;
			hResizing: #rigid}! !

!XpfCtTagSearchMorph methodsFor: 'controls' stamp: 'mt 5/5/2009 20:57'!
progressBar

	^ (XpfCtPluggableProgressBarMorph 
		newFor: self model
		value: #progressValue
		max: #progressValueMax)
		hResizing: #spaceFill;
		vResizing: #rigid;
		height: 16! !

!XpfCtTagSearchMorph methodsFor: 'controls' stamp: 'mt 5/6/2009 10:22'!
progressLabel

	^ XpfCtPluggableLabelMorph new
		model: self model;
		labelSelector: #progressString;
		hResizing: #spaceFill! !

!XpfCtTagSearchMorph methodsFor: 'controls' stamp: 'mt 5/5/2009 20:36'!
resultsList

	^ (XpfPluggableListMorph new
			selectionColor: self theme selectionColor;
			font: self theme listFont;
			on: self model
			list: #results
			selected: nil
			changeSelected: #selectResult:
			menu: nil
			keystroke: nil)
			autoDeselect: false;
			cornerStyle: self preferredCornerStyle;
			color: Color white;
			borderStyle: (BorderStyle inset width: 1);
			hResizing: #spaceFill;
			vResizing: #spaceFill;
			setBalloonText: 'Displays search results';
			minWidth: 200! !

!XpfCtTagSearchMorph methodsFor: 'controls' stamp: 'mt 5/5/2009 21:36'!
searchButton

	^ (self
		newButtonFor: self model
		getState: nil
		action: #searchOrStop
		arguments: nil
		getEnabled: #canSearch
		getLabel: #searchButtonLabel
		help: 'Click here to search')
		hResizing: #spaceFill! !

!XpfCtTagSearchMorph methodsFor: 'layout' stamp: 'mt 5/5/2009 19:25'!
tagRow

	| chkCol |
	chkCol := (self newColumn: {})
		width: self class defaultControlWidth;
		hResizing: #rigid.
	
	XpfComplexAttribute tags do: [:tag |
		chkCol addMorphBack:  (self
			newCheckboxFor: self model
			getSelected: ('find{1}' format: {tag capitalized}) asSymbol
			setSelected: ('find{1}:' format: {tag capitalized}) asSymbol
			label: tag asString
			help: ('Find code tagged as {1}' format: {tag}))].
	
	^ self newRow: {
		(self newLabel: 'Tag') hResizing: #spaceFill; vResizing: #spaceFill.
		chkCol}! !

!XpfCtTagSearchMorph methodsFor: 'layout' stamp: 'mt 5/5/2009 19:25'!
timeRow

	^ self newRow: {
		(self newLabel: 'Created Time') hResizing: #spaceFill.
		(self
			newDropListFor: self model
			list: #possibleTimes
			getSelected: #selectedTimeIndex
			setSelected: #selectedTimeIndex:
			help: 'Search for tags created at the specific time')
			hResizing: #rigid;
			vResizing: #rigid;
			extent: self class defaultControlWidth @ 24}! !

!XpfCtTagSearchMorph methodsFor: 'appearance' stamp: 'cs 5/4/2009 11:55'!
title

	^ self class title! !

!String methodsFor: '*xpf-codetalk' stamp: 'mt 5/2/2009 15:52'!
toHex

	^ self
		inject: ''
		into: [:result :char | result, char hex]! !

!OBCmdMultiView methodsFor: '*xpf-codetalk-override' stamp: 'mt 4/28/2009 08:46'!
execute
	|viewType|
	viewType := OBChoiceRequest labels: #(Source Bytecode Decompile PrettyPrint Xpf).
	self styler: SHTextStylerST80 new.
	viewType ifNotNil: [self perform: (#toggle, viewType) asSymbol]! !

!OBCmdMultiView methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 16:05'!
icon

	^ #xpfCtEyeIcon! !

!OBCmdMultiView methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 16:05'!
iconOnly

	^ true! !

!OBCmdMultiView methodsFor: '*xpf-codetalk' stamp: 'cs 1/15/2009 17:24'!
styler: styler
	| panel morph |
	
	panel := requestor browser panels 
		detect: [ :each | each isKindOf: OBDefinitionPanel ]
		ifNone: [ ^ self ].
	morph := OBPluggableTextMorph allSubInstances
		detect: [ :each | each model == panel ]
		ifNone: [ ^ self ].
	morph styler: (styler
		view: morph;
		yourself).! !

!OBCmdMultiView methodsFor: '*xpf-codetalk' stamp: 'topa 2/13/2009 13:47'!
toggleXpf

	self styler: XpfTextStyler new.
	self setTextInDefinitionPanel: target source.! !

!OBEnhancementButtonBar methodsFor: '*xpf-codetalk-override' stamp: 'mt 5/30/2009 16:28'!
adoptPaneColor: aColor
	(self submorphs reject: [:ea | ea isKindOf: OBBackButtonMorph]) do: [:ea | 
		(ea isKindOf: PluggableButtonMorphPlus)
			ifTrue: [ea onColor: aColor offColor: aColor whiter]].
	super adoptPaneColor: aColor! !

!OBEnhancementButtonBar methodsFor: '*xpf-codetalk-override' stamp: 'mt 5/30/2009 16:28'!
updateCommands
	self removeAllMorphs.
	
	self
		addMorphBack: model createBackButton;
		addMorphBack: model createForwardButton;
		addButtons.! !

OBPaneScroller subclass: #XpfCtPaneScroller
	instanceVariableNames: 'firstColumnWidth'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Morphs'!

!XpfCtPaneScroller commentStamp: 'mt 6/5/2009 15:51' prior: 0!
Just like OBPaneScroller but gives the first column a fixed space.!

!XpfCtPaneScroller methodsFor: 'accessing' stamp: 'mt 6/5/2009 16:01'!
firstColumnWidth

	firstColumnWidth ifNil: [firstColumnWidth := (Preferences standardListFont widthOf: $x) * 15].
	^ firstColumnWidth! !

!XpfCtPaneScroller methodsFor: 'accessing' stamp: 'mt 6/5/2009 15:55'!
firstColumnWidth: anObject

	firstColumnWidth := anObject.! !

!XpfCtPaneScroller methodsFor: 'layout' stamp: 'mt 6/5/2009 15:59'!
paneWidthsToFit: limit
	| padded newLimit |
	padded := Array new: self paneCount.
	newLimit := limit - self firstColumnWidth.
	padded atAllPut: (newLimit / (self sizing - 1)) floor.
	padded at: 1 put: self firstColumnWidth.
	(1 to: limit - padded sum) do: [:i | padded at: i put: (padded at: i) + 1].
	^ padded! !

OBLazyListMorph subclass: #XpfLazyListMorph
	instanceVariableNames: 'showCategories'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Kernel'!

!XpfLazyListMorph methodsFor: 'displaying' stamp: 'mt 5/5/2009 14:48'!
display: item  atRow: row on: canvas
	"display the given item at row row"
	| drawBounds top icon node |
	drawBounds := self drawBoundsForRow: row.
	drawBounds := drawBounds intersect: self bounds.
	node := listSource model children at: row.
	
	(listSource backgroundColorAt: row) ifNotNilDo: [:aColor | canvas fillRectangle: drawBounds color: aColor].

	"(node isKindOf: OBClassNode)
		ifTrue: [
			self indicateMarkupForClass: node on: canvas in: drawBounds.
			drawBounds := drawBounds left: drawBounds left + 2 + 6]."
	
	(listSource iconAt: row) ifNotNilDo: 
		[:name |
		icon := OBMorphicIcons iconNamed: name.
		top := drawBounds top + (drawBounds height - icon height // 2).
		canvas translucentImage: icon at: drawBounds left @ top.
		drawBounds := drawBounds left: drawBounds left + icon width + 2].
		
	item isText
		ifTrue: [canvas
			drawString: item
			in: drawBounds
			font: (font emphasized: (item emphasisAt: 1))
			color: (self colorForRow: row).
			drawBounds := drawBounds left: drawBounds left + ((font emphasized: (item emphasisAt: 1)) widthOfString: item)]
		ifFalse: [canvas
			drawString: item
			in: drawBounds
			font: font
			color: (self colorForRow: row).
			drawBounds := drawBounds left: drawBounds left + (font widthOfString: item)].

	(node isKindOf: OBMethodNode) "& (row ~= selectedRow)"
		ifTrue: [drawBounds := self
			displayCategoryFor: node
			in: drawBounds
			on: canvas].
		
	(node isKindOf: OBMethodNode)
		ifTrue: [
			drawBounds := self
				indicateMarkupFor: node
				on: canvas
				in: drawBounds].! !

!XpfLazyListMorph methodsFor: 'displaying' stamp: 'mt 5/5/2009 14:59'!
displayCategoryFor: aMethodNode in: drawBounds on: aCanvas

	| txt |
	self updateProperties.
	aMethodNode theClass == nil ifTrue: [^ drawBounds].
	
	txt := ' ({1})' format: {aMethodNode categoryText}.
	showCategories ifTrue: [aCanvas
		drawString: txt
		in: drawBounds
		font: font
		color: ((aMethodNode categoryText = 'as yet unclassified')
			ifTrue: [Color red]
			ifFalse: [Color gray])].
		
	^ drawBounds left: drawBounds left + (font widthOfString: txt asString) + 2! !

!XpfLazyListMorph methodsFor: 'displaying' stamp: 'mt 5/28/2009 20:00'!
indicateMarkupFor: aMethodNode on: aCanvas in: drawBounds

	| icon top newBounds |
	aMethodNode theClass ifNil: [^ drawBounds].
	
	newBounds := drawBounds.
	(aMethodNode sourceText asText attributesOfKind: XpfComplexAttribute)
		do: [ :attr |
			icon := attr tag = #bad
				ifTrue: [MenuIcons xpfCtSmallMarkBadIcon]
				ifFalse: [attr tag = #comment
					ifTrue: [MenuIcons xpfCtSmallAddCommentIcon]
					ifFalse: [MenuIcons xpfCtSmallMarkCommentIcon]].
			top := newBounds top + (newBounds height - icon height // 2) + 1.
			aCanvas translucentImage: icon at: newBounds left @ top.
			newBounds := newBounds left: newBounds left + icon width].
	^ newBounds! !

!XpfLazyListMorph methodsFor: 'displaying' stamp: 'mt 5/5/2009 14:56'!
indicateMarkupForClass: aClassNode on: aCanvas in: drawBounds

	| left top icon |
	(aClassNode methods anySatisfy: [:node | node source asText includesAttributesOfKind: XpfComplexAttribute])
		ifTrue: [
			icon := MenuIcons markGoodIcon.
			top := drawBounds top + (drawBounds height - icon height // 2).
			left := drawBounds left - 5.
			aCanvas
				translucentImage: icon
				at: left @ top].! !

!XpfLazyListMorph methodsFor: 'accessing' stamp: 'mt 5/1/2009 17:03'!
updateProperties

	showCategories ifNil: [showCategories := 
		(Preferences
			preferenceAt: #showProtocolForMessage
			ifAbsent: [Preference new rawValue: false])
			preferenceValue].! !

!MethodReference methodsFor: '*xpf-codetalk' stamp: 'mt 6/2/2009 15:07'!
theClassName

	^ '{1}{2}' format: {
		self classSymbol.
		self classIsMeta
			ifTrue: [' class']
			ifFalse: ['']}! !

!Text methodsFor: '*xpf-codetalk' stamp: 'mt 5/1/2009 17:00'!
attributesOfKind: anAttrClass
	"Return a collection with all instances of the given attribute class that can be found in this text."
	
	| result |
	result := OrderedCollection new.
	runs values do: [:array |
		array do: [:attr | (attr isKindOf: anAttrClass)
			ifTrue: [result addIfNotPresent: attr]]].
	^ result! !

!Text methodsFor: '*xpf-codetalk' stamp: 'mt 5/18/2009 11:16'!
attributesOfKind: anAttrClass from: start to: stop
	"Return a collection with all instances of the given attribute class that can be found in the specified range."
	
	| part result |
	start > stop ifTrue: [
		^ (self attributesAt: start) select: [:attr | attr isKindOf: anAttrClass]].
	
	result := OrderedCollection new.
	part := self copyFrom: start to: stop.
	part runs withStartStopAndValueDo: [:i :j :attributes |
		attributes
			select: [:attr | attr isKindOf: anAttrClass]
			thenDo: [:attr | result addIfNotPresent: attr]].
	^ result.! !

!Text methodsFor: '*xpf-codetalk' stamp: 'mt 5/1/2009 14:01'!
includesAttributesOfKind: anAttrClass
	"Check whether this text has at least one run that includes an attribute of the given class."
	
	runs values do: [:array |
		array do: [:attr | (attr isKindOf: anAttrClass) ifTrue: [^ true]]].
	^ false! !

!Text methodsFor: '*xpf-codetalk' stamp: 'mt 5/3/2009 18:37'!
includesAttributesOfKind: anAttrClass from: start to: stop
	"Check whether this text has at least one run that includes an attribute of the given class in the specified range."
	
	| part |
	part := self copyFrom: start to: stop.
	part runs values do: [:array |
		array do: [:attr | (attr isKindOf: anAttrClass) ifTrue: [^ true]]].
	^ false! !

!Text methodsFor: '*xpf-codetalk' stamp: 'mt 5/1/2009 17:08'!
removeAttribute: attr
	
	self removeAttribute: attr from: 1 to: self size.! !

!Text methodsFor: '*xpf-codetalk' stamp: 'mt 5/1/2009 13:56'!
removeAttribute: anAttribute around: index
	
	self removeAttribute: anAttribute around: index and: index.! !

!Text methodsFor: '*xpf-codetalk' stamp: 'mt 5/1/2009 15:08'!
removeAttribute: anAttribute around: leftIndex and: rightIndex
	"Remove the given attribute from all indices that are adjacent to the given ones."

	| start stop |
	start := leftIndex.
	[start > 0 and: [(self attributesAt: start) includes: anAttribute]]
		whileTrue: [start := start - 1].
	stop := rightIndex.
	[stop <= self size and: [(self attributesAt: stop) includes: anAttribute]]
		whileTrue: [stop := stop + 1].

	self removeAttribute: anAttribute from: (start max: 0) to: (stop min: runs size).! !

!Text methodsFor: '*xpf-codetalk' stamp: 'mt 5/1/2009 17:08'!
removeAttribute: attr from: start to: stop
	"Removes an attribute kind over the interval start to stop."
	
	runs := runs
		copyReplaceFrom: start
		to: stop
		with: ((runs copyFrom: start to: stop)	mapValues:
			[:attributes | attributes reject: [:each | each = attr]])! !

!OBCmdBrowseHierarchy methodsFor: '*xpf-codetalk-override' stamp: 'mt 5/30/2009 15:59'!
buttonLabelWithSpaces

	^ super buttonLabelWithSpaces! !

!OBCmdBrowseHierarchy methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 15:41'!
icon

	^ #xpfCtChartOrganisationIcon! !

!OBCmdBrowseHierarchy methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 15:42'!
iconOnly

	^ true! !

Object subclass: #XpfCodeTalk
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Kernel'!

!XpfCodeTalk class methodsFor: 'services' stamp: 'mt 6/6/2009 09:11'!
highlightAuthorInitialsFor: aText
	"Look for this image's author initials and highlight them. This will modify the attributse of the given text."
	
	| rx s strm links |
	rx := ('\\<{1}\\>' format: {Utilities authorInitials}) asRegex.
	s := aText asString.
	strm := s readStream.
	links := OrderedCollection new.
	
	[rx searchStream: strm]
		whileTrue: [
			links add: {
				rx subBeginning: 1.
				rx subEnd: 1}].

	links do: [:link |
		aText
			addAttribute: TextColor red
			from: link first + 1
			to: link second.
		aText
			addAttribute: TextEmphasis bold
			from: link first + 1
			to: link second].
		
	^ aText! !

!XpfCodeTalk class methodsFor: 'initialization' stamp: 'mt 5/26/2009 13:00'!
initialize
	"Resend this message whenever you checkout a new version of CodeTalk."
	
	super initialize.
	self
		initializeMonticello;
		initializePreferences;
		initializeOtherClasses;
		registerInToolsFlap;
		registerInWorldMenu.! !

!XpfCodeTalk class methodsFor: 'initialization' stamp: 'mt 5/2/2009 09:26'!
initializeMonticello

	(MCMethodDefinition allInstVarNames includes: #sourceText)
		ifFalse:[MCMethodDefinition addInstVarName: #sourceText].! !

!XpfCodeTalk class methodsFor: 'initialization' stamp: 'mt 5/30/2009 17:03'!
initializeOtherClasses
	
	(Smalltalk includesKey: #XpfEditor)
		ifTrue: [XpfEditor initializeCmdKeyShortcuts].
		
	(Smalltalk includesKey: #XpfComplexAttribute)
		ifTrue: [XpfComplexAttribute reset].
		
	((Smalltalk includesKey: #OBButtonModel) and: [(OBButtonModel allInstVarNames includes: #icon) not])
		ifTrue:[OBButtonModel addInstVarName: #icon].
		
	((Smalltalk includesKey: #OBButtonModel) and: [(OBButtonModel allInstVarNames includes: #iconOnly) not])
		ifTrue:[OBButtonModel addInstVarName: #iconOnly].	! !

!XpfCodeTalk class methodsFor: 'initialization' stamp: 'mt 6/2/2009 18:16'!
initializePreferences
		
	(Preferences dictionaryOfPreferences includesKey: #showLineNumbers)
		ifFalse: [Preferences
			addBooleanPreference: #showLineNumbers
			category: #CodeTalk
			default: false
			balloonHelp: 'Enables line numbers in front of each codeline.'].
		
	(Preferences dictionaryOfPreferences includesKey: #showProtocolForMessage)
		ifFalse: [Preferences
			addBooleanPreference: #showProtocolForMessage
			category: #CodeTalk
			default: false
			balloonHelp: 'Displays the protocol name after each message name in the code browser.'].
		
	(Preferences dictionaryOfPreferences includesKey: #browseMarkupsAfterLoadMerge)
		ifFalse: [Preferences
			addBooleanPreference: #browseMarkupsAfterLoadMerge
			category: #CodeTalk
			default: true
			balloonHelp: 'Brings up the markup browser for the current Monticello package after a merge or a load.'].
	
	(Preferences dictionaryOfPreferences includesKey: #useMoreIconsForCommands)
		ifFalse: [Preferences
			addBooleanPreference: #useMoreIconsForCommands
			category: #CodeTalk
			default: true
			balloonHelp: 'Saves a little space and improves usability in the code browser by adding icons to command buttons.'].
	
	(Preferences dictionaryOfPreferences includesKey: #showCodeTalkToolbar)
		ifFalse: [Preferences
			addBooleanPreference: #showCodeTalkToolbar
			category: #CodeTalk
			default: true
			balloonHelp: 'Show a convenient toolbar for markups in the package browser.'].
		
	(Preferences dictionaryOfPreferences includesKey: #rememberMarkupReads)
		ifFalse: [Preferences
			addBooleanPreference: #rememberMarkupReads
			category: #CodeTalk
			default: true
			balloonHelp: 'Shows markups differently in markup browser that have been already read.'].

	Preferences setPreference: #confirmFirstUseOfStyle toValue: false.
	Preferences setPreference: #alwaysShowVScrollbar toValue: false.! !

!XpfCodeTalk class methodsFor: 'as yet unclassified' stamp: 'mt 5/9/2009 17:30'!
registerInToolsFlap

	self environment at: #Flaps ifPresent: [ :class |
		class
			registerQuad: {
				#XpfCtTagSearchMorph.
				#prototypicalToolWindow.
				XpfCtTagSearchMorph title.
				'A tool for discovering methods that contains different kind of markup'}
			forFlapNamed: 'Tools';
			replaceToolsFlap.
		class
			registerQuad: {
				#XpfCtTagAnalysisMorph.
				#prototypicalToolWindow.
				XpfCtTagAnalysisMorph title.
				'A tool for analyze markup of methods'}
			forFlapNamed: 'Tools';
			replaceToolsFlap].! !

!XpfCodeTalk class methodsFor: 'as yet unclassified' stamp: 'mt 5/9/2009 17:30'!
registerInWorldMenu

	self environment at: #TheWorldMenu ifPresent: [ :class |
		class registerOpenCommand: {
			XpfCtTagSearchMorph title.
			{XpfCtTagSearchMorph. #open}}.
		class registerOpenCommand: {
			XpfCtTagAnalysisMorph title.
			{XpfCtTagAnalysisMorph. #open}}]! !

!XpfCodeTalk class methodsFor: 'as yet unclassified' stamp: 'mt 5/30/2009 10:39'!
todoClass

	"Dummy."! !

!XpfCodeTalk methodsFor: 'testing' stamp: 'mt 6/5/2009 15:17'!
todoTakeTwo

	"Featulre cchamt:h herhe."! !

Object subclass: #XpfCtCodeChatModel
	instanceVariableNames: 'attribute searchString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Models'!

!XpfCtCodeChatModel methodsFor: 'adding' stamp: 'mt 5/3/2009 14:14'!
addMessage: aMessage

	aMessage ifEmpty: [^ self].
	self attribute ifNil: [^ self].
	self attribute addChatLine: aMessage.
	self
		changed: #messages;
		changed: #newMessage;
		changed: #lastIndex;
		changed: #hasMessages.! !

!XpfCtCodeChatModel methodsFor: 'accessing' stamp: 'mt 4/29/2009 22:22'!
attribute

	^ attribute! !

!XpfCtCodeChatModel methodsFor: 'accessing' stamp: 'mt 4/29/2009 22:22'!
attribute: anXpfComplexAttribute

	attribute := anXpfComplexAttribute.
	self changed: #messages.! !

!XpfCtCodeChatModel methodsFor: 'accessing' stamp: 'mt 5/3/2009 14:14'!
hasMessages

	^ self attribute notNil and: [self attribute chat isEmpty not].! !

!XpfCtCodeChatModel methodsFor: 'accessing' stamp: 'mt 5/1/2009 18:39'!
lastIndex
	"Used to show the latest message"
	
	self attribute ifNil: [^ 0].
	^ self attribute chat size! !

!XpfCtCodeChatModel methodsFor: 'accessing' stamp: 'mt 5/3/2009 14:05'!
messages

	self attribute ifNil: [^ #()].
	
	^ self attribute chat collect: [:line | | msgMorph |
		msgMorph := XpfCtMessageMorph
		timestamp: (line at: #timestamp)
		author: (line at: #author)
		message: (line at: #message).
		self searchString ifNotEmpty: [msgMorph highlightIf: self searchString].
		msgMorph]! !

!XpfCtCodeChatModel methodsFor: 'accessing' stamp: 'mt 5/1/2009 18:07'!
newMessage

	^ ''! !

!XpfCtCodeChatModel methodsFor: 'accessing' stamp: 'mt 5/3/2009 13:58'!
searchString

	searchString ifNil: [searchString := ''].
	^ searchString! !

!XpfCtCodeChatModel methodsFor: 'accessing' stamp: 'mt 5/3/2009 14:21'!
searchString: aString

	searchString := aString.
	self changed: #messages.! !

Object subclass: #XpfCtCommentEditorModel
	instanceVariableNames: 'attribute'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Models'!

!XpfCtCommentEditorModel methodsFor: 'accessing' stamp: 'mt 5/28/2009 19:36'!
attribute

	^ attribute! !

!XpfCtCommentEditorModel methodsFor: 'accessing' stamp: 'mt 5/28/2009 20:07'!
attribute: anObject

	attribute := anObject.
	self changed: #comment.! !

!XpfCtCommentEditorModel methodsFor: 'accessing' stamp: 'mt 6/5/2009 13:43'!
comment

	self attribute ifNil: [^ ''].
	^ XpfCtMethodLink addMethodLinksInto: self attribute comment asText! !

!XpfCtCommentEditorModel methodsFor: 'accessing' stamp: 'mt 5/28/2009 20:03'!
comment: aString

	self attribute comment: aString.! !

Object subclass: #XpfCtGraphModel
	instanceVariableNames: 'inspector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Models'!

!XpfCtGraphModel class methodsFor: 'instance creation' stamp: 'mt 5/9/2009 14:18'!
newForInspector: anMczInspector

	^ self new
		inspector: anMczInspector! !

!XpfCtGraphModel methodsFor: 'accessing' stamp: 'mt 5/9/2009 14:19'!
inspector

	^ inspector! !

!XpfCtGraphModel methodsFor: 'accessing' stamp: 'mt 5/9/2009 14:02'!
inspector: anObject

	self inspector ifNotNilDo: [:i | i removeDependent: self].
	inspector := anObject.
	self inspector ifNotNilDo: [:i | i addDependent: self].! !

!XpfCtGraphModel methodsFor: 'processing' stamp: 'mt 5/9/2009 15:56'!
processFinish

	self subclassResponsiblity.! !

!XpfCtGraphModel methodsFor: 'processing' stamp: 'mt 5/9/2009 14:07'!
processResult: aDictionary

	self subclassResponsiblity.! !

!XpfCtGraphModel methodsFor: 'processing' stamp: 'mt 5/9/2009 14:55'!
reset

	self changed: #reset.! !

!XpfCtGraphModel methodsFor: 'updating' stamp: 'mt 5/9/2009 15:56'!
update: aSymbol

	super update: aSymbol.
	aSymbol = #isRunning ifTrue: [
		self inspector isRunning ifTrue: [self reset]].
	aSymbol = #done ifTrue: [self processFinish].	! !

!XpfCtGraphModel methodsFor: 'updating' stamp: 'mt 5/9/2009 14:07'!
update: aSymbol with: aDictionary

	super update: aSymbol with: aDictionary.
	aSymbol = #resultFound ifTrue: [self processResult: aDictionary].! !

XpfCtGraphModel subclass: #XpfCtTestGraphModel
	instanceVariableNames: 'versionCount attributeCount currentVersionName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Models'!

!XpfCtTestGraphModel methodsFor: 'initialize-release' stamp: 'mt 5/9/2009 15:57'!
initialize

	super initialize.
	self resetCache.! !

!XpfCtTestGraphModel methodsFor: 'processing' stamp: 'mt 5/15/2009 14:46'!
pointFound

	versionCount > 0
		ifTrue: [self changed: #newPoint with: versionCount@attributeCount].! !

!XpfCtTestGraphModel methodsFor: 'processing' stamp: 'mt 5/15/2009 14:39'!
processFinish

	self pointFound.! !

!XpfCtTestGraphModel methodsFor: 'processing' stamp: 'mt 5/15/2009 14:39'!
processResult: aDictionary

	currentVersionName ifEmpty: [
		currentVersionName := (aDictionary at: #info) name.
		attributeCount := (aDictionary at: #attributes) size.
		versionCount := ((aDictionary at: #info) name findTokens: $.) last asNumber.
		^ self].

	currentVersionName = (aDictionary at: #info) name
		ifTrue: [
			attributeCount := attributeCount + (aDictionary at: #attributes) size]
		ifFalse: [
			self pointFound.
			versionCount := ((aDictionary at: #info) name findTokens: $.) last asNumber.
			currentVersionName := (aDictionary at: #info) name.
			attributeCount := (aDictionary at: #attributes) size].! !

!XpfCtTestGraphModel methodsFor: 'processing' stamp: 'mt 5/9/2009 15:57'!
reset

	super reset.
	self resetCache.! !

!XpfCtTestGraphModel methodsFor: 'processing' stamp: 'mt 5/9/2009 15:57'!
resetCache

	versionCount := 0.
	attributeCount := 0.
	currentVersionName := ''.! !

Object subclass: #XpfCtMczCache
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Models'!

!XpfCtMczCache class methodsFor: 'private' stamp: 'mt 5/15/2009 14:28'!
addMczToCache: aStream at: aMczFileName
	"Need to write a clean zip."
	
	^ ZipArchive new
		readFrom: aStream;
		writeToFileNamed: (self cacheDirectory fullNameFor: aMczFileName).! !

!XpfCtMczCache class methodsFor: 'private' stamp: 'mt 5/15/2009 14:35'!
cacheAt: aFileName

	^ ZipArchive new
		readFrom: (self cacheDirectory readOnlyFileNamed: aFileName)! !

!XpfCtMczCache class methodsFor: 'caching' stamp: 'mt 5/26/2009 18:48'!
cacheAt: aFileName ifNoneGetFrom: anHttpRepository
	"Return a zip archive for the mcz file."

	^ (self includes: aFileName)
		ifTrue: [self cacheAt: aFileName]
		ifFalse: [
			anHttpRepository
				readStreamForFileNamed: aFileName
				do: [:strm | self addMczToCache: strm at: aFileName]]! !

!XpfCtMczCache class methodsFor: 'private' stamp: 'mt 5/15/2009 12:45'!
cacheDirectory

	^ (FileDirectory default directoryNamed: 'codetalk-cache')
		assureExistence;
		yourself! !

!XpfCtMczCache class methodsFor: 'private' stamp: 'mt 5/15/2009 13:25'!
includes: aFileName

	^ self cacheDirectory includesKey: aFileName! !

Object subclass: #XpfCtMczInspector
	instanceVariableNames: 'repositories isRunning process reader currentMethodDefinition followAncestors currentAncestors classFilter selectorFilter lastDefinition currentStep maxSteps'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Models'!

XpfCtMczInspector class
	instanceVariableNames: 'exampleCache'!

XpfCtMczInspector class
	instanceVariableNames: 'exampleCache'!

!XpfCtMczInspector class methodsFor: 'examples' stamp: 'mt 5/19/2009 13:31'!
exampleVersions

	| instance result repo |
	exampleCache ifNotNilDo: [:c | ^ c].
	
	result := OrderedCollection new.
	instance := self newForPackageNamed: 'Xpf-CodeTalk'.
	repo := instance repositories first key.
	(repo readableFileNames
		select: [:filename | filename startsWith: 'Xpf-CodeTalk'])
		do: [:filename |
			instance zip: (XpfCtMczCache
				cacheAt: filename
				ifNoneGetFrom: repo).
			instance loadVersionInfo.
			
			(instance zip memberNamed: 'snapshot.bin') ifNotNilDo: [:bin |
			[(DataStream on: bin contentStream) next definitions
				select: [:def | def isMethodDefinition and: [def className = 'XpfCodeTalk' and: [def selector = #todo]]]
				thenDo: [:def | result add: (XpfCtRemoteMethodVersion
					repository: repo
					info: instance info
					definition: def)]]
				on: Error
				do: [:fallThrough | "Unknown content in snapshot.bin!!"]]] displayingProgress: 'Preparing...'.
	exampleCache := result.
	^ result! !

!XpfCtMczInspector class methodsFor: 'instance creation' stamp: 'mt 5/19/2009 11:52'!
newForPackageNamed: aString

	| instance pkg |
	instance := self new.
	pkg := MCPackage named: aString.
	pkg hasWorkingCopy ifTrue: [pkg workingCopy repositoryGroup repositories
		select: [:r | r isKindOf: MCHttpRepository]
		thenDo: [:r | instance addRepository: r include: {aString}]].
	^ instance! !

!XpfCtMczInspector methodsFor: 'adding repos' stamp: 'mt 5/9/2009 12:22'!
addRepository: anHttpRepository include: somePackageNames
	"Add the given repo and decide which packages to use when looking at the contents of the repo later."
	
	self repositories add: (anHttpRepository -> somePackageNames).! !

!XpfCtMczInspector methodsFor: 'accessing' stamp: 'mt 6/3/2009 11:05'!
currentAncestors

	^ currentAncestors
		ifNil: [currentAncestors := Set new]! !

!XpfCtMczInspector methodsFor: 'accessing status' stamp: 'mt 5/27/2009 10:02'!
currentStep

	currentStep ifNil: [currentStep := 1].
	^ currentStep! !

!XpfCtMczInspector methodsFor: 'accessing status' stamp: 'mt 5/27/2009 10:03'!
currentStep: anObject

	currentStep := anObject.
	self changed: #currentStep.! !

!XpfCtMczInspector methodsFor: 'inspecting' stamp: 'mt 5/26/2009 18:41'!
filterFileNames: someFileNames packages: somePackageNames

	| result |
	result := (someFileNames
		select: [:filename | somePackageNames anySatisfy: [:name | filename startsWith: name]])
		sortBy: [:f1 :f2 | (f1 findTokens: $.) second asNumber > (f2 findTokens: $.) second asNumber].
	
	^ self followAncestors
		ifTrue: [result]
		ifFalse: [result reversed]! !

!XpfCtMczInspector methodsFor: 'accessing' stamp: 'mt 5/13/2009 14:14'!
followAncestors

	followAncestors ifNil: [self followAncestors: false].
	^ followAncestors! !

!XpfCtMczInspector methodsFor: 'accessing' stamp: 'mt 5/13/2009 14:13'!
followAncestors: anObject

	followAncestors := anObject.! !

!XpfCtMczInspector methodsFor: 'inspecting' stamp: 'mt 5/26/2009 18:23'!
inspectDefinitions

	(self reader definitions detect: [:def |
		def isMethodDefinition
			and: [classFilter = def actualClass
			and: [selectorFilter = def selector]]]	ifNone: [])
		ifNotNilDo: [:def |
			lastDefinition = def ifFalse:[ 
				self changed: #versionFound with: (Dictionary newFrom: {
				#repository -> self reader repository.
				#definition -> def.
				#info -> self reader info})].
			lastDefinition := def].! !

!XpfCtMczInspector methodsFor: 'inspecting' stamp: 'mt 6/3/2009 11:08'!
inspectRepository: anHttpRepository include: somePackageNames

	| filenames |
	filenames := (self
		filterFileNames: anHttpRepository readableFileNames
		packages: somePackageNames).
	
	self maxSteps: filenames size.		
	filenames withIndexDo: [:filename :i |	
		self currentStep: i.
		self reader readFile: filename from: anHttpRepository.
		self followAncestors
			ifFalse: [self inspectDefinitions]
			ifTrue: [
				(self currentAncestors isEmpty or: [self currentAncestors anySatisfy: [:anc | anc name = self reader info name]])
					ifTrue: [self inspectDefinitions].
				self updateCurrentAncestry]].! !

!XpfCtMczInspector methodsFor: 'inspecting' stamp: 'mt 5/26/2009 13:42'!
inspectSourceText: aText

	| result |
	result := aText attributesOfKind: XpfComplexAttribute.

	self changed: #resultFound with: (Dictionary newFrom: {
		#repository -> self reader repository.
		#definition -> currentMethodDefinition.
		#info -> self reader info.
		#attributes -> result}).! !

!XpfCtMczInspector methodsFor: 'inspecting' stamp: 'mt 5/26/2009 13:42'!
inspectVersionsFor: aSelector in: aClass

	classFilter := aClass.
	selectorFilter := aSelector.
	self followAncestors: true.
	self start.! !

!XpfCtMczInspector methodsFor: 'accessing' stamp: 'mt 5/9/2009 12:03'!
isRunning

	isRunning ifNil: [self isRunning: false].
	^ isRunning! !

!XpfCtMczInspector methodsFor: 'accessing' stamp: 'mt 5/9/2009 12:03'!
isRunning: anObject

	isRunning := anObject.
	self changed: #isRunning.! !

!XpfCtMczInspector methodsFor: 'accessing status' stamp: 'mt 5/27/2009 10:02'!
maxSteps

	maxSteps ifNil: [maxSteps := 1].
	^ maxSteps! !

!XpfCtMczInspector methodsFor: 'accessing status' stamp: 'mt 5/27/2009 10:03'!
maxSteps: anObject

	maxSteps := anObject.
	self changed: #maxSteps.! !

!XpfCtMczInspector methodsFor: 'debugging' stamp: 'mt 5/26/2009 13:48'!
print

	Transcript show: ('Next Result: {1}>>{2} ({3}) - {4}' format: {
		currentMethodDefinition className.
		currentMethodDefinition selector.
		currentMethodDefinition category.
		self reader info name}); cr.! !

!XpfCtMczInspector methodsFor: 'accessing' stamp: 'mt 5/26/2009 13:37'!
reader

	reader ifNil: [reader := XpfCtMczReader new].
	^ reader! !

!XpfCtMczInspector methodsFor: 'accessing' stamp: 'mt 5/9/2009 12:01'!
repositories

	repositories ifNil: [self repositories: OrderedCollection new].
	^ repositories! !

!XpfCtMczInspector methodsFor: 'accessing' stamp: 'mt 5/9/2009 12:01'!
repositories: anObject

	repositories := anObject.! !

!XpfCtMczInspector methodsFor: 'inspecting' stamp: 'mt 6/3/2009 11:14'!
start

	process ifNotNil: [self stop].
	process := [
		self isRunning: true.
		self repositories do: [:repo |
			self
				inspectRepository: repo key
				include: repo value.
			currentAncestors := nil].
		self
			isRunning: false;
			changed: #done] fork priority: 20.! !

!XpfCtMczInspector methodsFor: 'inspecting' stamp: 'mt 5/9/2009 12:13'!
stop

	process ifNotNilDo: [:p | p terminate].
	process := nil.
	self isRunning: false.! !

!XpfCtMczInspector methodsFor: 'inspecting' stamp: 'mt 6/3/2009 11:05'!
updateCurrentAncestry

	self reader info ancestors ifNotNilDo: [:newAnc |
		self currentAncestors addAll: newAnc].! !

Object subclass: #XpfCtMczReader
	instanceVariableNames: 'zip info definitions repository'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Models'!

!XpfCtMczReader commentStamp: 'mt 5/26/2009 13:09' prior: 0!
This is a simplified version of the McMczReader.!

!XpfCtMczReader methodsFor: 'reading' stamp: 'mt 5/26/2009 13:11'!
associate: tokens

	| result |
	result := Dictionary new.
	tokens pairsDo: [:key :value | 
					value isString ifFalse: [value := value collect: [:ea | self associate: ea]].
					result at: key put: value].
	^ result! !

!XpfCtMczReader methodsFor: 'accessing' stamp: 'mt 5/26/2009 13:09'!
definitions

	^ definitions! !

!XpfCtMczReader methodsFor: 'accessing' stamp: 'mt 5/26/2009 13:09'!
definitions: anObject

	definitions := anObject.! !

!XpfCtMczReader methodsFor: 'reading' stamp: 'mt 5/26/2009 13:11'!
extractInfoFrom: dict

	^ MCVersionInfo
		name: (dict at: #name ifAbsent: [''])
		id: (UUID fromString: (dict at: #id))
		message: (dict at: #message ifAbsent: [''])
		date: ([Date fromString: (dict at: #date) ] on: Error do: [ :ex | ex return: nil ])
		time: ([ Time fromString:(dict at: #time)] on: Error do: [ :ex | ex return: nil ])
		author: (dict at: #author ifAbsent: [''])
		ancestors: ((dict at: #ancestors ifAbsent: [#()]) collect: [:ea | self extractInfoFrom: ea])
		stepChildren: ((dict at: #stepChildren ifAbsent: [#()]) collect: [:ea | self extractInfoFrom: ea])! !

!XpfCtMczReader methodsFor: 'public' stamp: 'mt 5/26/2009 13:58'!
getDefinitionByClass: aClass selector: aSelector

	^ self definitions
		detect: [:def |
			def actualClass = aClass
				and: [def selector = aSelector]]
		ifNone: []! !

!XpfCtMczReader methodsFor: 'accessing' stamp: 'mt 5/26/2009 13:09'!
info

	^ info! !

!XpfCtMczReader methodsFor: 'accessing' stamp: 'mt 5/26/2009 13:09'!
info: anObject

	info := anObject.! !

!XpfCtMczReader methodsFor: 'reading' stamp: 'mt 5/26/2009 13:17'!
loadDefinitions

	(self zip memberNamed: 'snapshot.bin') ifNotNilDo: [:bin |
		[self	definitions:
			(DataStream on: bin contentStream) next definitions]
		on: Error
		do: [:fallThrough |
			self definitions: OrderedCollection new.
			Transcript show: 'Unknown content in snapshot.bin!!'; cr]].! !

!XpfCtMczReader methodsFor: 'reading' stamp: 'mt 5/26/2009 13:11'!
loadVersionInfo

	info := self extractInfoFrom: (self parseMember: 'version')! !

!XpfCtMczReader methodsFor: 'reading' stamp: 'mt 5/26/2009 13:12'!
parseMember: fileName

	| tokens |
	tokens := (MCScanner scanTokens: (zip contentsOf: fileName)) first.
	^ self associate: tokens! !

!XpfCtMczReader methodsFor: 'public' stamp: 'mt 5/26/2009 13:32'!
readFile: aFilename from: aRepository

	self
		repository: aRepository;
		setZip: (XpfCtMczCache cacheAt: aFilename ifNoneGetFrom: aRepository).! !

!XpfCtMczReader methodsFor: 'accessing' stamp: 'mt 5/26/2009 13:32'!
repository

	^ repository! !

!XpfCtMczReader methodsFor: 'accessing' stamp: 'mt 5/26/2009 13:32'!
repository: anObject

	repository := anObject.! !

!XpfCtMczReader methodsFor: 'public' stamp: 'mt 5/26/2009 13:17'!
setZip: anMczFile

	self
		zip: anMczFile;
		loadVersionInfo;
		loadDefinitions.! !

!XpfCtMczReader methodsFor: 'accessing' stamp: 'mt 5/26/2009 13:09'!
zip

	^ zip! !

!XpfCtMczReader methodsFor: 'accessing' stamp: 'mt 5/26/2009 13:09'!
zip: anObject

	zip := anObject.! !

Object subclass: #XpfCtRemoteMethodVersion
	instanceVariableNames: 'repository definition info'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Models'!

XpfCtRemoteMethodVersion class
	instanceVariableNames: 'cache'!

XpfCtRemoteMethodVersion class
	instanceVariableNames: 'cache'!

!XpfCtRemoteMethodVersion class methodsFor: 'caching' stamp: 'mt 5/26/2009 14:06'!
cache

	cache ifNil: [self cache: 
		(LRUCache
			size: 100
			factory: [:key | | repo reader def |
				repo := MCHttpRepository
					location: key location
					user: key user
					password: key password.
				reader := XpfCtMczReader new.
				reader readFile: key filename from: repo.
				def := reader getDefinitionByClass: key theClass selector: key selector.
				def ifNil: [Error signal].
				Transcript show: 'Factory used.'.
				XpfCtRemoteMethodVersion
					repository: repo
					info: reader info
					definition: (reader getDefinitionByClass: key theClass selector: key selector)])].
	^ cache! !

!XpfCtRemoteMethodVersion class methodsFor: 'caching' stamp: 'mt 5/26/2009 09:47'!
cache: anLRUCache

	cache :=  anLRUCache.! !

!XpfCtRemoteMethodVersion class methodsFor: 'instance creation' stamp: 'mt 5/19/2009 11:38'!
repository: aRepository info: aVersionInfo definition: aMethodDefinition

	^ self new
		repository: aRepository;
		info: aVersionInfo;
		definition: aMethodDefinition! !

!XpfCtRemoteMethodVersion methodsFor: 'accessing' stamp: 'mt 5/19/2009 16:22'!
= other

	^ self species = other species and: [self info timeStamp = other info timeStamp].! !

!XpfCtRemoteMethodVersion methodsFor: 'accessing' stamp: 'mt 5/19/2009 11:28'!
category

	^ self definition category! !

!XpfCtRemoteMethodVersion methodsFor: 'accessing' stamp: 'mt 5/19/2009 11:18'!
definition
	"This should be a Monticello method definition."

	^ definition! !

!XpfCtRemoteMethodVersion methodsFor: 'accessing' stamp: 'mt 5/19/2009 11:17'!
definition: anObject

	definition := anObject.! !

!XpfCtRemoteMethodVersion methodsFor: 'accessing' stamp: 'mt 5/19/2009 16:07'!
fileIn
	(self theClass) ifNotNilDo: [:class | class
						 				compile: self source 
										classified: self category 
										withStamp: self stamp 
										notifying: nil]! !

!XpfCtRemoteMethodVersion methodsFor: 'accessing' stamp: 'mt 5/19/2009 11:18'!
info
	"This should be a Monticello version information object."

	^ info! !

!XpfCtRemoteMethodVersion methodsFor: 'accessing' stamp: 'mt 5/19/2009 11:17'!
info: anObject

	info := anObject.! !

!XpfCtRemoteMethodVersion methodsFor: 'accessing' stamp: 'mt 5/19/2009 11:17'!
repository

	^ repository! !

!XpfCtRemoteMethodVersion methodsFor: 'accessing' stamp: 'mt 5/19/2009 11:17'!
repository: anObject

	repository := anObject.! !

!XpfCtRemoteMethodVersion methodsFor: 'accessing' stamp: 'mt 5/19/2009 11:24'!
selector

	^ self definition selector! !

!XpfCtRemoteMethodVersion methodsFor: 'accessing' stamp: 'mt 5/19/2009 15:36'!
source

	^ self sourceText! !

!XpfCtRemoteMethodVersion methodsFor: 'accessing' stamp: 'mt 5/19/2009 11:26'!
sourceText

	^ self definition sourceText! !

!XpfCtRemoteMethodVersion methodsFor: 'accessing' stamp: 'mt 5/25/2009 14:06'!
stamp

	^ self definition timeStamp! !

!XpfCtRemoteMethodVersion methodsFor: 'accessing' stamp: 'mt 5/19/2009 11:24'!
theClass

	^ self definition actualClass! !

!XpfCtRemoteMethodVersion methodsFor: 'accessing' stamp: 'mt 5/19/2009 15:38'!
theClassName

	^ self definition className! !

Object subclass: #XpfCtRemoteVersionKey
	instanceVariableNames: 'theClass selector filename user password location'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Models'!

!XpfCtRemoteVersionKey methodsFor: 'comparing' stamp: 'mt 5/26/2009 14:01'!
= other

	^ self species = other species
		and: [self theClass = other theClass
		and: [self selector = other selector
		and: [self filename = other filename
		and: [self user = other user
		and: [self password = other password
		and: [self location = other location]]]]]]! !

!XpfCtRemoteVersionKey methodsFor: 'accessing' stamp: 'mt 5/26/2009 10:09'!
filename

	^ filename! !

!XpfCtRemoteVersionKey methodsFor: 'accessing' stamp: 'mt 5/26/2009 10:09'!
filename: anObject

	filename := anObject.! !

!XpfCtRemoteVersionKey methodsFor: 'comparing' stamp: 'mt 5/26/2009 14:01'!
hash

	^ self theClass hash
		bitXor: (self selector hash
		bitXor: (self filename hash
		bitXor: (self user hash
		bitXor: (self password hash
		bitXor: (self location hash)))))! !

!XpfCtRemoteVersionKey methodsFor: 'accessing' stamp: 'mt 5/26/2009 10:09'!
location

	^ location! !

!XpfCtRemoteVersionKey methodsFor: 'accessing' stamp: 'mt 5/26/2009 10:09'!
location: anObject

	location := anObject.! !

!XpfCtRemoteVersionKey methodsFor: 'accessing' stamp: 'mt 5/26/2009 10:09'!
password

	^ password! !

!XpfCtRemoteVersionKey methodsFor: 'accessing' stamp: 'mt 5/26/2009 10:09'!
password: anObject

	password := anObject.! !

!XpfCtRemoteVersionKey methodsFor: 'accessing' stamp: 'mt 5/26/2009 10:09'!
selector

	^ selector! !

!XpfCtRemoteVersionKey methodsFor: 'accessing' stamp: 'mt 5/26/2009 10:09'!
selector: anObject

	selector := anObject.! !

!XpfCtRemoteVersionKey methodsFor: 'accessing' stamp: 'mt 5/26/2009 10:09'!
theClass

	^ theClass! !

!XpfCtRemoteVersionKey methodsFor: 'accessing' stamp: 'mt 5/26/2009 10:09'!
theClass: anObject

	theClass := anObject.! !

!XpfCtRemoteVersionKey methodsFor: 'accessing' stamp: 'mt 5/26/2009 10:09'!
user

	^ user! !

!XpfCtRemoteVersionKey methodsFor: 'accessing' stamp: 'mt 5/26/2009 10:09'!
user: anObject

	user := anObject.! !

Object subclass: #XpfCtTagAnalysisModel
	instanceVariableNames: 'inspector repositoryName username password filter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Models'!

!XpfCtTagAnalysisModel methodsFor: 'testing' stamp: 'mt 5/9/2009 17:24'!
canAnalyze

	^ self repositoryName notEmpty! !

!XpfCtTagAnalysisModel methodsFor: 'accessing' stamp: 'mt 5/9/2009 17:36'!
filter

	filter ifNil: [self filter: 'Xpf-CodeTalk'].
	^ filter! !

!XpfCtTagAnalysisModel methodsFor: 'accessing' stamp: 'mt 5/9/2009 17:38'!
filter: anObject

	filter := anObject.
	self changed: #filter.! !

!XpfCtTagAnalysisModel methodsFor: 'accessing' stamp: 'mt 5/13/2009 15:51'!
inspector

	inspector ifNil: [self inspector: XpfCtMczInspector new].
	^ inspector! !

!XpfCtTagAnalysisModel methodsFor: 'accessing' stamp: 'mt 5/9/2009 17:39'!
inspector: anObject

	inspector ifNotNilDo: [:i | i removeDependent: self].
	inspector := anObject.
	inspector ifNotNilDo: [:i | i addDependent: self].
	self changed: #inspector.! !

!XpfCtTagAnalysisModel methodsFor: 'testing' stamp: 'mt 5/9/2009 17:53'!
isNotAnalyzing

	^ self inspector isRunning not! !

!XpfCtTagAnalysisModel methodsFor: 'accessing' stamp: 'mt 5/9/2009 17:27'!
label

	^ self inspector isRunning
		ifTrue: ['Stop Analysis']
		ifFalse: ['Start Analysis'].! !

!XpfCtTagAnalysisModel methodsFor: 'accessing' stamp: 'mt 5/9/2009 17:35'!
password

	password ifNil: [self password: 'gsgs'].
	^ password! !

!XpfCtTagAnalysisModel methodsFor: 'accessing' stamp: 'mt 5/9/2009 17:12'!
password: anObject

	password := anObject.
	self changed: #password.! !

!XpfCtTagAnalysisModel methodsFor: 'accessing' stamp: 'mt 5/9/2009 17:35'!
repositoryName

	repositoryName ifNil: [self repositoryName: 'xpforums'].
	^ repositoryName! !

!XpfCtTagAnalysisModel methodsFor: 'accessing' stamp: 'mt 5/9/2009 17:52'!
repositoryName: anObject

	repositoryName := anObject.
	self
		changed: #repositoryName;
		changed: #canAnalyze.! !

!XpfCtTagAnalysisModel methodsFor: 'analyzing' stamp: 'mt 5/9/2009 17:41'!
startStop

	self inspector isRunning
		ifTrue: [
			self inspector stop.
			self inspector repositories: OrderedCollection new]
		ifFalse: [
			self inspector
				addRepository: (MCHttpRepository
					location: 'http://www.hpi.uni-potsdam.de/hirschfeld/squeaksource/', self repositoryName
					user: self username
					password: self password)
				include: {self filter}.
			self inspector start].! !

!XpfCtTagAnalysisModel methodsFor: 'updating' stamp: 'mt 5/9/2009 17:51'!
update: aSymbol

	super update: aSymbol.
	aSymbol = #isRunning ifTrue: [
		self
			changed: #label;
			changed: #isAnalyzing].! !

!XpfCtTagAnalysisModel methodsFor: 'accessing' stamp: 'mt 5/9/2009 17:35'!
username

	username ifNil: [self username: 'gs'].
	^ username! !

!XpfCtTagAnalysisModel methodsFor: 'accessing' stamp: 'mt 5/9/2009 17:12'!
username: anObject

	username := anObject.
	self changed: #username.! !

Object subclass: #XpfCtTagSearchHelper
	instanceVariableNames: 'results classMatchers methodMatchers attributeMatchers typeMatchers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Models'!

!XpfCtTagSearchHelper methodsFor: 'matching' stamp: 'cs 5/2/2009 16:43'!
addAttributeMatcher: matcher

	self attributeMatchers add: matcher.! !

!XpfCtTagSearchHelper methodsFor: 'matching' stamp: 'cs 5/2/2009 16:43'!
addMethodMatcher: matcher

	self methodMatchers add: matcher.! !

!XpfCtTagSearchHelper methodsFor: 'searching' stamp: 'mt 5/5/2009 20:09'!
addToResultClass: mrClass symbol: mrSel

	| result |
	result := MethodReference new
		setStandardClass: mrClass
		methodSymbol: mrSel.
	self pvtResults add: result.
	self changed: #resultFound with: result.! !

!XpfCtTagSearchHelper methodsFor: 'matching' stamp: 'cs 5/3/2009 17:15'!
addTypeMatcher: matcher

	self typeMatchers add: matcher.! !

!XpfCtTagSearchHelper methodsFor: 'accessing' stamp: 'cs 5/2/2009 15:31'!
attributeMatchers

	^ attributeMatchers! !

!XpfCtTagSearchHelper methodsFor: 'accessing' stamp: 'cs 5/2/2009 15:31'!
attributeMatchers: anObject

	attributeMatchers := anObject.! !

!XpfCtTagSearchHelper methodsFor: 'updating' stamp: 'mt 5/7/2009 08:56'!
doWithProgress: aCollection block: aDoBlock message: aString
	"This method is used to signal asynchronous progress from a non-gui thread."
	
	| startTime |
	startTime := TimeStamp now.
	aCollection
		withIndexDo: [:e :i| 
			(TimeStamp now - startTime) seconds >= 1
				ifTrue: [
					self changed: #progressChanged with: {aString. i. aCollection size}. 
					startTime := TimeStamp now].
			aDoBlock value: e].
	self changed: #progressChanged with: {''. aCollection size. aCollection size}.! !

!XpfCtTagSearchHelper methodsFor: 'initialization' stamp: 'cs 5/3/2009 17:16'!
initialize

	self
		methodMatchers: OrderedCollection new;
		typeMatchers: OrderedCollection new;
		attributeMatchers: OrderedCollection new;
		results: Set new;
		addMethodMatcher: [:sel | sel isDoIt not]! !

!XpfCtTagSearchHelper methodsFor: 'matching' stamp: 'cs 5/3/2009 17:16'!
matchAttributeBad

	self addTypeMatcher: [:att | att tag = #bad].! !

!XpfCtTagSearchHelper methodsFor: 'matching' stamp: 'mt 5/28/2009 20:15'!
matchAttributeComment

	self addTypeMatcher: [:att | att tag = #comment].! !

!XpfCtTagSearchHelper methodsFor: 'matching' stamp: 'cs 5/3/2009 17:16'!
matchAttributeTalk

	self addTypeMatcher: [:att | att tag = #talk].! !

!XpfCtTagSearchHelper methodsFor: 'matching' stamp: 'cs 5/4/2009 02:39'!
matchCreator: aString

	self addAttributeMatcher: [:att | att creator = aString].! !

!XpfCtTagSearchHelper methodsFor: 'matching' stamp: 'cs 5/4/2009 02:28'!
matchKeyword: aString

	self addAttributeMatcher: [:att | att includesChatLine: aString].! !

!XpfCtTagSearchHelper methodsFor: 'matching' stamp: 'cs 5/3/2009 14:07'!
matchTime: aSymbol

	self addAttributeMatcher: (self timeMatchers at: aSymbol).! !

!XpfCtTagSearchHelper methodsFor: 'accessing' stamp: 'cs 5/2/2009 15:45'!
methodMatchers

	^ methodMatchers! !

!XpfCtTagSearchHelper methodsFor: 'accessing' stamp: 'cs 5/2/2009 15:46'!
methodMatchers: anObject

	methodMatchers := anObject.! !

!XpfCtTagSearchHelper methodsFor: 'accessing' stamp: 'cs 5/2/2009 13:06'!
pvtResults

	^ results! !

!XpfCtTagSearchHelper methodsFor: 'accessing' stamp: 'cs 5/2/2009 13:07'!
results

	^ results asSortedCollection! !

!XpfCtTagSearchHelper methodsFor: 'accessing' stamp: 'cs 5/2/2009 12:39'!
results: anObject

	results := anObject.! !

!XpfCtTagSearchHelper methodsFor: 'searching' stamp: 'mt 5/5/2009 20:00'!
searchAttribute: anAttribute
	"Attributes may be a specific timestamp, creator or keyword."
	
	(self searchType: anAttribute) ifFalse: [^ false].
	self attributeMatchers do: [ :matcher |
		(matcher value: anAttribute) ifFalse: [^ false]].
	^ true! !

!XpfCtTagSearchHelper methodsFor: 'searching' stamp: 'mt 5/5/2009 21:31'!
searchCategory: aString

	| result |
	result := OrderedCollection new.
	Smalltalk organization categories
		select: [:c | c startsWith: aString]
		thenDo: [:c | result addAll: (Smalltalk organization listAtCategoryNamed: c)].
	self
		doWithProgress: result
		block: [:name | self searchClass: (Smalltalk at: name)]
		message: 'Searching category ', aString, '...'.! !

!XpfCtTagSearchHelper methodsFor: 'searching' stamp: 'mt 5/5/2009 21:31'!
searchClass: class

	class selectorsDo: [:sel |
		(self searchMethod: sel text: (class sourceCodeAt: sel))
			ifTrue: [self addToResultClass: class symbol: sel]].! !

!XpfCtTagSearchHelper methodsFor: 'searching' stamp: 'mt 5/5/2009 21:31'!
searchGlobal

	self
		doWithProgress: Smalltalk classNames
		block: [:className | self searchClass: (Smalltalk at: className)]
		message: 'Searching all source code...'.! !

!XpfCtTagSearchHelper methodsFor: 'searching' stamp: 'cs 5/2/2009 16:56'!
searchMethod: sel text: text
	
	text isText ifFalse: [^ false].
	self methodMatchers do: [:matcher |
		(matcher value: sel) ifFalse: [^ false]].
	^ self searchText: text! !

!XpfCtTagSearchHelper methodsFor: 'searching' stamp: 'mt 5/5/2009 19:59'!
searchText: aText

	aText runs values do: [:atts |
		atts do: [:att |
			((att isKindOf: XpfComplexAttribute)
			and: [self searchAttribute: att])
				ifTrue: [^ true]]].
	^ false! !

!XpfCtTagSearchHelper methodsFor: 'searching' stamp: 'cs 5/3/2009 17:17'!
searchType: anAttribute
		
	self typeMatchers do: [ :matcher |
		(matcher value: anAttribute) ifTrue: [^ true]].
	^ false! !

!XpfCtTagSearchHelper methodsFor: 'accessing' stamp: 'cs 5/4/2009 02:14'!
timeMatchers

	^ Dictionary
		with: #today -> [:att | att timestamp asDate = Date today]
		with: #yesterday -> [:att | att timestamp asDate = Date yesterday]
		with: #thisWeek -> [:att | att timestamp asWeek = Week current]
		with: #lastWeek -> [:att | att timestamp asWeek = (Week current - (Duration weeks: 1))]
		with: #thisMonth -> [:att | att timestamp asMonth = Month current]
		with: #lastMonth -> [:att | att timestamp asMonth = Date current onPreviousMonth asMonth]! !

!XpfCtTagSearchHelper methodsFor: 'accessing' stamp: 'cs 5/3/2009 17:15'!
typeMatchers

	^ typeMatchers! !

!XpfCtTagSearchHelper methodsFor: 'accessing' stamp: 'cs 5/3/2009 17:15'!
typeMatchers: anObject

	typeMatchers := anObject.! !

Object subclass: #XpfCtTagSearchModel
	instanceVariableNames: 'results category theClass findBad findTalk findComment keyword creator selectedTime controller isSearching progressString progressValue progressValueMax searchProcess'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Models'!

!XpfCtTagSearchModel methodsFor: 'testing' stamp: 'mt 5/28/2009 20:17'!
canSearch

	^ self isSearching or: [((self findBad | self findTalk) | self findComment) &
		(self validClass and: [self validCategory])]! !

!XpfCtTagSearchModel methodsFor: 'accessing' stamp: 'cs 5/3/2009 13:26'!
category

	^ category asString asText
		addAttribute: (self validCategory
			ifTrue: [TextColor black]
			ifFalse: [TextColor red]);
		yourself! !

!XpfCtTagSearchModel methodsFor: 'accessing' stamp: 'mt 5/6/2009 10:07'!
category: aText
	
	category := aText asString withBlanksTrimmed asSymbol.
	self changed: #category.
	self changed: #canSearch.
	self changed: #theClassEnabled.! !

!XpfCtTagSearchModel methodsFor: 'accessing' stamp: 'cs 5/4/2009 10:45'!
categoryEnabled

	^ theClass isEmpty! !

!XpfCtTagSearchModel methodsFor: 'accessing' stamp: 'cs 5/3/2009 13:32'!
categoryLength

	^ {category size + 1}! !

!XpfCtTagSearchModel methodsFor: 'searching' stamp: 'cs 5/4/2009 00:45'!
children

	^ self results collect: [:ref |
		OBMethodNode on: ref]! !

!XpfCtTagSearchModel methodsFor: 'searching' stamp: 'mt 5/5/2009 21:45'!
clearResults

	results := OrderedCollection new.
	self changed: #results.! !

!XpfCtTagSearchModel methodsFor: 'ecompletion' stamp: 'cs 5/5/2009 17:30'!
completionController

	controller ifNil:[controller := ECController model: self ].
	^ controller! !

!XpfCtTagSearchModel methodsFor: 'accessing' stamp: 'cs 5/4/2009 09:48'!
creator
	^ creator! !

!XpfCtTagSearchModel methodsFor: 'accessing' stamp: 'cs 5/4/2009 09:48'!
creator: anObject
	creator := anObject! !

!XpfCtTagSearchModel methodsFor: 'searching' stamp: 'cs 5/4/2009 10:05'!
enableParams: helper
	
	self keyword ifNotEmpty: [helper matchKeyword: self keyword].
	self creator ifNotEmpty: [helper matchCreator: self creator].
	self selectedTime = #all ifFalse: [helper matchTime: self selectedTime].! !

!XpfCtTagSearchModel methodsFor: 'searching' stamp: 'mt 5/28/2009 20:15'!
enableTags: helper
	
	self findBad ifTrue: [helper matchAttributeBad ].
	self findTalk ifTrue: [helper matchAttributeTalk ].
	self findComment ifTrue: [helper matchAttributeComment ].! !

!XpfCtTagSearchModel methodsFor: 'accessing' stamp: 'cs 5/2/2009 17:15'!
findBad

	^ findBad! !

!XpfCtTagSearchModel methodsFor: 'accessing' stamp: 'cs 5/2/2009 17:56'!
findBad: anObject

	findBad := anObject.
	self changed: #findBad.
	self changed: #canSearch.! !

!XpfCtTagSearchModel methodsFor: 'accessing' stamp: 'mt 5/28/2009 20:14'!
findComment

	^ findComment! !

!XpfCtTagSearchModel methodsFor: 'accessing' stamp: 'mt 5/28/2009 20:14'!
findComment: anObject

	findComment := anObject.
	self changed: #findComment.
	self changed: #canSearch.! !

!XpfCtTagSearchModel methodsFor: 'accessing' stamp: 'cs 5/2/2009 17:15'!
findTalk

	^ findTalk! !

!XpfCtTagSearchModel methodsFor: 'accessing' stamp: 'cs 5/2/2009 17:56'!
findTalk: anObject

	findTalk := anObject.
	self changed: #findTalk.
	self changed: #canSearch.! !

!XpfCtTagSearchModel methodsFor: 'initialization' stamp: 'mt 5/28/2009 20:16'!
initialize

	super initialize.
	self
		category: '';
		theClass: '';
		keyword: '';
		creator: '';
		findBad: true;
		findTalk: false;
		findComment: false;
		selectedTime: #all.! !

!XpfCtTagSearchModel methodsFor: 'accessing' stamp: 'mt 5/5/2009 20:29'!
isSearching

	isSearching ifNil: [isSearching := false].
	^ isSearching! !

!XpfCtTagSearchModel methodsFor: 'accessing' stamp: 'mt 5/5/2009 21:38'!
isSearching: aBoolean

	isSearching := aBoolean.
	self
		changed: #canSearch;
		changed: #searchButtonLabel.! !

!XpfCtTagSearchModel methodsFor: 'accessing' stamp: 'cs 5/2/2009 17:15'!
keyword

	^ keyword! !

!XpfCtTagSearchModel methodsFor: 'accessing' stamp: 'cs 5/2/2009 17:15'!
keyword: anObject

	keyword := anObject.! !

!XpfCtTagSearchModel methodsFor: 'accessing' stamp: 'cs 5/4/2009 09:51'!
possibleTimes
	
	^ #(all today yesterday thisWeek lastWeek thisMonth lastMonth).! !

!XpfCtTagSearchModel methodsFor: 'updating' stamp: 'mt 5/5/2009 21:02'!
progressString

	progressString ifNil: [progressString := ''].
	^ progressString! !

!XpfCtTagSearchModel methodsFor: 'updating' stamp: 'mt 5/5/2009 21:03'!
progressValue

	progressValue ifNil: [progressValue := 0].
	^ progressValue! !

!XpfCtTagSearchModel methodsFor: 'updating' stamp: 'mt 5/5/2009 21:04'!
progressValueMax

	progressValueMax ifNil: [progressValueMax := 100].
	^ progressValueMax! !

!XpfCtTagSearchModel methodsFor: 'searching' stamp: 'mt 5/5/2009 20:08'!
results

	results ifNil: [results := OrderedCollection new].
	^ results! !

!XpfCtTagSearchModel methodsFor: 'searching' stamp: 'mt 5/5/2009 21:48'!
search

	| helper |
	self clearResults.
	
	helper := XpfCtTagSearchHelper new.
	helper addDependent: self.
	
	self isSearching: true.
	self enableTags: helper.
	self enableParams: helper.
	searchProcess := [(self theClass notEmpty and: [self validClass])
		ifTrue: [helper searchClass: (Smalltalk at: theClass)]
		ifFalse: [(self category notEmpty and: [self validCategory])
			ifTrue: [helper searchCategory: self category]
			ifFalse: [helper searchGlobal]].
	self isSearching: false] fork priority: 35. "Lower than UI-Thread"! !

!XpfCtTagSearchModel methodsFor: 'accessing' stamp: 'mt 5/5/2009 21:37'!
searchButtonLabel

	^ self isSearching
		ifTrue: ['Stop Search']
		ifFalse: ['Start Search']! !

!XpfCtTagSearchModel methodsFor: 'searching' stamp: 'mt 5/5/2009 21:41'!
searchOrStop

	self isSearching
		ifTrue: [self searchStop]
		ifFalse: [self search].! !

!XpfCtTagSearchModel methodsFor: 'searching' stamp: 'mt 5/6/2009 10:25'!
searchStop

	searchProcess ifNil: [^ self].
	searchProcess terminate.
	searchProcess := nil.
	progressValue := 0.
	progressString := ''.
	self
		isSearching: false;
		changed: #progressValue;
		changed: #progressString.! !

!XpfCtTagSearchModel methodsFor: 'searching' stamp: 'cs 5/4/2009 00:51'!
selectResult: result

	(self children at: result) browse! !

!XpfCtTagSearchModel methodsFor: 'ecompletion' stamp: 'cs 5/5/2009 17:38'!
selectedClassOrMetaClass

	^ nil "I don't know any better"! !

!XpfCtTagSearchModel methodsFor: 'accessing' stamp: 'cs 5/4/2009 10:03'!
selectedTime

	^ selectedTime! !

!XpfCtTagSearchModel methodsFor: 'accessing' stamp: 'cs 5/4/2009 10:03'!
selectedTime: anObject

	selectedTime := anObject.! !

!XpfCtTagSearchModel methodsFor: 'accessing' stamp: 'cs 5/4/2009 10:01'!
selectedTimeIndex

	^ self possibleTimes indexOf: self selectedTime! !

!XpfCtTagSearchModel methodsFor: 'accessing' stamp: 'cs 5/4/2009 10:03'!
selectedTimeIndex: aNumber

	^ self selectedTime: (self possibleTimes at: aNumber)! !

!XpfCtTagSearchModel methodsFor: 'accessing' stamp: 'cs 5/3/2009 13:03'!
theClass

	^ theClass asString asText
		addAttribute: (self validClass
			ifTrue: [TextColor black]
			ifFalse: [TextColor red]);
		yourself! !

!XpfCtTagSearchModel methodsFor: 'accessing' stamp: 'mt 5/6/2009 10:07'!
theClass: aText
	
	theClass := aText asString withBlanksTrimmed asSymbol.
	self changed: #theClass.
	self changed: #canSearch.! !

!XpfCtTagSearchModel methodsFor: 'accessing' stamp: 'cs 5/3/2009 13:29'!
theClassEnabled

	^ category isEmpty! !

!XpfCtTagSearchModel methodsFor: 'accessing' stamp: 'cs 5/3/2009 13:19'!
theClassLength

	^ {theClass size + 1}! !

!XpfCtTagSearchModel methodsFor: 'updating' stamp: 'mt 5/5/2009 20:31'!
update: aSymbol

	super update: aSymbol.
	
	aSymbol = #searchFinished ifTrue: [
		self isSearching: false].! !

!XpfCtTagSearchModel methodsFor: 'updating' stamp: 'mt 5/5/2009 21:05'!
update: aSymbol with: anObject

	| label value max |
	super update: aSymbol with: anObject.
	
	aSymbol = #resultFound ifTrue: [
		self results add: anObject.
		self changed: #results].
	
	aSymbol = #progressChanged ifTrue: [
		label := anObject first.
		value := anObject second.
		max := anObject third.
		
		progressString := label.
		progressValue := value.
		progressValueMax := max.
		
		self
			changed: #progressString;
			changed: #progressValue].! !

!XpfCtTagSearchModel methodsFor: 'accessing' stamp: 'cs 5/3/2009 13:31'!
validCategory

	^ category isEmpty or:
		[Smalltalk organization categories anySatisfy: [:c | c startsWith: category]]! !

!XpfCtTagSearchModel methodsFor: 'accessing' stamp: 'cs 5/3/2009 13:30'!
validClass

	^ theClass isEmpty or: [Smalltalk includesKey: theClass]! !

BorderedMorph subclass: #XpfCtAttributeEditorMorph
	instanceVariableNames: 'model closeButton title'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Morphs'!

!XpfCtAttributeEditorMorph class methodsFor: 'constants' stamp: 'mt 5/28/2009 19:37'!
defaultExtent

	^ 200@150! !

!XpfCtAttributeEditorMorph class methodsFor: 'instance creation' stamp: 'mt 5/28/2009 19:37'!
forAttribute: anXpfAttribute

	^ self new
		attribute: anXpfAttribute! !

!XpfCtAttributeEditorMorph class methodsFor: 'constants' stamp: 'mt 5/28/2009 19:39'!
modelClass

	^ self subclassResponsibility! !

!XpfCtAttributeEditorMorph methodsFor: 'accessing' stamp: 'mt 5/28/2009 19:28'!
attribute: anXpfAttribute

	self model ifNil: [^ self].
	self model attribute: anXpfAttribute.
	self title contents: ('{1} - {2}' format: {
			anXpfAttribute timestamp printRelativeTimeStamp.
			anXpfAttribute creator}).
	self color: (anXpfAttribute color copy lighter lighter alpha: 0.7).! !

!XpfCtAttributeEditorMorph methodsFor: 'accessing' stamp: 'mt 5/28/2009 19:28'!
closeButton

	closeButton ifNil: [closeButton := IconicButton new
			color: (Color white alpha: 0.5);
			target: self;
			borderWidth: 0;
			labelGraphic: MenuIcons xpfCtCrossIcon;
			actionSelector: #delete;
			useRoundedCorners;
			setBalloonText: 'Close window'].
	^ closeButton! !

!XpfCtAttributeEditorMorph methodsFor: 'initialization' stamp: 'mt 5/28/2009 19:28'!
initialize

	super initialize.
	self
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		listDirection: #topToBottom;
		borderWidth: 1;
		borderColor: Color black;
		changeTableLayout;
		fillStyle: (Color yellow alpha: 0.8);
		layoutInset: 5;
		cellInset: 5;
		useRoundedCorners;
		initializeUserInterface.! !

!XpfCtAttributeEditorMorph methodsFor: 'initialization' stamp: 'mt 5/28/2009 19:29'!
initializeUserInterface

	^ self subclassResponsibility! !

!XpfCtAttributeEditorMorph methodsFor: 'accessing' stamp: 'mt 5/28/2009 19:40'!
model

	model ifNil: [model := self class modelClass new].
	^ model! !

!XpfCtAttributeEditorMorph methodsFor: 'accessing' stamp: 'mt 5/28/2009 19:29'!
title

	title ifNil: [title := UITheme current
			newLabelIn: self label: 'Editor'.
		title hResizing: #spaceFill.
		title assureExtension
			balloonText: 'Creation time and creator'].
	^ title! !

XpfCtAttributeEditorMorph subclass: #XpfCtCodeChatMorph
	instanceVariableNames: 'chatLog textEntry addMessageButton searchEntry searchButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Morphs'!

!XpfCtCodeChatMorph class methodsFor: 'constants' stamp: 'mt 5/28/2009 19:39'!
modelClass

	^ XpfCtCodeChatModel! !

!XpfCtCodeChatMorph methodsFor: 'accessing' stamp: 'mt 5/2/2009 17:56'!
addMessageButton

	addMessageButton ifNil: [addMessageButton := IconicButton new
			color: (Color white alpha: 0.5);
			target: self textEntry;
			borderWidth: 0;
			labelGraphic: MenuIcons xpfCtCommentAddIcon;
			actionSelector: #accept;
			useRoundedCorners;
			setBalloonText: 'Add message'].
	^ addMessageButton! !

!XpfCtCodeChatMorph methodsFor: 'accessing' stamp: 'mt 5/3/2009 10:58'!
chatLog

	chatLog ifNil: [chatLog := (UITheme current
		newMorphListIn: self
		for: self model
		list: #messages
		getSelected: #lastIndex
		setSelected: nil
		getEnabled: nil
		help: nil)
		hResizing: #rigid;
		vResizing: #rigid;
		cellInset: 0;
		layoutInset: 0;
		borderWidth: 0;
		fillStyle: Color transparent;
		extent: self class defaultExtent.
		chatLog listMorph cellInset: 0].
	^ chatLog! !

!XpfCtCodeChatMorph methodsFor: 'initialization' stamp: 'mt 5/3/2009 14:20'!
initializeUserInterface

	self
		addMorphBack: (UITheme current newRowIn: self for: {
			self title.
			self closeButton});
		addMorphBack: (UITheme current newRowIn: self for: {
			self searchEntry.
			self searchButton});
		addMorphBack: self chatLog;
		addMorphBack: (UITheme current newRowIn: self for: {
			self textEntry.
			self addMessageButton}).! !

!XpfCtCodeChatMorph methodsFor: 'accessing' stamp: 'mt 5/3/2009 14:18'!
searchButton

	searchButton ifNil: [searchButton := IconicButton new
			color: (Color white alpha: 0.5);
			target: self searchEntry;
			borderWidth: 0;
			labelGraphic: MenuIcons xpfCtMagnifierIcon;
			actionSelector: #accept;
			useRoundedCorners;
			setBalloonText: 'Highlight messages with keyword.'].
	^ searchButton! !

!XpfCtCodeChatMorph methodsFor: 'accessing' stamp: 'mt 5/3/2009 14:19'!
searchEntry

	searchEntry ifNil: [searchEntry := UITheme current
		newTextEntryIn: self
		for: self model
		get: nil
		set: #searchString:
		class: String
		getEnabled: nil
		help: 'Type a keyword to hightlight messages which contain that keyword.'.
		searchEntry
			useRoundedCorners;
			borderWidth: 0;
			fillStyle: (Color white alpha: 0.5);
			setText: 'Look for keyword...'].
	^ searchEntry! !

!XpfCtCodeChatMorph methodsFor: 'accessing' stamp: 'mt 5/3/2009 10:56'!
textEntry

	textEntry ifNil: [textEntry := UITheme current
		newTextEntryIn: self
		for: self model
		get: #newMessage
		set: #addMessage:
		class: String
		getEnabled: nil
		help: 'Type a message and hit the return key or push the button to the right.'.
		textEntry
			useRoundedCorners;
			borderWidth: 0;
			fillStyle: (Color white alpha: 0.5);
			setText: 'Type message here...'].
	^ textEntry! !

XpfCtAttributeEditorMorph subclass: #XpfCtCommentEditorMorph
	instanceVariableNames: 'commentField'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Morphs'!

!XpfCtCommentEditorMorph class methodsFor: 'constants' stamp: 'mt 5/28/2009 19:39'!
modelClass

	^ XpfCtCommentEditorModel! !

!XpfCtCommentEditorMorph methodsFor: 'accessing' stamp: 'mt 5/28/2009 19:45'!
commentField

	commentField ifNil: [commentField := UITheme current
		newTextEditorIn: self
		for: self model
		getText: #comment
		setText: #comment:
		getEnabled: nil.
		commentField
			autoAccept: true;
			useRoundedCorners;
			borderWidth: 0;
			fillStyle: (Color white alpha: 0.5);
			hResizing: #rigid;
			vResizing: #rigid;
			cellInset: 0;
			layoutInset: 0;
			extent: self class defaultExtent].
	^ commentField! !

!XpfCtCommentEditorMorph methodsFor: 'initialization' stamp: 'mt 5/28/2009 19:37'!
initializeUserInterface

	self
		addMorphBack: (UITheme current newRowIn: self for: {
			self title.
			self closeButton});
		addMorphBack: self commentField.! !

BorderedMorph subclass: #XpfCtDiagramMorph
	instanceVariableNames: 'graphs dimensions grid'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Morphs'!

!XpfCtDiagramMorph methodsFor: 'add/remove' stamp: 'mt 5/9/2009 15:37'!
addGraph: aGraphMorph

	self addMorph: aGraphMorph.
	aGraphMorph
		position: self position;
		diagram: self.! !

!XpfCtDiagramMorph methodsFor: 'add/remove' stamp: 'mt 5/9/2009 16:48'!
addGrid: aPoint

	self removeGrid.
	
	(self minX to: self maxX by: aPoint x) do: [:t | |newLine|
		newLine := LineMorph
			from: (self scaledPoint: t @ self minY)
			to: (self scaledPoint: t @ self maxY)
			color: Color gray
			width: 1.
		self addMorph: newLine.
		self grid add: newLine].
	
	(self minY to: self maxY by: aPoint y) do: [:t | |newLine|
		newLine := LineMorph
			from: (self scaledPoint: self minX @ t)
			to: (self scaledPoint: self maxX @ t)
			color: Color gray
			width: 1.
		self addMorph: newLine.
		self grid add: newLine].
	
	self
		addGridAxis;
		addLabel: aPoint * (2@1).! !

!XpfCtDiagramMorph methodsFor: 'add/remove' stamp: 'mt 5/9/2009 16:27'!
addGridAxis

	| newLine |
	newLine := LineMorph
		from: (self scaledPoint: self minX @ 0)
		to: (self scaledPoint: self maxX @ 0)
		color: Color gray
		width: 2.

	self addMorph: newLine.
	self grid add: newLine.
	
	newLine := LineMorph
		from: (self scaledPoint: 0 @ self minY)
		to: (self scaledPoint: 0 @ self maxY)
		color: Color gray
		width: 2.

	self addMorph: newLine.
	self grid add: newLine.! !

!XpfCtDiagramMorph methodsFor: 'add/remove' stamp: 'mt 5/9/2009 16:39'!
addLabel: aPoint

	(self minX to: self maxX by: aPoint x) do: [:t | |label|		
		label := (StringMorph contents: t asString)
			position: (self scaledPoint: t@0).
		label position: (label position x - (label width // 2)) @ (label position y + 5).
		self addMorph: label].
	
	(self minY to: self maxY by: aPoint y) do: [:t | |label|
		label := (StringMorph contents: t asString)
			position: (self scaledPoint: 0@t).
		label position: (label position x - label width - 5) @ (label position y - (label height // 2)).
		self addMorph: label].! !

!XpfCtDiagramMorph methodsFor: 'accessing' stamp: 'mt 5/9/2009 11:37'!
dimensions

	dimensions ifNil: [self dimensions: (0@100 corner: 100@0)].
	^ dimensions! !

!XpfCtDiagramMorph methodsFor: 'accessing' stamp: 'mt 5/9/2009 11:37'!
dimensions: aRectangle

	dimensions := aRectangle.! !

!XpfCtDiagramMorph methodsFor: 'accessing' stamp: 'mt 5/9/2009 10:18'!
graphs

	graphs ifNil: [self graphs: Dictionary new].
	^ graphs! !

!XpfCtDiagramMorph methodsFor: 'accessing' stamp: 'mt 5/9/2009 10:18'!
graphs: anObject

	graphs anObject.! !

!XpfCtDiagramMorph methodsFor: 'accessing' stamp: 'mt 5/9/2009 16:01'!
grid

	grid ifNil: [self grid: OrderedCollection new].
	^ grid! !

!XpfCtDiagramMorph methodsFor: 'accessing' stamp: 'mt 5/9/2009 16:10'!
grid: anObject

	grid := OrderedCollection new.! !

!XpfCtDiagramMorph methodsFor: 'initialization' stamp: 'mt 5/9/2009 16:42'!
initialize

	super initialize.
	self
		extent: 200@200;
		color: Color white;
		borderWidth: 0.! !

!XpfCtDiagramMorph methodsFor: 'accessing' stamp: 'mt 5/9/2009 11:39'!
maxX

	^ self dimensions right! !

!XpfCtDiagramMorph methodsFor: 'accessing' stamp: 'mt 5/9/2009 11:39'!
maxY

	^ self dimensions top! !

!XpfCtDiagramMorph methodsFor: 'accessing' stamp: 'mt 5/9/2009 11:38'!
minX

	^ self dimensions left! !

!XpfCtDiagramMorph methodsFor: 'accessing' stamp: 'mt 5/9/2009 11:38'!
minY

	^ self dimensions bottom! !

!XpfCtDiagramMorph methodsFor: 'add/remove' stamp: 'mt 5/9/2009 16:11'!
removeGrid

	self grid copy do: [:gridLine | gridLine delete]! !

!XpfCtDiagramMorph methodsFor: 'scaling' stamp: 'mt 5/9/2009 16:03'!
scaledPoint: aPoint
	"Scale the point according to the diagrams dimensions."
	
	| scaledPoint |
	
	scaledPoint :=
		(((aPoint x - self minX) * self width)  // (self maxX abs + self minX abs)) @
		(((aPoint y - self minY) * self height) // (self maxY abs + self minY abs)).
		
	^ scaledPoint * (1@-1) + (0@self height) + self position! !

!Integer methodsFor: '*xpf-codetalk' stamp: 'mt 5/3/2009 21:24'!
asByteArrayOfSize2: aSize 
	"Answer a ByteArray of aSize with my value, most-significant byte first."
	| answer digitPos |
	aSize < self digitLength ifTrue: [ Error signal: 'number to large for byte array' ].
	answer := ByteArray new: aSize.
	digitPos := 1.
	aSize 
		to: aSize - self digitLength + 1
		by: -1
		do: 
			[ : pos | 
			answer 
				at: pos
				put: (self digitAt: digitPos).
			digitPos := digitPos + 1 ].
	^ answer! !

LabelMorph subclass: #XpfCtPluggableLabelMorph
	instanceVariableNames: 'labelSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Morphs'!

!XpfCtPluggableLabelMorph methodsFor: 'accessing' stamp: 'mt 5/6/2009 10:18'!
labelSelector
	^ labelSelector! !

!XpfCtPluggableLabelMorph methodsFor: 'accessing' stamp: 'mt 5/6/2009 10:22'!
labelSelector: anObject

	labelSelector := anObject.
	self update: anObject! !

!XpfCtPluggableLabelMorph methodsFor: 'updating' stamp: 'mt 5/6/2009 10:24'!
update: aSymbol

	super update: aSymbol.
	
	aSymbol = self labelSelector ifTrue: [self updateLabel].! !

!XpfCtPluggableLabelMorph methodsFor: 'updating' stamp: 'mt 5/6/2009 10:24'!
updateLabel

	| string |
	string := self model perform: self labelSelector.
	
	self 
		disableTableLayout: string isEmpty;
		visible: string isEmpty not.		
	
	self visible ifTrue:
		[self contents: string].! !

!OBMethodNode methodsFor: '*xpf-codetalk' stamp: 'mt 5/3/2009 10:02'!
categoryText

	^ self category! !

!OBMethodNode methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 13:50'!
hasMarkups

	^ true! !

!OBMethodNode methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 14:28'!
markupSourceName

	^ 'protocol [{1}] in {2} "{3}"' format: {
		self category.
		self theClass isMeta
			ifTrue: ['meta-class']
			ifFalse: ['class'].
		self theClassName}! !

!OBMethodNode methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 13:49'!
referencesForMarkups
	"Use markups for all methods in this method's category."
	
	^ (PackageOrganizer default
		packageOfMethod: self reference
		ifNone: [^ #()]) methods select: [:m | m category = self category]! !

!OBMethodNode methodsFor: '*xpf-codetalk' stamp: 'mt 5/27/2009 15:23'!
remoteVersions

	| result lastDate |
	self metaNode filters ifEmpty: [^ #()].
	
	result := OrderedCollection new.
	
	self metaNode filters first cache do: [:ver | |t|
		t := ver definition fullTimeStamp.
		lastDate = t date ifFalse: [
			result add: (XpfCtSeparatorNode text: t date printRelativeDate)].
		lastDate := t date.
		result add: (XpfCtRemoteMethodVersionNode on: ver)].

	^ result! !

!OBMethodNode methodsFor: '*xpf-codetalk' stamp: 'mt 5/3/2009 09:55'!
sourceText

	^ self source! !

PluggableButtonMorphPlus subclass: #XpfCtButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Morphs'!

!XpfCtButton class methodsFor: 'instance creation' stamp: 'mt 6/3/2009 10:21'!
on: aModel action: actionSel icon: aSymbol label: aTextOrString

	| lm |
	lm := PanelMorph new
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		fillStyle: Color transparent;
		changeTableLayout;
		listDirection: #leftToRight;
		cellInset: 2.
		
	lm
		addMorphBack: (MenuIcons perform: aSymbol) asMorph;
		addMorphBack: aTextOrString asMorph.
		
	^ (self
		on: aModel
		getState: nil
		action: actionSel)
			hResizing: #shrinkWrap;
			vResizing: #spaceFill;
			styleWith: OBMorphBuilder new;
			"setBalloonText: aCommand longDescription;"
			cellInset: 1;	
			label: lm;
			yourself! !

PluggableListMorph subclass: #XpfPluggableListMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk'!

!XpfPluggableListMorph methodsFor: 'as yet unclassified' stamp: 'cs 5/4/2009 00:49'!
backgroundColorAt: row

	^ Color white! !

!XpfPluggableListMorph methodsFor: 'as yet unclassified' stamp: 'cs 5/4/2009 00:49'!
iconAt: row

	^ nil! !

!XpfPluggableListMorph methodsFor: 'as yet unclassified' stamp: 'cs 5/4/2009 00:37'!
listMorphClass

	^ XpfLazyListMorph! !

!OBNode methodsFor: '*xpf-codetalk' stamp: 'mt 5/25/2009 14:46'!
isSeparatorNode

   ^false! !

!OBPluggableListMorph methodsFor: '*xpf-codetalk-override' stamp: 'mt 4/26/2009 21:32'!
listMorphClass
    ^XpfLazyListMorph! !

PolygonMorph subclass: #XpfCtGraphMorph
	instanceVariableNames: 'model diagram'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Morphs'!

!XpfCtGraphMorph class methodsFor: 'instance creation' stamp: 'mt 5/9/2009 16:15'!
newFor: aGraphModel color: aColor

	^ (self new
		vertices: {0@0} asOrderedCollection
		color: Color black
		borderWidth: 3
		borderColor: aColor)
		makeOpen;
		model: aGraphModel! !

!XpfCtGraphMorph methodsFor: 'add/remove' stamp: 'mt 5/9/2009 16:04'!
addPoint: aPoint

	"(self diagram dimensions containsPoint: aPoint)
		ifFalse: [^ self]."

	self vertices add: (self diagram scaledPoint: aPoint).
	self computeBounds.! !

!XpfCtGraphMorph methodsFor: 'accessing' stamp: 'mt 5/9/2009 15:37'!
diagram

	^ diagram! !

!XpfCtGraphMorph methodsFor: 'accessing' stamp: 'mt 5/9/2009 15:37'!
diagram: aDiagramMorph

	diagram := aDiagramMorph.! !

!XpfCtGraphMorph methodsFor: 'accessing' stamp: 'mt 5/9/2009 11:36'!
model

	^ model! !

!XpfCtGraphMorph methodsFor: 'accessing' stamp: 'mt 5/9/2009 14:52'!
model: anObject

	self model ifNotNilDo: [:m | m removeDependent: self].
	model := anObject.
	self model ifNotNilDo: [:m | m addDependent: self].! !

!XpfCtGraphMorph methodsFor: 'add/remove' stamp: 'mt 5/9/2009 16:04'!
removeAllPoints

	vertices := {self diagram scaledPoint: 0@0} asOrderedCollection.
	self computeBounds.! !

!XpfCtGraphMorph methodsFor: 'updating' stamp: 'mt 5/9/2009 14:55'!
update: aSymbol

	super update: aSymbol.
	aSymbol = #reset ifTrue: [self removeAllPoints].! !

!XpfCtGraphMorph methodsFor: 'updating' stamp: 'mt 5/9/2009 15:03'!
update: aSymbol with: anObject

	super update: aSymbol with: anObject.
	aSymbol = #newPoint ifTrue: [self addPoint: anObject].! !

ImageMorph subclass: #XpfCtAttributeIconMorph
	instanceVariableNames: 'attribute lastVisible'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Kernel'!

!XpfCtAttributeIconMorph methodsFor: 'accessing' stamp: 'mt 5/1/2009 17:19'!
attribute
	^ attribute! !

!XpfCtAttributeIconMorph methodsFor: 'accessing' stamp: 'mt 5/1/2009 17:19'!
attribute: anObject
	attribute := anObject! !

!XpfCtAttributeIconMorph methodsFor: 'event handling' stamp: 'mt 5/1/2009 17:19'!
handlesMouseDown: evt

	^ true! !

!XpfCtAttributeIconMorph methodsFor: 'accessing' stamp: 'mt 5/3/2009 19:43'!
visible: aBoolean

	lastVisible = aBoolean ifTrue: [^ self].
	lastVisible := aBoolean.
	self disableTableLayout: aBoolean not.
	^ super visible: aBoolean! !

XpfCtAttributeIconMorph subclass: #XpfCtChatIconMorph
	instanceVariableNames: 'chat'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Kernel'!

!XpfCtChatIconMorph methodsFor: 'accessing' stamp: 'mt 5/2/2009 15:16'!
balloonText

	^ 'View chat'! !

!XpfCtChatIconMorph methodsFor: 'accessing' stamp: 'mt 4/30/2009 14:49'!
chat

	chat ifNil: [chat := XpfCtCodeChatMorph forAttribute: self attribute].
	^ chat! !

!XpfCtChatIconMorph methodsFor: 'initialization' stamp: 'mt 6/2/2009 15:07'!
initialize

	super initialize.
	self image: (MenuIcons xpfCtCommentsIcon).! !

!XpfCtChatIconMorph methodsFor: 'event handling' stamp: 'mt 6/2/2009 18:06'!
mouseDown: evt

	self attribute ifNil: [^ self].
	self attribute read.
	self chat
		initialize;
		position: self positionInWorld;
		attribute: self attribute;
		openInWorld.! !

XpfCtAttributeIconMorph subclass: #XpfCtCommentIconMorph
	instanceVariableNames: 'editor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Kernel'!

!XpfCtCommentIconMorph methodsFor: 'accessing' stamp: 'mt 5/28/2009 19:45'!
balloonText

	^ 'View comment'! !

!XpfCtCommentIconMorph methodsFor: 'accessing' stamp: 'mt 5/28/2009 19:46'!
editor

	editor ifNil: [editor := XpfCtCommentEditorMorph forAttribute: self attribute].
	^ editor! !

!XpfCtCommentIconMorph methodsFor: 'initialization' stamp: 'mt 5/28/2009 20:12'!
initialize

	super initialize.
	self image: MenuIcons xpfCtCommentIcon.! !

!XpfCtCommentIconMorph methodsFor: 'event handling' stamp: 'mt 6/2/2009 18:07'!
mouseDown: evt

	self attribute ifNil: [^ self].
	self attribute read.
	self editor
		initialize;
		position: self positionInWorld;
		attribute: self attribute;
		openInWorld.! !

XpfCtAttributeIconMorph subclass: #XpfCtDeleteIconMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Kernel'!

!XpfCtDeleteIconMorph methodsFor: 'accessing' stamp: 'mt 5/2/2009 15:16'!
balloonText

	^ 'Delete markup'! !

!XpfCtDeleteIconMorph methodsFor: 'initialization' stamp: 'mt 5/1/2009 17:55'!
initialize

	super initialize.
	self image: (MenuIcons xpfCtDeleteIcon).! !

!XpfCtDeleteIconMorph methodsFor: 'event handling' stamp: 'mt 5/1/2009 17:55'!
mouseDown: evt

	self attribute ifNil: [^ self].
	self attribute requestDeletion.! !

XpfCtAttributeIconMorph subclass: #XpfCtResizeIconMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Kernel'!

!XpfCtResizeIconMorph methodsFor: 'accessing' stamp: 'mt 5/3/2009 19:17'!
balloonText

	^ 'Resize markup'! !

!XpfCtResizeIconMorph methodsFor: 'initialization' stamp: 'mt 5/3/2009 19:18'!
initialize

	super initialize.
	self image: (MenuIcons xpfCtPaintcanIcon).! !

!XpfCtResizeIconMorph methodsFor: 'event handling' stamp: 'mt 5/3/2009 19:19'!
mouseDown: evt

	self attribute ifNil: [^ self].
	self attribute requestResizing.! !

!OBPluggableTextMorphWithShout class methodsFor: '*xpf-codetalk-override' stamp: 'mt 5/1/2009 15:45'!
on: anObject text: getTextSel accept: setTextSel readSelection: getSelectionSel menu: getMenuSel
	"CodeTalk: Use the XpfStyler right now."
	
	|styler answer stylerClass |
	answer := self new.
	stylerClass := answer stylerClass.
	styler := stylerClass
		ifNotNil:[
			stylerClass new
				view: answer;
				yourself].
	^ answer
		styler: styler;
		on: anObject
		text: getTextSel
		accept: setTextSel
		readSelection: getSelectionSel
		menu: getMenuSel! !

!OBPluggableTextMorphWithShout methodsFor: '*xpf-codetalk' stamp: 'topa 2/13/2009 13:48'!
stylerClass
	^XpfTextStyler! !

!OBPluggableTextMorphWithShout methodsFor: '*xpf-codetalk-override' stamp: 'topa 2/13/2009 13:48'!
textMorphClass
	"Answer the class used to create the receiver's textMorph"
	^XpfTextMorph! !

!RunArray class methodsFor: '*xpf-codetalk-override' stamp: 'mt 4/30/2009 11:37'!
scanFrom: strm
	"Read the style section of a fileOut or sources file.  nextChunk has already been done.  We need to return a RunArray of TextAttributes of various kinds.  These are written by the implementors of writeScanOn:"
	| rr vv aa this |
	(strm peekFor: $( ) ifFalse: [^ nil].
	rr := OrderedCollection new.
	[strm skipSeparators.
	 strm peekFor: $)] whileFalse: 
		[rr add: (Number readFrom: strm)].
	vv := OrderedCollection new.	"Value array"
	aa := OrderedCollection new.	"Attributes list"
	[(this := strm next) == nil] whileFalse: [
		this == $, ifTrue: [vv add: aa asArray.  aa := OrderedCollection new].
		this == $a ifTrue: [aa add: 
			(TextAlignment new alignment: (Integer readFrom: strm))].
		this == $f ifTrue: [aa add: 
			(TextFontChange new fontNumber: (Integer readFrom: strm))].
		this == $F ifTrue: [aa add: (TextFontReference toFont: 
			(StrikeFont familyName: (strm upTo: $#) size: (Integer readFrom: strm)))].
		this == $b ifTrue: [aa add: (TextEmphasis bold)].
		this == $i ifTrue: [aa add: (TextEmphasis italic)].
		this == $u ifTrue: [aa add: (TextEmphasis underlined)].
		this == $= ifTrue: [aa add: (TextEmphasis struckOut)].
		this == $n ifTrue: [aa add: (TextEmphasis normal)].
		this == $- ifTrue: [aa add: (TextKern kern: -1)].
		this == $+ ifTrue: [aa add: (TextKern kern: 1)].
		this == $c ifTrue: [aa add: (TextColor scanFrom: strm)]. "color"
		this == $h ifTrue: [aa add: (XpfComplexAttribute scanFrom: strm)]. "background color - CodeTalk"
		this == $L ifTrue: [aa add: (TextLink scanFrom: strm)].	"L not look like 1"
		this == $R ifTrue: [aa add: (TextURL scanFrom: strm)].
				"R capitalized so it can follow a number"
		this == $q ifTrue: [aa add: (TextSqkPageLink scanFrom: strm)].
		this == $p ifTrue: [aa add: (TextSqkProjectLink scanFrom: strm)].
		this == $P ifTrue: [aa add: (TextPrintIt scanFrom: strm)].
		this == $d ifTrue: [aa add: (TextDoIt scanFrom: strm)].
		"space, cr do nothing"
		].
	aa size > 0 ifTrue: [vv add: aa asArray].
	^ self runs: rr asArray values: vv asArray
"
RunArray scanFrom: (ReadStream on: '(14 50 312)f1,f1b,f1LInteger +;i')
"! !

!MCMethodDefinition class methodsFor: '*xpf-codetalk-override' stamp: 'mt 4/20/2009 15:54'!
forMethodReference: aMethodReference
	"CodeTalk: Get the markup from the method reference and put it into the definition."

	| definition |
	definition := self cachedDefinitions at: aMethodReference compiledMethod ifAbsent: [].
	(definition isNil
		or: [definition selector ~= aMethodReference methodSymbol]
		or: [definition className ~= aMethodReference classSymbol]
		or: [definition classIsMeta ~= aMethodReference classIsMeta]
		or: [definition category ~= aMethodReference category])
			ifTrue: [definition := (self 
						className: aMethodReference classSymbol
						classIsMeta: aMethodReference classIsMeta
						selector: aMethodReference methodSymbol
						category: aMethodReference category
						timeStamp: aMethodReference timeStamp
						source: aMethodReference source)
						sourceText: aMethodReference sourceCode.
					self cachedDefinitions at: aMethodReference compiledMethod put: definition].
	^ definition
	! !

!MCMethodDefinition methodsFor: '*xpf-codetalk-override' stamp: 'cs 4/17/2009 18:23'!
addMethodAdditionTo: aCollection
	| methodAddition |
	methodAddition := MethodAddition new
		compile: self sourceText
		classified: category
		withStamp: timeStamp
		notifying: (SyntaxError new category: category)
		logSource: true
		inClass: self actualClass.
	"This might raise an exception and never return"
	methodAddition createCompiledMethod.
	aCollection add: methodAddition.
! !

!MCMethodDefinition methodsFor: '*xpf-codetalk-override' stamp: 'cs 4/17/2009 18:24'!
load
	self actualClass
		compile: self sourceText
		classified: category
		withStamp: timeStamp
		notifying: (SyntaxError new category: category)! !

!MCMethodDefinition methodsFor: '*xpf-codetalk' stamp: 'cs 4/20/2009 16:16'!
sourceText

	^ sourceText ifNil: [self source asText]! !

!MCMethodDefinition methodsFor: '*xpf-codetalk' stamp: 'mt 3/24/2009 15:52'!
sourceText: aText

	sourceText := aText.! !

MultiNewParagraph subclass: #XpfParagraph
	instanceVariableNames: 'textMorph showLineNumbers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Kernel'!

!XpfParagraph methodsFor: 'displaying' stamp: 'mt 5/3/2009 19:36'!
addAttributeMorphs
	"Add the small iconmorphs that appear for some attributes in the text."
	
	| morphs |
	selectionStart isNil | self textMorph isNil
		ifTrue: [^ self].

	morphs := (self text
		attributesOfKind: XpfComplexAttribute 
		from: selectionStart stringIndex
		to: ((selectionStop stringIndex - 1) max: selectionStart stringIndex))
		collect: [:attr | self textMorph addMorph: attr morph. attr morph].
	self textMorph removeAllMorphsBut: morphs.! !

!XpfParagraph methodsFor: 'editing' stamp: 'mt 5/18/2009 11:12'!
changeTagInSelectionTo: aSymbol
	"Used to change the tag (#bad, #talk) )of an attribute in the text."

	| attrs |
	attrs := self text
		attributesOfKind: XpfComplexAttribute
		from: selectionStart stringIndex
		to: selectionStop stringIndex - 1.
		
	attrs ifEmpty: [^ false].
	attrs
		do: [:attr | attr tag: aSymbol].

	^ true! !

!XpfParagraph methodsFor: 'displaying' stamp: 'mt 5/3/2009 19:23'!
displayOn: aCanvas using: displayScanner at: somePosition

	self
		updateProperties;
		addAttributeMorphs;
		updateAttributeMorphs;
		drawLineNumberBorderOn: aCanvas.
	
	(self lineIndexForPoint: aCanvas clipRect topLeft)
		to: (self lineIndexForPoint: aCanvas clipRect bottomRight)
		do: [ :i | | line |
			line := lines at: i.
			self drawComplexAttributeOn: aCanvas at: i.
			self drawLineNumber: i on: aCanvas for: line].
	
	super displayOn: aCanvas using: displayScanner at: somePosition.! !

!XpfParagraph methodsFor: 'displaying' stamp: 'mt 5/3/2009 11:12'!
drawComplexAttributeOn: aCanvas at: index 

	| textLine line nextLine|
	line := lines at: index.
	nextLine := lines size > index ifTrue: [lines at: index + 1] ifFalse: [].
	textLine := self text 
		copyFrom: line first
		to: line last.
	textLine runs withStartStopAndValueDo: [:start :stop :attributes |
		(attributes 
			detect: [:attr | attr isKindOf: XpfComplexAttribute]
			ifNone: [])
			ifNotNilDo: [:cAttr | | cb1 cb2 |
				cb1 := self characterBlockForIndex: start + (line first - 1).
				cb2 := self characterBlockForIndex: stop + (line first - 1).
	
				"Highlight the attribute."
				cAttr
					displayOn: aCanvas
					in: (cb1 left @ line top corner: cb2 right @ line bottom).

				"Update position of the morph from the attribute."
				(self isLastOccuranceOf: cAttr in: textLine position: stop for: index)
					ifTrue: [self
						moveAttributeMorph: cAttr morph
						to: cb2 right @ (line top - cAttr morph height)]]].! !

!XpfParagraph methodsFor: 'displaying' stamp: 'mt 5/1/2009 16:15'!
drawLineNumber: aNumber on: aCanvas for: line

	| str |
	showLineNumbers ifFalse: [^ self].
	self textMorph ifNil: [^ self].
	
	str := (aNumber < 10 ifTrue: [' '] ifFalse: ['']), aNumber asString.
	aCanvas
		drawString: str
		from: 1
		to: str size
		at: (self textMorph position x @ (line top + 2))
		font: Preferences standardCodeFont
		color: ((self isInSelectionFor: line)
			ifTrue: [Color black]
			ifFalse: [Color gray]).! !

!XpfParagraph methodsFor: 'displaying' stamp: 'mt 5/1/2009 16:12'!
drawLineNumberBorderOn: aCanvas

	| fontWidth |
	showLineNumbers ifFalse: [^ self].
	self textMorph ifNil: [^ self].
	
	fontWidth := Preferences standardCodeFont widthOfString: '99'.
	aCanvas
		line: (self textMorph position x + fontWidth + 3) @ aCanvas clipRect top
		to: (self textMorph position x + fontWidth + 3) @ aCanvas clipRect bottom
		width: 1
		color: Color gray.! !

!XpfParagraph methodsFor: 'testing' stamp: 'mt 5/1/2009 13:39'!
isInSelectionFor: line

	(selectionStart isNil or: [selectionStop isNil])
		ifTrue: [^ false].
		
	^ line last >= selectionStart textLine first
		and: [line first <= selectionStop textLine last]! !

!XpfParagraph methodsFor: 'testing' stamp: 'mt 5/1/2009 15:31'!
isLastOccuranceOf: cAttr in: textLine position: endOfRunIndex for: lineIndex
	"Answer true if the attribute does not appear in another run past the current one."

	| nextLine |
	nextLine := lines size > lineIndex ifTrue: [lines at: lineIndex + 1] ifFalse: [].
	^ ((nextLine isNil
		or: [((self text attributesAt: nextLine first) noneSatisfy: [:att | att == cAttr])])
		and: [textLine runs size < (endOfRunIndex + 1) 
			or: [(textLine attributesAt: endOfRunIndex + 1)	noneSatisfy: [:att | att == cAttr]]])! !

!XpfParagraph methodsFor: 'displaying' stamp: 'mt 5/3/2009 13:53'!
moveAttributeMorph: aMorph to: aPosition
	"Used to display small morphs to interaction with the markup. Pay attention to the extent of the textMorph if possible."
	
	| pos |
	pos := aPosition.
	self textMorph ifNotNilDo: [:t |
		pos := (t extent x - aMorph width min: aPosition x)
			@ (aPosition y < -5 ifTrue: [aMorph height max: aPosition y] ifFalse: [aPosition y])].
	aMorph position: pos.! !

!XpfParagraph methodsFor: 'editing' stamp: 'mt 5/3/2009 19:04'!
resizeTagInSelection
	"Used to grow or shrink the extent of an attribute in the text."

	| attrs |
	selectionStart = selectionStop ifTrue: [^ false].
	attrs := self text
		attributesOfKind: XpfComplexAttribute
		from: selectionStart stringIndex
		to: selectionStop stringIndex - 1.
	
	attrs size > 1
		ifTrue: [^ false. "Can only modify one attribute here."].
		
	self text
		removeAttribute: attrs first;
		addAttribute: attrs first
		from: selectionStart stringIndex
		to: selectionStop stringIndex - 1.
	^ true! !

!XpfParagraph methodsFor: 'editing' stamp: 'mt 5/3/2009 18:51'!
tagSelectionWith: aSymbol
	"Tag the selected code or text with the symbol."

	| attribute |
	selectionStart = selectionStop ifTrue: [^ false].
	attribute := XpfComplexAttribute forTag: aSymbol.
	attribute addDependent: self textMorph.
	self text
		addAttribute: attribute
		from: selectionStart stringIndex
		to: selectionStop stringIndex - 1.
	^ true! !

!XpfParagraph methodsFor: 'accessing' stamp: 'mt 4/22/2009 20:37'!
textMorph
	^ textMorph! !

!XpfParagraph methodsFor: 'accessing' stamp: 'mt 4/22/2009 20:37'!
textMorph: anObject
	textMorph := anObject! !

!XpfParagraph methodsFor: 'editing' stamp: 'mt 5/5/2009 15:02'!
untagSelection

	(self text
		attributesOfKind: XpfComplexAttribute
		from: selectionStart stringIndex
		to: selectionStop stringIndex) do: [:attr |
			self text
				removeAttribute: attr
				around: selectionStart stringIndex
				and: selectionStop stringIndex - 1].
	^ true! !

!XpfParagraph methodsFor: 'displaying' stamp: 'mt 5/18/2009 11:20'!
updateAttributeMorphs
	
	| attrs |
	selectionStart isNil | self textMorph isNil
		ifTrue: [^ self].
	
	attrs := self text
		attributesOfKind: XpfComplexAttribute 
		from: selectionStart stringIndex
		to: ((selectionStop stringIndex - 1) max: selectionStart stringIndex).

	(attrs size = 1) & (selectionStart ~= selectionStop)
		ifTrue: [attrs first resizeMorph visible: true]
		ifFalse: [attrs do: [:attr | attr resizeMorph visible: false]].! !

!XpfParagraph methodsFor: 'accessing' stamp: 'mt 5/1/2009 16:16'!
updateProperties

	showLineNumbers ifNil: [showLineNumbers := 
		(Preferences
			preferenceAt: #showLineNumbers
			ifAbsent: [Preference new rawValue: false])
			preferenceValue].! !

!OBCommand methodsFor: '*xpf-codetalk-override' stamp: 'mt 5/30/2009 17:51'!
buttonLabelWithSpaces
	"Overwrite to use icons in button label."
	
	| lm pref |
	pref := (Preferences
		preferenceAt: #useMoreIconsForCommands
		ifAbsent: [Preference new rawValue: false])
		preferenceValue.

	self icon isNil | pref not ifTrue: [^ ' {1} ' format: {self buttonLabel}]. "the classic way"
	
	(self iconOnly or: [self buttonLabel isNil or: [self buttonLabel isEmpty]])
		ifTrue: [^ (MenuIcons perform: self icon) asMorph].

	lm := PanelMorph new
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		fillStyle: Color transparent; "non pane color tracking"
		changeTableLayout;
		listDirection: #leftToRight;
		cellInset: 2.
		
	lm
		addMorphBack: (MenuIcons perform: self icon) asMorph;
		addMorphBack: self buttonLabel asMorph.

	^ lm! !

!OBCommand methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 15:23'!
iconOnly
	"Used to decide whether or not to use the label if an icon is present."

	^ false! !

OBCommand subclass: #XpfCtCmdBrowseMarkups
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Commands'!

!XpfCtCmdBrowseMarkups methodsFor: 'accessing' stamp: 'mt 5/30/2009 18:25'!
buttonLabel

	^ 'markups'! !

!XpfCtCmdBrowseMarkups methodsFor: 'execution' stamp: 'mt 5/30/2009 10:01'!
execute

	XpfCtMarkupBrowser openOn: target copy.! !

!XpfCtCmdBrowseMarkups methodsFor: 'accessing' stamp: 'mt 5/30/2009 09:27'!
group

	^ #codetalk! !

!XpfCtCmdBrowseMarkups methodsFor: 'accessing' stamp: 'mt 5/30/2009 15:19'!
icon

	^ #xpfCtCommentsIcon! !

!XpfCtCmdBrowseMarkups methodsFor: 'accessing' stamp: 'mt 5/30/2009 15:19'!
iconOnly

	^ true! !

!XpfCtCmdBrowseMarkups methodsFor: 'testing' stamp: 'mt 5/30/2009 18:25'!
isActive

	^ target hasMarkups and: [requestor isSelected: target]! !

!XpfCtCmdBrowseMarkups methodsFor: 'accessing' stamp: 'mt 5/30/2009 18:25'!
label

	^ 'browse markups'! !

!XpfCtCmdBrowseMarkups methodsFor: 'accessing' stamp: 'mt 5/30/2009 09:28'!
longDescription

	^ 'browse markups'! !

!XpfCtCmdBrowseMarkups methodsFor: 'testing' stamp: 'mt 5/30/2009 09:28'!
wantsButton

	^ true! !

OBCommand subclass: #XpfCtCmdBrowseRemoteMethodVersions
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Commands'!

!XpfCtCmdBrowseRemoteMethodVersions methodsFor: 'accessing' stamp: 'mt 5/30/2009 18:25'!
buttonLabel

	^ 'versions (mc)'! !

!XpfCtCmdBrowseRemoteMethodVersions methodsFor: 'execution' stamp: 'mt 5/19/2009 15:27'!
execute

	XpfCtRemoteVersionBrowser openOn: target copy.! !

!XpfCtCmdBrowseRemoteMethodVersions methodsFor: 'accessing' stamp: 'mt 5/30/2009 15:19'!
group

	^ #codetalk! !

!XpfCtCmdBrowseRemoteMethodVersions methodsFor: 'accessing' stamp: 'mt 5/30/2009 15:18'!
icon

	^ #xpfCtWorldIcon! !

!XpfCtCmdBrowseRemoteMethodVersions methodsFor: 'accessing' stamp: 'mt 5/30/2009 15:18'!
iconOnly

	^ true! !

!XpfCtCmdBrowseRemoteMethodVersions methodsFor: 'testing' stamp: 'mt 5/27/2009 14:50'!
isActive

	^ target hasVersions and: [requestor isSelected: target]! !

!XpfCtCmdBrowseRemoteMethodVersions methodsFor: 'accessing' stamp: 'mt 5/30/2009 18:26'!
label

	^ 'browse monticello versions'! !

!XpfCtCmdBrowseRemoteMethodVersions methodsFor: 'accessing' stamp: 'mt 5/27/2009 10:35'!
longDescription

  ^ 'display the different remote versions of this method - use repository of working copy'! !

!XpfCtCmdBrowseRemoteMethodVersions methodsFor: 'testing' stamp: 'mt 5/18/2009 13:16'!
wantsButton

	^ true! !

OBCommand subclass: #XpfCtEditCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Commands'!

XpfCtEditCommand subclass: #XpfCtCmdAddComment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Commands'!

!XpfCtCmdAddComment methodsFor: 'accessing' stamp: 'mt 5/28/2009 19:49'!
group

	^ '2'! !

!XpfCtCmdAddComment methodsFor: 'accessing' stamp: 'mt 5/28/2009 19:58'!
icon

	^ #xpfCtAddCommentIcon! !

!XpfCtCmdAddComment methodsFor: 'accessing' stamp: 'mt 5/28/2009 19:50'!
label

	^ 'add comment'! !

!XpfCtCmdAddComment methodsFor: 'execution' stamp: 'mt 5/28/2009 19:51'!
mark: aTarget in: anEditor

	^ anEditor addComment: aTarget! !

XpfCtEditCommand subclass: #XpfCtCmdChangeTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Commands'!

!XpfCtCmdChangeTag methodsFor: 'as yet unclassified' stamp: 'mt 5/28/2009 19:49'!
group

	^ '3'! !

!XpfCtCmdChangeTag methodsFor: 'as yet unclassified' stamp: 'mt 5/18/2009 11:05'!
isEnabled

	^ target fullText
		includesAttributesOfKind: XpfComplexAttribute
		from: target start
		to: (target stop max: target start)! !

!XpfCtCmdChangeTag methodsFor: 'as yet unclassified' stamp: 'mt 5/18/2009 10:55'!
label

	^ 'change tag'! !

!XpfCtCmdChangeTag methodsFor: 'as yet unclassified' stamp: 'mt 5/18/2009 10:55'!
mark: aTarget in: anEditor

	^ anEditor changeMarkupTag.! !

XpfCtEditCommand subclass: #XpfCtCmdJustTalk
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Commands'!

!XpfCtCmdJustTalk methodsFor: 'accessing' stamp: 'mt 5/2/2009 19:20'!
group

	^ '1'! !

!XpfCtCmdJustTalk methodsFor: 'accessing' stamp: 'mt 5/5/2009 15:01'!
icon

	^ #xpfCtMarkCommentIcon! !

!XpfCtCmdJustTalk methodsFor: 'accessing' stamp: 'mt 5/5/2009 15:38'!
keystroke

	^ $t! !

!XpfCtCmdJustTalk methodsFor: 'accessing' stamp: 'mt 5/5/2009 21:47'!
label

	^ 'add code chat'! !

!XpfCtCmdJustTalk methodsFor: 'execution' stamp: 'mt 5/2/2009 09:37'!
mark: aTarget in: anEditor

	^ anEditor justTalk: aTarget! !

XpfCtEditCommand subclass: #XpfCtCmdMarkBad
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Commands'!

!XpfCtCmdMarkBad methodsFor: 'accessing' stamp: 'mt 5/5/2009 15:00'!
group

	^ '1'! !

!XpfCtCmdMarkBad methodsFor: 'accessing' stamp: 'mt 5/5/2009 15:01'!
icon

	^ #xpfCtMarkBadIcon! !

!XpfCtCmdMarkBad methodsFor: 'accessing' stamp: 'mt 5/5/2009 15:38'!
keystroke

	^ $r! !

!XpfCtCmdMarkBad methodsFor: 'accessing' stamp: 'mfp 2/3/2009 16:11'!
label
	^ 'mark bad'! !

!XpfCtCmdMarkBad methodsFor: 'editor-bridge' stamp: 'mt 5/1/2009 16:00'!
mark: aTarget in: anEditor

	^ anEditor markAsBad: aTarget.! !

XpfCtEditCommand subclass: #XpfCtCmdRemoveMarkup
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Commands'!

!XpfCtCmdRemoveMarkup methodsFor: 'accessing' stamp: 'mt 5/28/2009 19:49'!
group

	^ '3'! !

!XpfCtCmdRemoveMarkup methodsFor: 'accessing' stamp: 'mt 5/2/2009 19:23'!
icon

	^ #xpfCtDeleteIcon! !

!XpfCtCmdRemoveMarkup methodsFor: 'testing' stamp: 'mt 5/3/2009 18:44'!
isEnabled

	^ target fullText
		includesAttributesOfKind: XpfComplexAttribute
		from: target start
		to: (target stop max: target start)! !

!XpfCtCmdRemoveMarkup methodsFor: 'accessing' stamp: 'mt 5/3/2009 19:06'!
label

	^'remove markup'! !

!XpfCtCmdRemoveMarkup methodsFor: 'execution' stamp: 'mt 5/1/2009 16:00'!
mark: aTarget in: anEditor
	
	anEditor removeMarkup: aTarget.
	^ true! !

XpfCtEditCommand subclass: #XpfCtCmdResize
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeTalk-Commands'!

!XpfCtCmdResize methodsFor: 'accessing' stamp: 'mt 5/28/2009 19:49'!
group

	^ '3'! !

!XpfCtCmdResize methodsFor: 'testing' stamp: 'mt 5/3/2009 19:17'!
icon

	^ #xpfCtPaintcanIcon! !

!XpfCtCmdResize methodsFor: 'testing' stamp: 'mt 5/18/2009 11:20'!
isEnabled

	^ target start <= target stop
		and: [(target fullText
			attributesOfKind: XpfComplexAttribute
			from: target start
			to: target stop) size = 1]! !

!XpfCtCmdResize methodsFor: 'accessing' stamp: 'mt 5/3/2009 19:06'!
label

	^'resize markup'! !

!XpfCtCmdResize methodsFor: 'execution' stamp: 'mt 5/3/2009 19:07'!
mark: aTarget in: anEditor
	
	anEditor resizeMarkup: aTarget.
	^ true! !

!XpfCtEditCommand class methodsFor: 'testing' stamp: 'cs 5/2/2009 13:30'!
takesText

	^ true! !

!XpfCtEditCommand methodsFor: 'accessing' stamp: 'cs 5/2/2009 13:31'!
cluster

	^ #CodeTalk! !

!XpfCtEditCommand methodsFor: 'execution' stamp: 'cs 5/2/2009 13:32'!
execute
	"'inspired' by ORCmdPrettyPrint>>execute"

	| panel morph editor |	
	panel := requestor browser panels 
		detect: [ :each | each isKindOf: OBDefinitionPanel ]
		ifNone: [ ^ self ].
	morph := OBPluggableTextMorph allSubInstances
		detect: [ :each | each model == panel ]
		ifNone: [ ^ self ].
	editor := morph textMorph editor.
	morph hasUnacceptedEdits: (self mark: target in: editor).! !

!XpfCtEditCommand methodsFor: 'testing' stamp: 'mt 5/2/2009 09:59'!
isActive

	^ target isKindOf: OBTextSelection! !

!XpfCtEditCommand methodsFor: 'testing' stamp: 'mt 5/3/2009 18:53'!
isEnabled

	^ target stop >= target start
		and: [(target fullText
			includesAttributesOfKind: XpfComplexAttribute
			from: target start
			to: target stop) not]! !

!XpfCtEditCommand methodsFor: 'execution' stamp: 'cs 5/2/2009 13:32'!
mark: aTarget in: anEditor

	^ self subclassResponsibility! !

!OBPackageBrowser class methodsFor: '*xpf-codetalk-override' stamp: 'mt 5/30/2009 19:53'!
panels
	^ {
		self topPanel.
		self navigationPanel.
		self annotationPanel.
		self toolbarPanel.
		self definitionPanel} reject: [:ea | ea isNil]! !

!OBPackageBrowser class methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 19:53'!
toolbarPanel

	^ (Preferences
		preferenceAt: #showCodeTalkToolbar
		ifAbsent: [Preference new rawValue: false])
		preferenceValue
			ifTrue: [XpfCtToolbar new]
			ifFalse: []! !

!OBButtonBar methodsFor: '*xpf-codetalk' stamp: 'mt 5/30/2009 16:32'!
addButtons

	| lastGroup |
	model commands
		select: [:cmd | cmd isActive]
		thenDo: [:cmd |
			(lastGroup notNil and: [lastGroup ~= cmd group])
				ifTrue: [self addMorphBack: (PanelMorph new
						hResizing: #rigid;
						vResizing: #rigid;
						extent: 5@1;
						fillStyle: Color transparent)].
			self addButtonFor: cmd.
			lastGroup := cmd group].! !

!OBButtonBar methodsFor: '*xpf-codetalk-override' stamp: 'mt 5/30/2009 16:20'!
adoptPaneColor: aColor
	self submorphs do: [:ea |
		(ea isKindOf: PluggableButtonMorphPlus)
			ifTrue: [ea onColor: aColor offColor: aColor whiter]].
	super adoptPaneColor: aColor.! !

!OBButtonBar methodsFor: '*xpf-codetalk-override' stamp: 'mt 5/30/2009 16:23'!
updateCommands
	
	self
		removeAllMorphs;
		addButtons.! !
XpfCodeTalk initialize!
